funcs = [('/', 'get', 'meta/root', 'GitHub API Root', 'rest/meta/meta#github-api-root', [], [], ''),
 ('/advisories',
  'get',
  'security-advisories/list-global-advisories',
  'List global security advisories',
  'rest/security-advisories/global-advisories#list-global-security-advisories',
  ['ghsa_id', 'type', 'cve_id', 'ecosystem', 'severity', 'cwes', 'is_withdrawn', 'affects', 'published', 'updated', 'modified', 'before', 'after', 'direction', 'per_page', 'sort'],
  [],
  ''),
 ('/advisories/{ghsa_id}', 'get', 'security-advisories/get-global-advisory', 'Get a global security advisory', 'rest/security-advisories/global-advisories#get-a-global-security-advisory', [], [], ''),
 ('/app', 'get', 'apps/get-authenticated', 'Get the authenticated app', 'rest/apps/apps#get-the-authenticated-app', [], [], ''),
 ('/app-manifests/{code}/conversions', 'post', 'apps/create-from-manifest', 'Create a GitHub App from a manifest', 'rest/apps/apps#create-a-github-app-from-a-manifest', [], [], ''),
 ('/app/hook/config', 'get', 'apps/get-webhook-config-for-app', 'Get a webhook configuration for an app', 'rest/apps/webhooks#get-a-webhook-configuration-for-an-app', [], [], ''),
 ('/app/hook/config', 'patch', 'apps/update-webhook-config-for-app', 'Update a webhook configuration for an app', 'rest/apps/webhooks#update-a-webhook-configuration-for-an-app', [], [['url', str], ['content_type', str], ['secret', str], ['insecure_ssl', object]], ''),
 ('/app/hook/deliveries', 'get', 'apps/list-webhook-deliveries', 'List deliveries for an app webhook', 'rest/apps/webhooks#list-deliveries-for-an-app-webhook', ['per_page', 'cursor', 'redelivery'], [], ''),
 ('/app/hook/deliveries/{delivery_id}', 'get', 'apps/get-webhook-delivery', 'Get a delivery for an app webhook', 'rest/apps/webhooks#get-a-delivery-for-an-app-webhook', [], [], ''),
 ('/app/hook/deliveries/{delivery_id}/attempts', 'post', 'apps/redeliver-webhook-delivery', 'Redeliver a delivery for an app webhook', 'rest/apps/webhooks#redeliver-a-delivery-for-an-app-webhook', [], [], ''),
 ('/app/installation-requests', 'get', 'apps/list-installation-requests-for-authenticated-app', 'List installation requests for the authenticated app', 'rest/apps/apps#list-installation-requests-for-the-authenticated-app', ['per_page', 'page'], [], ''),
 ('/app/installations', 'get', 'apps/list-installations', 'List installations for the authenticated app', 'rest/apps/apps#list-installations-for-the-authenticated-app', ['per_page', 'page', 'since', 'outdated'], [], ''),
 ('/app/installations/{installation_id}', 'get', 'apps/get-installation', 'Get an installation for the authenticated app', 'rest/apps/apps#get-an-installation-for-the-authenticated-app', [], [], ''),
 ('/app/installations/{installation_id}', 'delete', 'apps/delete-installation', 'Delete an installation for the authenticated app', 'rest/apps/apps#delete-an-installation-for-the-authenticated-app', [], [], ''),
 ('/app/installations/{installation_id}/access_tokens', 'post', 'apps/create-installation-access-token', 'Create an installation access token for an app', 'rest/apps/apps#create-an-installation-access-token-for-an-app', [], [['repositories', list], ['repository_ids', list], ['permissions', dict]], ''),
 ('/app/installations/{installation_id}/suspended', 'put', 'apps/suspend-installation', 'Suspend an app installation', 'rest/apps/apps#suspend-an-app-installation', [], [], ''),
 ('/app/installations/{installation_id}/suspended', 'delete', 'apps/unsuspend-installation', 'Unsuspend an app installation', 'rest/apps/apps#unsuspend-an-app-installation', [], [], ''),
 ('/applications/{client_id}/grant', 'delete', 'apps/delete-authorization', 'Delete an app authorization', 'rest/apps/oauth-applications#delete-an-app-authorization', [], [['access_token', str]], ''),
 ('/applications/{client_id}/token', 'post', 'apps/check-token', 'Check a token', 'rest/apps/oauth-applications#check-a-token', [], [['access_token', str]], ''),
 ('/applications/{client_id}/token', 'patch', 'apps/reset-token', 'Reset a token', 'rest/apps/oauth-applications#reset-a-token', [], [['access_token', str]], ''),
 ('/applications/{client_id}/token', 'delete', 'apps/delete-token', 'Delete an app token', 'rest/apps/oauth-applications#delete-an-app-token', [], [['access_token', str]], ''),
 ('/applications/{client_id}/token/scoped', 'post', 'apps/scope-token', 'Create a scoped access token', 'rest/apps/apps#create-a-scoped-access-token', [], [['access_token', str], ['target', str], ['target_id', int], ['repositories', list], ['repository_ids', list], ['permissions', dict]], ''),
 ('/apps/{app_slug}', 'get', 'apps/get-by-slug', 'Get an app', 'rest/apps/apps#get-an-app', [], [], ''),
 ('/assignments/{assignment_id}', 'get', 'classroom/get-an-assignment', 'Get an assignment', 'rest/classroom/classroom#get-an-assignment', [], [], ''),
 ('/assignments/{assignment_id}/accepted_assignments', 'get', 'classroom/list-accepted-assigments-for-an-assignment', 'List accepted assignments for an assignment', 'rest/classroom/classroom#list-accepted-assignments-for-an-assignment', ['page', 'per_page'], [], ''),
 ('/assignments/{assignment_id}/grades', 'get', 'classroom/get-assignment-grades', 'Get assignment grades', 'rest/classroom/classroom#get-assignment-grades', [], [], ''),
 ('/classrooms', 'get', 'classroom/list-classrooms', 'List classrooms', 'rest/classroom/classroom#list-classrooms', ['page', 'per_page'], [], ''),
 ('/classrooms/{classroom_id}', 'get', 'classroom/get-a-classroom', 'Get a classroom', 'rest/classroom/classroom#get-a-classroom', [], [], ''),
 ('/classrooms/{classroom_id}/assignments', 'get', 'classroom/list-assignments-for-a-classroom', 'List assignments for a classroom', 'rest/classroom/classroom#list-assignments-for-a-classroom', ['page', 'per_page'], [], ''),
 ('/codes_of_conduct', 'get', 'codes-of-conduct/get-all-codes-of-conduct', 'Get all codes of conduct', 'rest/codes-of-conduct/codes-of-conduct#get-all-codes-of-conduct', [], [], ''),
 ('/codes_of_conduct/{key}', 'get', 'codes-of-conduct/get-conduct-code', 'Get a code of conduct', 'rest/codes-of-conduct/codes-of-conduct#get-a-code-of-conduct', [], [], ''),
 ('/emojis', 'get', 'emojis/get', 'Get emojis', 'rest/emojis/emojis#get-emojis', [], [], ''),
 ('/enterprises/{enterprise}/dependabot/alerts', 'get', 'dependabot/list-alerts-for-enterprise', 'List Dependabot alerts for an enterprise', 'rest/dependabot/alerts#list-dependabot-alerts-for-an-enterprise', ['state', 'severity', 'ecosystem', 'package', 'scope', 'sort', 'direction', 'before', 'after', 'first', 'last', 'per_page'], [], ''),
 ('/enterprises/{enterprise}/secret-scanning/alerts', 'get', 'secret-scanning/list-alerts-for-enterprise', 'List secret scanning alerts for an enterprise', 'rest/secret-scanning/secret-scanning#list-secret-scanning-alerts-for-an-enterprise', ['state', 'secret_type', 'resolution', 'sort', 'direction', 'per_page', 'before', 'after', 'validity'], [], ''),
 ('/events', 'get', 'activity/list-public-events', 'List public events', 'rest/activity/events#list-public-events', ['per_page', 'page'], [], ''),
 ('/feeds', 'get', 'activity/get-feeds', 'Get feeds', 'rest/activity/feeds#get-feeds', [], [], ''),
 ('/gists', 'get', 'gists/list', 'List gists for the authenticated user', 'rest/gists/gists#list-gists-for-the-authenticated-user', ['since', 'per_page', 'page'], [], ''),
 ('/gists', 'post', 'gists/create', 'Create a gist', 'rest/gists/gists#create-a-gist', [], [['description', str], ['files', dict], ['public', object]], ''),
 ('/gists/public', 'get', 'gists/list-public', 'List public gists', 'rest/gists/gists#list-public-gists', ['since', 'per_page', 'page'], [], ''),
 ('/gists/starred', 'get', 'gists/list-starred', 'List starred gists', 'rest/gists/gists#list-starred-gists', ['since', 'per_page', 'page'], [], ''),
 ('/gists/{gist_id}', 'get', 'gists/get', 'Get a gist', 'rest/gists/gists#get-a-gist', [], [], ''),
 ('/gists/{gist_id}', 'patch', 'gists/update', 'Update a gist', 'rest/gists/gists#update-a-gist', [], [['description', str], ['files', dict]], ''),
 ('/gists/{gist_id}', 'delete', 'gists/delete', 'Delete a gist', 'rest/gists/gists#delete-a-gist', [], [], ''),
 ('/gists/{gist_id}/comments', 'get', 'gists/list-comments', 'List gist comments', 'rest/gists/comments#list-gist-comments', ['per_page', 'page'], [], ''),
 ('/gists/{gist_id}/comments', 'post', 'gists/create-comment', 'Create a gist comment', 'rest/gists/comments#create-a-gist-comment', [], [['body', str]], ''),
 ('/gists/{gist_id}/comments/{comment_id}', 'get', 'gists/get-comment', 'Get a gist comment', 'rest/gists/comments#get-a-gist-comment', [], [], ''),
 ('/gists/{gist_id}/comments/{comment_id}', 'patch', 'gists/update-comment', 'Update a gist comment', 'rest/gists/comments#update-a-gist-comment', [], [['body', str]], ''),
 ('/gists/{gist_id}/comments/{comment_id}', 'delete', 'gists/delete-comment', 'Delete a gist comment', 'rest/gists/comments#delete-a-gist-comment', [], [], ''),
 ('/gists/{gist_id}/commits', 'get', 'gists/list-commits', 'List gist commits', 'rest/gists/gists#list-gist-commits', ['per_page', 'page'], [], ''),
 ('/gists/{gist_id}/forks', 'get', 'gists/list-forks', 'List gist forks', 'rest/gists/gists#list-gist-forks', ['per_page', 'page'], [], ''),
 ('/gists/{gist_id}/forks', 'post', 'gists/fork', 'Fork a gist', 'rest/gists/gists#fork-a-gist', [], [], ''),
 ('/gists/{gist_id}/star', 'get', 'gists/check-is-starred', 'Check if a gist is starred', 'rest/gists/gists#check-if-a-gist-is-starred', [], [], ''),
 ('/gists/{gist_id}/star', 'put', 'gists/star', 'Star a gist', 'rest/gists/gists#star-a-gist', [], [], ''),
 ('/gists/{gist_id}/star', 'delete', 'gists/unstar', 'Unstar a gist', 'rest/gists/gists#unstar-a-gist', [], [], ''),
 ('/gists/{gist_id}/{sha}', 'get', 'gists/get-revision', 'Get a gist revision', 'rest/gists/gists#get-a-gist-revision', [], [], ''),
 ('/gitignore/templates', 'get', 'gitignore/get-all-templates', 'Get all gitignore templates', 'rest/gitignore/gitignore#get-all-gitignore-templates', [], [], ''),
 ('/gitignore/templates/{name}', 'get', 'gitignore/get-template', 'Get a gitignore template', 'rest/gitignore/gitignore#get-a-gitignore-template', [], [], ''),
 ('/installation/repositories', 'get', 'apps/list-repos-accessible-to-installation', 'List repositories accessible to the app installation', 'rest/apps/installations#list-repositories-accessible-to-the-app-installation', ['per_page', 'page'], [], ''),
 ('/installation/token', 'delete', 'apps/revoke-installation-access-token', 'Revoke an installation access token', 'rest/apps/installations#revoke-an-installation-access-token', [], [], ''),
 ('/issues', 'get', 'issues/list', 'List issues assigned to the authenticated user', 'rest/issues/issues#list-issues-assigned-to-the-authenticated-user', ['filter', 'state', 'labels', 'sort', 'direction', 'since', 'collab', 'orgs', 'owned', 'pulls', 'per_page', 'page'], [], ''),
 ('/licenses', 'get', 'licenses/get-all-commonly-used', 'Get all commonly used licenses', 'rest/licenses/licenses#get-all-commonly-used-licenses', ['featured', 'per_page', 'page'], [], ''),
 ('/licenses/{license}', 'get', 'licenses/get', 'Get a license', 'rest/licenses/licenses#get-a-license', [], [], ''),
 ('/markdown', 'post', 'markdown/render', 'Render a Markdown document', 'rest/markdown/markdown#render-a-markdown-document', [], [['text', str], ['mode', str, 'markdown'], ['context', str]], ''),
 ('/markdown/raw', 'post', 'markdown/render-raw', 'Render a Markdown document in raw mode', 'rest/markdown/markdown#render-a-markdown-document-in-raw-mode', [], [], ''),
 ('/marketplace_listing/accounts/{account_id}', 'get', 'apps/get-subscription-plan-for-account', 'Get a subscription plan for an account', 'rest/apps/marketplace#get-a-subscription-plan-for-an-account', [], [], ''),
 ('/marketplace_listing/plans', 'get', 'apps/list-plans', 'List plans', 'rest/apps/marketplace#list-plans', ['per_page', 'page'], [], ''),
 ('/marketplace_listing/plans/{plan_id}/accounts', 'get', 'apps/list-accounts-for-plan', 'List accounts for a plan', 'rest/apps/marketplace#list-accounts-for-a-plan', ['sort', 'direction', 'per_page', 'page'], [], ''),
 ('/marketplace_listing/stubbed/accounts/{account_id}', 'get', 'apps/get-subscription-plan-for-account-stubbed', 'Get a subscription plan for an account (stubbed)', 'rest/apps/marketplace#get-a-subscription-plan-for-an-account-stubbed', [], [], ''),
 ('/marketplace_listing/stubbed/plans', 'get', 'apps/list-plans-stubbed', 'List plans (stubbed)', 'rest/apps/marketplace#list-plans-stubbed', ['per_page', 'page'], [], ''),
 ('/marketplace_listing/stubbed/plans/{plan_id}/accounts', 'get', 'apps/list-accounts-for-plan-stubbed', 'List accounts for a plan (stubbed)', 'rest/apps/marketplace#list-accounts-for-a-plan-stubbed', ['sort', 'direction', 'per_page', 'page'], [], ''),
 ('/meta', 'get', 'meta/get', 'Get GitHub meta information', 'rest/meta/meta#get-apiname-meta-information', [], [], ''),
 ('/networks/{owner}/{repo}/events', 'get', 'activity/list-public-events-for-repo-network', 'List public events for a network of repositories', 'rest/activity/events#list-public-events-for-a-network-of-repositories', ['per_page', 'page'], [], ''),
 ('/notifications', 'get', 'activity/list-notifications-for-authenticated-user', 'List notifications for the authenticated user', 'rest/activity/notifications#list-notifications-for-the-authenticated-user', ['all', 'participating', 'since', 'before', 'page', 'per_page'], [], ''),
 ('/notifications', 'put', 'activity/mark-notifications-as-read', 'Mark notifications as read', 'rest/activity/notifications#mark-notifications-as-read', [], [['last_read_at', str], ['read', bool]], ''),
 ('/notifications/threads/{thread_id}', 'get', 'activity/get-thread', 'Get a thread', 'rest/activity/notifications#get-a-thread', [], [], ''),
 ('/notifications/threads/{thread_id}', 'patch', 'activity/mark-thread-as-read', 'Mark a thread as read', 'rest/activity/notifications#mark-a-thread-as-read', [], [], ''),
 ('/notifications/threads/{thread_id}', 'delete', 'activity/mark-thread-as-done', 'Mark a thread as done', 'rest/activity/notifications#mark-a-thread-as-done', [], [], ''),
 ('/notifications/threads/{thread_id}/subscription', 'get', 'activity/get-thread-subscription-for-authenticated-user', 'Get a thread subscription for the authenticated user', 'rest/activity/notifications#get-a-thread-subscription-for-the-authenticated-user', [], [], ''),
 ('/notifications/threads/{thread_id}/subscription', 'put', 'activity/set-thread-subscription', 'Set a thread subscription', 'rest/activity/notifications#set-a-thread-subscription', [], [['ignored', bool, False]], ''),
 ('/notifications/threads/{thread_id}/subscription', 'delete', 'activity/delete-thread-subscription', 'Delete a thread subscription', 'rest/activity/notifications#delete-a-thread-subscription', [], [], ''),
 ('/octocat', 'get', 'meta/get-octocat', 'Get Octocat', 'rest/meta/meta#get-octocat', ['s'], [], ''),
 ('/organizations', 'get', 'orgs/list', 'List organizations', 'rest/orgs/orgs#list-organizations', ['since', 'per_page'], [], ''),
 ('/orgs/{org}', 'get', 'orgs/get', 'Get an organization', 'rest/orgs/orgs#get-an-organization', [], [], ''),
 ('/orgs/{org}',
  'patch',
  'orgs/update',
  'Update an organization',
  'rest/orgs/orgs#update-an-organization',
  [],
  [['billing_email', str],
   ['company', str],
   ['email', str],
   ['twitter_username', str],
   ['location', str],
   ['name', str],
   ['description', str],
   ['has_organization_projects', bool],
   ['has_repository_projects', bool],
   ['default_repository_permission', str, 'read'],
   ['members_can_create_repositories', bool, True],
   ['members_can_create_internal_repositories', bool],
   ['members_can_create_private_repositories', bool],
   ['members_can_create_public_repositories', bool],
   ['members_allowed_repository_creation_type', str],
   ['members_can_create_pages', bool, True],
   ['members_can_create_public_pages', bool, True],
   ['members_can_create_private_pages', bool, True],
   ['members_can_fork_private_repositories', bool, False],
   ['web_commit_signoff_required', bool, False],
   ['blog', str],
   ['advanced_security_enabled_for_new_repositories', bool],
   ['dependabot_alerts_enabled_for_new_repositories', bool],
   ['dependabot_security_updates_enabled_for_new_repositories', bool],
   ['dependency_graph_enabled_for_new_repositories', bool],
   ['secret_scanning_enabled_for_new_repositories', bool],
   ['secret_scanning_push_protection_enabled_for_new_repositories', bool],
   ['secret_scanning_push_protection_custom_link_enabled', bool],
   ['secret_scanning_push_protection_custom_link', str]],
  ''),
 ('/orgs/{org}', 'delete', 'orgs/delete', 'Delete an organization', 'rest/orgs/orgs#delete-an-organization', [], [], ''),
 ('/orgs/{org}/actions/cache/usage', 'get', 'actions/get-actions-cache-usage-for-org', 'Get GitHub Actions cache usage for an organization', 'rest/actions/cache#get-github-actions-cache-usage-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/cache/usage-by-repository', 'get', 'actions/get-actions-cache-usage-by-repo-for-org', 'List repositories with GitHub Actions cache usage for an organization', 'rest/actions/cache#list-repositories-with-github-actions-cache-usage-for-an-organization', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/actions/oidc/customization/sub', 'get', 'oidc/get-oidc-custom-sub-template-for-org', 'Get the customization template for an OIDC subject claim for an organization', 'rest/actions/oidc#get-the-customization-template-for-an-oidc-subject-claim-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/oidc/customization/sub', 'put', 'oidc/update-oidc-custom-sub-template-for-org', 'Set the customization template for an OIDC subject claim for an organization', 'rest/actions/oidc#set-the-customization-template-for-an-oidc-subject-claim-for-an-organization', [], [['include_claim_keys', list]], ''),
 ('/orgs/{org}/actions/permissions', 'get', 'actions/get-github-actions-permissions-organization', 'Get GitHub Actions permissions for an organization', 'rest/actions/permissions#get-github-actions-permissions-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/permissions', 'put', 'actions/set-github-actions-permissions-organization', 'Set GitHub Actions permissions for an organization', 'rest/actions/permissions#set-github-actions-permissions-for-an-organization', [], [['enabled_repositories', str], ['allowed_actions', str]], ''),
 ('/orgs/{org}/actions/permissions/repositories', 'get', 'actions/list-selected-repositories-enabled-github-actions-organization', 'List selected repositories enabled for GitHub Actions in an organization', 'rest/actions/permissions#list-selected-repositories-enabled-for-github-actions-in-an-organization', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/actions/permissions/repositories', 'put', 'actions/set-selected-repositories-enabled-github-actions-organization', 'Set selected repositories enabled for GitHub Actions in an organization', 'rest/actions/permissions#set-selected-repositories-enabled-for-github-actions-in-an-organization', [], [['selected_repository_ids', list]], ''),
 ('/orgs/{org}/actions/permissions/repositories/{repository_id}', 'put', 'actions/enable-selected-repository-github-actions-organization', 'Enable a selected repository for GitHub Actions in an organization', 'rest/actions/permissions#enable-a-selected-repository-for-github-actions-in-an-organization', [], [], ''),
 ('/orgs/{org}/actions/permissions/repositories/{repository_id}', 'delete', 'actions/disable-selected-repository-github-actions-organization', 'Disable a selected repository for GitHub Actions in an organization', 'rest/actions/permissions#disable-a-selected-repository-for-github-actions-in-an-organization', [], [], ''),
 ('/orgs/{org}/actions/permissions/selected-actions', 'get', 'actions/get-allowed-actions-organization', 'Get allowed actions and reusable workflows for an organization', 'rest/actions/permissions#get-allowed-actions-and-reusable-workflows-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/permissions/selected-actions', 'put', 'actions/set-allowed-actions-organization', 'Set allowed actions and reusable workflows for an organization', 'rest/actions/permissions#set-allowed-actions-and-reusable-workflows-for-an-organization', [], [['github_owned_allowed', bool], ['verified_allowed', bool], ['patterns_allowed', list]], ''),
 ('/orgs/{org}/actions/permissions/workflow', 'get', 'actions/get-github-actions-default-workflow-permissions-organization', 'Get default workflow permissions for an organization', 'rest/actions/permissions#get-default-workflow-permissions-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/permissions/workflow', 'put', 'actions/set-github-actions-default-workflow-permissions-organization', 'Set default workflow permissions for an organization', 'rest/actions/permissions#set-default-workflow-permissions-for-an-organization', [], [['default_workflow_permissions', str], ['can_approve_pull_request_reviews', bool]], ''),
 ('/orgs/{org}/actions/runners', 'get', 'actions/list-self-hosted-runners-for-org', 'List self-hosted runners for an organization', 'rest/actions/self-hosted-runners#list-self-hosted-runners-for-an-organization', ['name', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/actions/runners/downloads', 'get', 'actions/list-runner-applications-for-org', 'List runner applications for an organization', 'rest/actions/self-hosted-runners#list-runner-applications-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/runners/generate-jitconfig',
  'post',
  'actions/generate-runner-jitconfig-for-org',
  'Create configuration for a just-in-time runner for an organization',
  'rest/actions/self-hosted-runners#create-configuration-for-a-just-in-time-runner-for-an-organization',
  [],
  [['name', str], ['runner_group_id', int], ['labels', list], ['work_folder', str, '_work']],
  ''),
 ('/orgs/{org}/actions/runners/registration-token', 'post', 'actions/create-registration-token-for-org', 'Create a registration token for an organization', 'rest/actions/self-hosted-runners#create-a-registration-token-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/runners/remove-token', 'post', 'actions/create-remove-token-for-org', 'Create a remove token for an organization', 'rest/actions/self-hosted-runners#create-a-remove-token-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/runners/{runner_id}', 'get', 'actions/get-self-hosted-runner-for-org', 'Get a self-hosted runner for an organization', 'rest/actions/self-hosted-runners#get-a-self-hosted-runner-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/runners/{runner_id}', 'delete', 'actions/delete-self-hosted-runner-from-org', 'Delete a self-hosted runner from an organization', 'rest/actions/self-hosted-runners#delete-a-self-hosted-runner-from-an-organization', [], [], ''),
 ('/orgs/{org}/actions/runners/{runner_id}/labels', 'get', 'actions/list-labels-for-self-hosted-runner-for-org', 'List labels for a self-hosted runner for an organization', 'rest/actions/self-hosted-runners#list-labels-for-a-self-hosted-runner-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/runners/{runner_id}/labels', 'post', 'actions/add-custom-labels-to-self-hosted-runner-for-org', 'Add custom labels to a self-hosted runner for an organization', 'rest/actions/self-hosted-runners#add-custom-labels-to-a-self-hosted-runner-for-an-organization', [], [['labels', list]], ''),
 ('/orgs/{org}/actions/runners/{runner_id}/labels', 'put', 'actions/set-custom-labels-for-self-hosted-runner-for-org', 'Set custom labels for a self-hosted runner for an organization', 'rest/actions/self-hosted-runners#set-custom-labels-for-a-self-hosted-runner-for-an-organization', [], [['labels', list]], ''),
 ('/orgs/{org}/actions/runners/{runner_id}/labels', 'delete', 'actions/remove-all-custom-labels-from-self-hosted-runner-for-org', 'Remove all custom labels from a self-hosted runner for an organization', 'rest/actions/self-hosted-runners#remove-all-custom-labels-from-a-self-hosted-runner-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/runners/{runner_id}/labels/{name}', 'delete', 'actions/remove-custom-label-from-self-hosted-runner-for-org', 'Remove a custom label from a self-hosted runner for an organization', 'rest/actions/self-hosted-runners#remove-a-custom-label-from-a-self-hosted-runner-for-an-organization', [], [], ''),
 ('/orgs/{org}/actions/secrets', 'get', 'actions/list-org-secrets', 'List organization secrets', 'rest/actions/secrets#list-organization-secrets', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/actions/secrets/public-key', 'get', 'actions/get-org-public-key', 'Get an organization public key', 'rest/actions/secrets#get-an-organization-public-key', [], [], ''),
 ('/orgs/{org}/actions/secrets/{secret_name}', 'get', 'actions/get-org-secret', 'Get an organization secret', 'rest/actions/secrets#get-an-organization-secret', [], [], ''),
 ('/orgs/{org}/actions/secrets/{secret_name}', 'put', 'actions/create-or-update-org-secret', 'Create or update an organization secret', 'rest/actions/secrets#create-or-update-an-organization-secret', [], [['encrypted_value', str], ['key_id', str], ['visibility', str], ['selected_repository_ids', list]], ''),
 ('/orgs/{org}/actions/secrets/{secret_name}', 'delete', 'actions/delete-org-secret', 'Delete an organization secret', 'rest/actions/secrets#delete-an-organization-secret', [], [], ''),
 ('/orgs/{org}/actions/secrets/{secret_name}/repositories', 'get', 'actions/list-selected-repos-for-org-secret', 'List selected repositories for an organization secret', 'rest/actions/secrets#list-selected-repositories-for-an-organization-secret', ['page', 'per_page'], [], ''),
 ('/orgs/{org}/actions/secrets/{secret_name}/repositories', 'put', 'actions/set-selected-repos-for-org-secret', 'Set selected repositories for an organization secret', 'rest/actions/secrets#set-selected-repositories-for-an-organization-secret', [], [['selected_repository_ids', list]], ''),
 ('/orgs/{org}/actions/secrets/{secret_name}/repositories/{repository_id}', 'put', 'actions/add-selected-repo-to-org-secret', 'Add selected repository to an organization secret', 'rest/actions/secrets#add-selected-repository-to-an-organization-secret', [], [], ''),
 ('/orgs/{org}/actions/secrets/{secret_name}/repositories/{repository_id}', 'delete', 'actions/remove-selected-repo-from-org-secret', 'Remove selected repository from an organization secret', 'rest/actions/secrets#remove-selected-repository-from-an-organization-secret', [], [], ''),
 ('/orgs/{org}/actions/variables', 'get', 'actions/list-org-variables', 'List organization variables', 'rest/actions/variables#list-organization-variables', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/actions/variables', 'post', 'actions/create-org-variable', 'Create an organization variable', 'rest/actions/variables#create-an-organization-variable', [], [['name', str], ['value', str], ['visibility', str], ['selected_repository_ids', list]], ''),
 ('/orgs/{org}/actions/variables/{name}', 'get', 'actions/get-org-variable', 'Get an organization variable', 'rest/actions/variables#get-an-organization-variable', [], [], ''),
 ('/orgs/{org}/actions/variables/{name}', 'patch', 'actions/update-org-variable', 'Update an organization variable', 'rest/actions/variables#update-an-organization-variable', [], [['name', str], ['value', str], ['visibility', str], ['selected_repository_ids', list]], ''),
 ('/orgs/{org}/actions/variables/{name}', 'delete', 'actions/delete-org-variable', 'Delete an organization variable', 'rest/actions/variables#delete-an-organization-variable', [], [], ''),
 ('/orgs/{org}/actions/variables/{name}/repositories', 'get', 'actions/list-selected-repos-for-org-variable', 'List selected repositories for an organization variable', 'rest/actions/variables#list-selected-repositories-for-an-organization-variable', ['page', 'per_page'], [], ''),
 ('/orgs/{org}/actions/variables/{name}/repositories', 'put', 'actions/set-selected-repos-for-org-variable', 'Set selected repositories for an organization variable', 'rest/actions/variables#set-selected-repositories-for-an-organization-variable', [], [['selected_repository_ids', list]], ''),
 ('/orgs/{org}/actions/variables/{name}/repositories/{repository_id}', 'put', 'actions/add-selected-repo-to-org-variable', 'Add selected repository to an organization variable', 'rest/actions/variables#add-selected-repository-to-an-organization-variable', [], [], ''),
 ('/orgs/{org}/actions/variables/{name}/repositories/{repository_id}', 'delete', 'actions/remove-selected-repo-from-org-variable', 'Remove selected repository from an organization variable', 'rest/actions/variables#remove-selected-repository-from-an-organization-variable', [], [], ''),
 ('/orgs/{org}/blocks', 'get', 'orgs/list-blocked-users', 'List users blocked by an organization', 'rest/orgs/blocking#list-users-blocked-by-an-organization', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/blocks/{username}', 'get', 'orgs/check-blocked-user', 'Check if a user is blocked by an organization', 'rest/orgs/blocking#check-if-a-user-is-blocked-by-an-organization', [], [], ''),
 ('/orgs/{org}/blocks/{username}', 'put', 'orgs/block-user', 'Block a user from an organization', 'rest/orgs/blocking#block-a-user-from-an-organization', [], [], ''),
 ('/orgs/{org}/blocks/{username}', 'delete', 'orgs/unblock-user', 'Unblock a user from an organization', 'rest/orgs/blocking#unblock-a-user-from-an-organization', [], [], ''),
 ('/orgs/{org}/code-scanning/alerts', 'get', 'code-scanning/list-alerts-for-org', 'List code scanning alerts for an organization', 'rest/code-scanning/code-scanning#list-code-scanning-alerts-for-an-organization', ['tool_name', 'tool_guid', 'before', 'after', 'page', 'per_page', 'direction', 'state', 'sort', 'severity'], [], ''),
 ('/orgs/{org}/codespaces', 'get', 'codespaces/list-in-organization', 'List codespaces for the organization', 'rest/codespaces/organizations#list-codespaces-for-the-organization', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/codespaces/access', 'put', 'codespaces/set-codespaces-access', 'Manage access control for organization codespaces', 'rest/codespaces/organizations#manage-access-control-for-organization-codespaces', [], [['visibility', str], ['selected_usernames', list]], ''),
 ('/orgs/{org}/codespaces/access/selected_users', 'post', 'codespaces/set-codespaces-access-users', 'Add users to Codespaces access for an organization', 'rest/codespaces/organizations#add-users-to-codespaces-access-for-an-organization', [], [['selected_usernames', list]], ''),
 ('/orgs/{org}/codespaces/access/selected_users', 'delete', 'codespaces/delete-codespaces-access-users', 'Remove users from Codespaces access for an organization', 'rest/codespaces/organizations#remove-users-from-codespaces-access-for-an-organization', [], [['selected_usernames', list]], ''),
 ('/orgs/{org}/codespaces/secrets', 'get', 'codespaces/list-org-secrets', 'List organization secrets', 'rest/codespaces/organization-secrets#list-organization-secrets', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/codespaces/secrets/public-key', 'get', 'codespaces/get-org-public-key', 'Get an organization public key', 'rest/codespaces/organization-secrets#get-an-organization-public-key', [], [], ''),
 ('/orgs/{org}/codespaces/secrets/{secret_name}', 'get', 'codespaces/get-org-secret', 'Get an organization secret', 'rest/codespaces/organization-secrets#get-an-organization-secret', [], [], ''),
 ('/orgs/{org}/codespaces/secrets/{secret_name}', 'put', 'codespaces/create-or-update-org-secret', 'Create or update an organization secret', 'rest/codespaces/organization-secrets#create-or-update-an-organization-secret', [], [['encrypted_value', str], ['key_id', str], ['visibility', str], ['selected_repository_ids', list]], ''),
 ('/orgs/{org}/codespaces/secrets/{secret_name}', 'delete', 'codespaces/delete-org-secret', 'Delete an organization secret', 'rest/codespaces/organization-secrets#delete-an-organization-secret', [], [], ''),
 ('/orgs/{org}/codespaces/secrets/{secret_name}/repositories', 'get', 'codespaces/list-selected-repos-for-org-secret', 'List selected repositories for an organization secret', 'rest/codespaces/organization-secrets#list-selected-repositories-for-an-organization-secret', ['page', 'per_page'], [], ''),
 ('/orgs/{org}/codespaces/secrets/{secret_name}/repositories', 'put', 'codespaces/set-selected-repos-for-org-secret', 'Set selected repositories for an organization secret', 'rest/codespaces/organization-secrets#set-selected-repositories-for-an-organization-secret', [], [['selected_repository_ids', list]], ''),
 ('/orgs/{org}/codespaces/secrets/{secret_name}/repositories/{repository_id}', 'put', 'codespaces/add-selected-repo-to-org-secret', 'Add selected repository to an organization secret', 'rest/codespaces/organization-secrets#add-selected-repository-to-an-organization-secret', [], [], ''),
 ('/orgs/{org}/codespaces/secrets/{secret_name}/repositories/{repository_id}', 'delete', 'codespaces/remove-selected-repo-from-org-secret', 'Remove selected repository from an organization secret', 'rest/codespaces/organization-secrets#remove-selected-repository-from-an-organization-secret', [], [], ''),
 ('/orgs/{org}/copilot/billing', 'get', 'copilot/get-copilot-organization-details', 'Get Copilot seat information and settings for an organization', 'rest/copilot/copilot-user-management#get-copilot-seat-information-and-settings-for-an-organization', [], [], ''),
 ('/orgs/{org}/copilot/billing/seats', 'get', 'copilot/list-copilot-seats', 'List all Copilot seat assignments for an organization', 'rest/copilot/copilot-user-management#list-all-copilot-seat-assignments-for-an-organization', ['page', 'per_page'], [], ''),
 ('/orgs/{org}/copilot/billing/selected_teams', 'post', 'copilot/add-copilot-seats-for-teams', 'Add teams to the Copilot subscription for an organization', 'rest/copilot/copilot-user-management#add-teams-to-the-copilot-subscription-for-an-organization', [], [['selected_teams', list]], ''),
 ('/orgs/{org}/copilot/billing/selected_teams', 'delete', 'copilot/cancel-copilot-seat-assignment-for-teams', 'Remove teams from the Copilot subscription for an organization', 'rest/copilot/copilot-user-management#remove-teams-from-the-copilot-subscription-for-an-organization', [], [['selected_teams', list]], ''),
 ('/orgs/{org}/copilot/billing/selected_users', 'post', 'copilot/add-copilot-seats-for-users', 'Add users to the Copilot subscription for an organization', 'rest/copilot/copilot-user-management#add-users-to-the-copilot-subscription-for-an-organization', [], [['selected_usernames', list]], ''),
 ('/orgs/{org}/copilot/billing/selected_users', 'delete', 'copilot/cancel-copilot-seat-assignment-for-users', 'Remove users from the Copilot subscription for an organization', 'rest/copilot/copilot-user-management#remove-users-from-the-copilot-subscription-for-an-organization', [], [['selected_usernames', list]], ''),
 ('/orgs/{org}/dependabot/alerts', 'get', 'dependabot/list-alerts-for-org', 'List Dependabot alerts for an organization', 'rest/dependabot/alerts#list-dependabot-alerts-for-an-organization', ['state', 'severity', 'ecosystem', 'package', 'scope', 'sort', 'direction', 'before', 'after', 'first', 'last', 'per_page'], [], ''),
 ('/orgs/{org}/dependabot/secrets', 'get', 'dependabot/list-org-secrets', 'List organization secrets', 'rest/dependabot/secrets#list-organization-secrets', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/dependabot/secrets/public-key', 'get', 'dependabot/get-org-public-key', 'Get an organization public key', 'rest/dependabot/secrets#get-an-organization-public-key', [], [], ''),
 ('/orgs/{org}/dependabot/secrets/{secret_name}', 'get', 'dependabot/get-org-secret', 'Get an organization secret', 'rest/dependabot/secrets#get-an-organization-secret', [], [], ''),
 ('/orgs/{org}/dependabot/secrets/{secret_name}', 'put', 'dependabot/create-or-update-org-secret', 'Create or update an organization secret', 'rest/dependabot/secrets#create-or-update-an-organization-secret', [], [['encrypted_value', str], ['key_id', str], ['visibility', str], ['selected_repository_ids', list]], ''),
 ('/orgs/{org}/dependabot/secrets/{secret_name}', 'delete', 'dependabot/delete-org-secret', 'Delete an organization secret', 'rest/dependabot/secrets#delete-an-organization-secret', [], [], ''),
 ('/orgs/{org}/dependabot/secrets/{secret_name}/repositories', 'get', 'dependabot/list-selected-repos-for-org-secret', 'List selected repositories for an organization secret', 'rest/dependabot/secrets#list-selected-repositories-for-an-organization-secret', ['page', 'per_page'], [], ''),
 ('/orgs/{org}/dependabot/secrets/{secret_name}/repositories', 'put', 'dependabot/set-selected-repos-for-org-secret', 'Set selected repositories for an organization secret', 'rest/dependabot/secrets#set-selected-repositories-for-an-organization-secret', [], [['selected_repository_ids', list]], ''),
 ('/orgs/{org}/dependabot/secrets/{secret_name}/repositories/{repository_id}', 'put', 'dependabot/add-selected-repo-to-org-secret', 'Add selected repository to an organization secret', 'rest/dependabot/secrets#add-selected-repository-to-an-organization-secret', [], [], ''),
 ('/orgs/{org}/dependabot/secrets/{secret_name}/repositories/{repository_id}', 'delete', 'dependabot/remove-selected-repo-from-org-secret', 'Remove selected repository from an organization secret', 'rest/dependabot/secrets#remove-selected-repository-from-an-organization-secret', [], [], ''),
 ('/orgs/{org}/docker/conflicts', 'get', 'packages/list-docker-migration-conflicting-packages-for-organization', 'Get list of conflicting packages during Docker migration for organization', 'rest/packages/packages#get-list-of-conflicting-packages-during-docker-migration-for-organization', [], [], ''),
 ('/orgs/{org}/events', 'get', 'activity/list-public-org-events', 'List public organization events', 'rest/activity/events#list-public-organization-events', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/failed_invitations', 'get', 'orgs/list-failed-invitations', 'List failed organization invitations', 'rest/orgs/members#list-failed-organization-invitations', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/hooks', 'get', 'orgs/list-webhooks', 'List organization webhooks', 'rest/orgs/webhooks#list-organization-webhooks', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/hooks', 'post', 'orgs/create-webhook', 'Create an organization webhook', 'rest/orgs/webhooks#create-an-organization-webhook', [], [['name', str], ['config', dict], ['events', list, ['push']], ['active', bool, True]], ''),
 ('/orgs/{org}/hooks/{hook_id}', 'get', 'orgs/get-webhook', 'Get an organization webhook', 'rest/orgs/webhooks#get-an-organization-webhook', [], [], ''),
 ('/orgs/{org}/hooks/{hook_id}', 'patch', 'orgs/update-webhook', 'Update an organization webhook', 'rest/orgs/webhooks#update-an-organization-webhook', [], [['config', dict], ['events', list, ['push']], ['active', bool, True], ['name', str]], ''),
 ('/orgs/{org}/hooks/{hook_id}', 'delete', 'orgs/delete-webhook', 'Delete an organization webhook', 'rest/orgs/webhooks#delete-an-organization-webhook', [], [], ''),
 ('/orgs/{org}/hooks/{hook_id}/config', 'get', 'orgs/get-webhook-config-for-org', 'Get a webhook configuration for an organization', 'rest/orgs/webhooks#get-a-webhook-configuration-for-an-organization', [], [], ''),
 ('/orgs/{org}/hooks/{hook_id}/config', 'patch', 'orgs/update-webhook-config-for-org', 'Update a webhook configuration for an organization', 'rest/orgs/webhooks#update-a-webhook-configuration-for-an-organization', [], [['url', str], ['content_type', str], ['secret', str], ['insecure_ssl', object]], ''),
 ('/orgs/{org}/hooks/{hook_id}/deliveries', 'get', 'orgs/list-webhook-deliveries', 'List deliveries for an organization webhook', 'rest/orgs/webhooks#list-deliveries-for-an-organization-webhook', ['per_page', 'cursor', 'redelivery'], [], ''),
 ('/orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}', 'get', 'orgs/get-webhook-delivery', 'Get a webhook delivery for an organization webhook', 'rest/orgs/webhooks#get-a-webhook-delivery-for-an-organization-webhook', [], [], ''),
 ('/orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}/attempts', 'post', 'orgs/redeliver-webhook-delivery', 'Redeliver a delivery for an organization webhook', 'rest/orgs/webhooks#redeliver-a-delivery-for-an-organization-webhook', [], [], ''),
 ('/orgs/{org}/hooks/{hook_id}/pings', 'post', 'orgs/ping-webhook', 'Ping an organization webhook', 'rest/orgs/webhooks#ping-an-organization-webhook', [], [], ''),
 ('/orgs/{org}/installation', 'get', 'apps/get-org-installation', 'Get an organization installation for the authenticated app', 'rest/apps/apps#get-an-organization-installation-for-the-authenticated-app', [], [], ''),
 ('/orgs/{org}/installations', 'get', 'orgs/list-app-installations', 'List app installations for an organization', 'rest/orgs/orgs#list-app-installations-for-an-organization', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/interaction-limits', 'get', 'interactions/get-restrictions-for-org', 'Get interaction restrictions for an organization', 'rest/interactions/orgs#get-interaction-restrictions-for-an-organization', [], [], ''),
 ('/orgs/{org}/interaction-limits', 'put', 'interactions/set-restrictions-for-org', 'Set interaction restrictions for an organization', 'rest/interactions/orgs#set-interaction-restrictions-for-an-organization', [], [['limit', str], ['expiry', str]], ''),
 ('/orgs/{org}/interaction-limits', 'delete', 'interactions/remove-restrictions-for-org', 'Remove interaction restrictions for an organization', 'rest/interactions/orgs#remove-interaction-restrictions-for-an-organization', [], [], ''),
 ('/orgs/{org}/invitations', 'get', 'orgs/list-pending-invitations', 'List pending organization invitations', 'rest/orgs/members#list-pending-organization-invitations', ['per_page', 'page', 'role', 'invitation_source'], [], ''),
 ('/orgs/{org}/invitations', 'post', 'orgs/create-invitation', 'Create an organization invitation', 'rest/orgs/members#create-an-organization-invitation', [], [['invitee_id', int], ['email', str], ['role', str, 'direct_member'], ['team_ids', list]], ''),
 ('/orgs/{org}/invitations/{invitation_id}', 'delete', 'orgs/cancel-invitation', 'Cancel an organization invitation', 'rest/orgs/members#cancel-an-organization-invitation', [], [], ''),
 ('/orgs/{org}/invitations/{invitation_id}/teams', 'get', 'orgs/list-invitation-teams', 'List organization invitation teams', 'rest/orgs/members#list-organization-invitation-teams', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/issues', 'get', 'issues/list-for-org', 'List organization issues assigned to the authenticated user', 'rest/issues/issues#list-organization-issues-assigned-to-the-authenticated-user', ['filter', 'state', 'labels', 'sort', 'direction', 'since', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/members', 'get', 'orgs/list-members', 'List organization members', 'rest/orgs/members#list-organization-members', ['filter', 'role', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/members/{username}', 'get', 'orgs/check-membership-for-user', 'Check organization membership for a user', 'rest/orgs/members#check-organization-membership-for-a-user', [], [], ''),
 ('/orgs/{org}/members/{username}', 'delete', 'orgs/remove-member', 'Remove an organization member', 'rest/orgs/members#remove-an-organization-member', [], [], ''),
 ('/orgs/{org}/members/{username}/codespaces', 'get', 'codespaces/get-codespaces-for-user-in-org', 'List codespaces for a user in organization', 'rest/codespaces/organizations#list-codespaces-for-a-user-in-organization', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/members/{username}/codespaces/{codespace_name}', 'delete', 'codespaces/delete-from-organization', 'Delete a codespace from the organization', 'rest/codespaces/organizations#delete-a-codespace-from-the-organization', [], [], ''),
 ('/orgs/{org}/members/{username}/codespaces/{codespace_name}/stop', 'post', 'codespaces/stop-in-organization', 'Stop a codespace for an organization user', 'rest/codespaces/organizations#stop-a-codespace-for-an-organization-user', [], [], ''),
 ('/orgs/{org}/members/{username}/copilot', 'get', 'copilot/get-copilot-seat-details-for-user', 'Get Copilot seat assignment details for a user', 'rest/copilot/copilot-user-management#get-copilot-seat-assignment-details-for-a-user', [], [], ''),
 ('/orgs/{org}/memberships/{username}', 'get', 'orgs/get-membership-for-user', 'Get organization membership for a user', 'rest/orgs/members#get-organization-membership-for-a-user', [], [], ''),
 ('/orgs/{org}/memberships/{username}', 'put', 'orgs/set-membership-for-user', 'Set organization membership for a user', 'rest/orgs/members#set-organization-membership-for-a-user', [], [['role', str, 'member']], ''),
 ('/orgs/{org}/memberships/{username}', 'delete', 'orgs/remove-membership-for-user', 'Remove organization membership for a user', 'rest/orgs/members#remove-organization-membership-for-a-user', [], [], ''),
 ('/orgs/{org}/migrations', 'get', 'migrations/list-for-org', 'List organization migrations', 'rest/migrations/orgs#list-organization-migrations', ['per_page', 'page', 'exclude'], [], ''),
 ('/orgs/{org}/migrations',
  'post',
  'migrations/start-for-org',
  'Start an organization migration',
  'rest/migrations/orgs#start-an-organization-migration',
  [],
  [['repositories', list], ['lock_repositories', bool, False], ['exclude_metadata', bool, False], ['exclude_git_data', bool, False], ['exclude_attachments', bool, False], ['exclude_releases', bool, False], ['exclude_owner_projects', bool, False], ['org_metadata_only', bool, False], ['exclude', list]],
  ''),
 ('/orgs/{org}/migrations/{migration_id}', 'get', 'migrations/get-status-for-org', 'Get an organization migration status', 'rest/migrations/orgs#get-an-organization-migration-status', ['exclude'], [], ''),
 ('/orgs/{org}/migrations/{migration_id}/archive', 'get', 'migrations/download-archive-for-org', 'Download an organization migration archive', 'rest/migrations/orgs#download-an-organization-migration-archive', [], [], ''),
 ('/orgs/{org}/migrations/{migration_id}/archive', 'delete', 'migrations/delete-archive-for-org', 'Delete an organization migration archive', 'rest/migrations/orgs#delete-an-organization-migration-archive', [], [], ''),
 ('/orgs/{org}/migrations/{migration_id}/repos/{repo_name}/lock', 'delete', 'migrations/unlock-repo-for-org', 'Unlock an organization repository', 'rest/migrations/orgs#unlock-an-organization-repository', [], [], ''),
 ('/orgs/{org}/migrations/{migration_id}/repositories', 'get', 'migrations/list-repos-for-org', 'List repositories in an organization migration', 'rest/migrations/orgs#list-repositories-in-an-organization-migration', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/organization-fine-grained-permissions', 'get', 'orgs/list-organization-fine-grained-permissions', 'List organization fine-grained permissions for an organization', 'rest/orgs/organization-roles#list-organization-fine-grained-permissions-for-an-organization', [], [], ''),
 ('/orgs/{org}/organization-roles', 'get', 'orgs/list-org-roles', 'Get all organization roles for an organization', 'rest/orgs/organization-roles#get-all-organization-roles-for-an-organization', [], [], ''),
 ('/orgs/{org}/organization-roles', 'post', 'orgs/create-custom-organization-role', 'Create a custom organization role', 'rest/orgs/organization-roles#create-a-custom-organization-role', [], [['name', str], ['description', str], ['permissions', list]], ''),
 ('/orgs/{org}/organization-roles/teams/{team_slug}', 'delete', 'orgs/revoke-all-org-roles-team', 'Remove all organization roles for a team', 'rest/orgs/organization-roles#remove-all-organization-roles-for-a-team', [], [], ''),
 ('/orgs/{org}/organization-roles/teams/{team_slug}/{role_id}', 'put', 'orgs/assign-team-to-org-role', 'Assign an organization role to a team', 'rest/orgs/organization-roles#assign-an-organization-role-to-a-team', [], [], ''),
 ('/orgs/{org}/organization-roles/teams/{team_slug}/{role_id}', 'delete', 'orgs/revoke-org-role-team', 'Remove an organization role from a team', 'rest/orgs/organization-roles#remove-an-organization-role-from-a-team', [], [], ''),
 ('/orgs/{org}/organization-roles/users/{username}', 'delete', 'orgs/revoke-all-org-roles-user', 'Remove all organization roles for a user', 'rest/orgs/organization-roles#remove-all-organization-roles-for-a-user', [], [], ''),
 ('/orgs/{org}/organization-roles/users/{username}/{role_id}', 'put', 'orgs/assign-user-to-org-role', 'Assign an organization role to a user', 'rest/orgs/organization-roles#assign-an-organization-role-to-a-user', [], [], ''),
 ('/orgs/{org}/organization-roles/users/{username}/{role_id}', 'delete', 'orgs/revoke-org-role-user', 'Remove an organization role from a user', 'rest/orgs/organization-roles#remove-an-organization-role-from-a-user', [], [], ''),
 ('/orgs/{org}/organization-roles/{role_id}', 'get', 'orgs/get-org-role', 'Get an organization role', 'rest/orgs/organization-roles#get-an-organization-role', [], [], ''),
 ('/orgs/{org}/organization-roles/{role_id}', 'patch', 'orgs/patch-custom-organization-role', 'Update a custom organization role', 'rest/orgs/organization-roles#update-a-custom-organization-role', [], [['name', str], ['description', str], ['permissions', list]], ''),
 ('/orgs/{org}/organization-roles/{role_id}', 'delete', 'orgs/delete-custom-organization-role', 'Delete a custom organization role.', 'rest/orgs/organization-roles#delete-a-custom-organization-role', [], [], ''),
 ('/orgs/{org}/organization-roles/{role_id}/teams', 'get', 'orgs/list-org-role-teams', 'List teams that are assigned to an organization role', 'rest/orgs/organization-roles#list-teams-that-are-assigned-to-an-organization-role', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/organization-roles/{role_id}/users', 'get', 'orgs/list-org-role-users', 'List users that are assigned to an organization role', 'rest/orgs/organization-roles#list-users-that-are-assigned-to-an-organization-role', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/outside_collaborators', 'get', 'orgs/list-outside-collaborators', 'List outside collaborators for an organization', 'rest/orgs/outside-collaborators#list-outside-collaborators-for-an-organization', ['filter', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/outside_collaborators/{username}', 'put', 'orgs/convert-member-to-outside-collaborator', 'Convert an organization member to outside collaborator', 'rest/orgs/outside-collaborators#convert-an-organization-member-to-outside-collaborator', [], [['async', bool, False]], ''),
 ('/orgs/{org}/outside_collaborators/{username}', 'delete', 'orgs/remove-outside-collaborator', 'Remove outside collaborator from an organization', 'rest/orgs/outside-collaborators#remove-outside-collaborator-from-an-organization', [], [], ''),
 ('/orgs/{org}/packages', 'get', 'packages/list-packages-for-organization', 'List packages for an organization', 'rest/packages/packages#list-packages-for-an-organization', ['package_type', 'visibility', 'page', 'per_page'], [], ''),
 ('/orgs/{org}/packages/{package_type}/{package_name}', 'get', 'packages/get-package-for-organization', 'Get a package for an organization', 'rest/packages/packages#get-a-package-for-an-organization', [], [], ''),
 ('/orgs/{org}/packages/{package_type}/{package_name}', 'delete', 'packages/delete-package-for-org', 'Delete a package for an organization', 'rest/packages/packages#delete-a-package-for-an-organization', [], [], ''),
 ('/orgs/{org}/packages/{package_type}/{package_name}/restore', 'post', 'packages/restore-package-for-org', 'Restore a package for an organization', 'rest/packages/packages#restore-a-package-for-an-organization', ['token'], [], ''),
 ('/orgs/{org}/packages/{package_type}/{package_name}/versions', 'get', 'packages/get-all-package-versions-for-package-owned-by-org', 'List package versions for a package owned by an organization', 'rest/packages/packages#list-package-versions-for-a-package-owned-by-an-organization', ['page', 'per_page', 'state'], [], ''),
 ('/orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}', 'get', 'packages/get-package-version-for-organization', 'Get a package version for an organization', 'rest/packages/packages#get-a-package-version-for-an-organization', [], [], ''),
 ('/orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}', 'delete', 'packages/delete-package-version-for-org', 'Delete package version for an organization', 'rest/packages/packages#delete-package-version-for-an-organization', [], [], ''),
 ('/orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}/restore', 'post', 'packages/restore-package-version-for-org', 'Restore package version for an organization', 'rest/packages/packages#restore-package-version-for-an-organization', [], [], ''),
 ('/orgs/{org}/personal-access-token-requests',
  'get',
  'orgs/list-pat-grant-requests',
  'List requests to access organization resources with fine-grained personal access tokens',
  'rest/orgs/personal-access-tokens#list-requests-to-access-organization-resources-with-fine-grained-personal-access-tokens',
  ['per_page', 'page', 'sort', 'direction', 'owner', 'repository', 'permission', 'last_used_before', 'last_used_after'],
  [],
  ''),
 ('/orgs/{org}/personal-access-token-requests',
  'post',
  'orgs/review-pat-grant-requests-in-bulk',
  'Review requests to access organization resources with fine-grained personal access tokens',
  'rest/orgs/personal-access-tokens#review-requests-to-access-organization-resources-with-fine-grained-personal-access-tokens',
  [],
  [['pat_request_ids', list], ['action', str], ['reason', str]],
  ''),
 ('/orgs/{org}/personal-access-token-requests/{pat_request_id}',
  'post',
  'orgs/review-pat-grant-request',
  'Review a request to access organization resources with a fine-grained personal access token',
  'rest/orgs/personal-access-tokens#review-a-request-to-access-organization-resources-with-a-fine-grained-personal-access-token',
  [],
  [['action', str], ['reason', str]],
  ''),
 ('/orgs/{org}/personal-access-token-requests/{pat_request_id}/repositories',
  'get',
  'orgs/list-pat-grant-request-repositories',
  'List repositories requested to be accessed by a fine-grained personal access token',
  'rest/orgs/personal-access-tokens#list-repositories-requested-to-be-accessed-by-a-fine-grained-personal-access-token',
  ['per_page', 'page'],
  [],
  ''),
 ('/orgs/{org}/personal-access-tokens',
  'get',
  'orgs/list-pat-grants',
  'List fine-grained personal access tokens with access to organization resources',
  'rest/orgs/personal-access-tokens#list-fine-grained-personal-access-tokens-with-access-to-organization-resources',
  ['per_page', 'page', 'sort', 'direction', 'owner', 'repository', 'permission', 'last_used_before', 'last_used_after'],
  [],
  ''),
 ('/orgs/{org}/personal-access-tokens', 'post', 'orgs/update-pat-accesses', 'Update the access to organization resources via fine-grained personal access tokens', 'rest/orgs/personal-access-tokens#update-the-access-to-organization-resources-via-fine-grained-personal-access-tokens', [], [['action', str], ['pat_ids', list]], ''),
 ('/orgs/{org}/personal-access-tokens/{pat_id}', 'post', 'orgs/update-pat-access', 'Update the access a fine-grained personal access token has to organization resources', 'rest/orgs/personal-access-tokens#update-the-access-a-fine-grained-personal-access-token-has-to-organization-resources', [], [['action', str]], ''),
 ('/orgs/{org}/personal-access-tokens/{pat_id}/repositories', 'get', 'orgs/list-pat-grant-repositories', 'List repositories a fine-grained personal access token has access to', 'rest/orgs/personal-access-tokens#list-repositories-a-fine-grained-personal-access-token-has-access-to', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/projects', 'get', 'projects/list-for-org', 'List organization projects', 'rest/projects/projects#list-organization-projects', ['state', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/projects', 'post', 'projects/create-for-org', 'Create an organization project', 'rest/projects/projects#create-an-organization-project', [], [['name', str], ['body', str]], ''),
 ('/orgs/{org}/properties/schema', 'get', 'orgs/get-all-custom-properties', 'Get all custom properties for an organization', 'rest/orgs/custom-properties#get-all-custom-properties-for-an-organization', [], [], ''),
 ('/orgs/{org}/properties/schema', 'patch', 'orgs/create-or-update-custom-properties', 'Create or update custom properties for an organization', 'rest/orgs/custom-properties#create-or-update-custom-properties-for-an-organization', [], [['properties', list]], ''),
 ('/orgs/{org}/properties/schema/{custom_property_name}', 'get', 'orgs/get-custom-property', 'Get a custom property for an organization', 'rest/orgs/custom-properties#get-a-custom-property-for-an-organization', [], [], ''),
 ('/orgs/{org}/properties/schema/{custom_property_name}',
  'put',
  'orgs/create-or-update-custom-property',
  'Create or update a custom property for an organization',
  'rest/orgs/custom-properties#create-or-update-a-custom-property-for-an-organization',
  [],
  [['value_type', str], ['required', bool], ['default_value', str], ['description', str], ['allowed_values', list]],
  ''),
 ('/orgs/{org}/properties/schema/{custom_property_name}', 'delete', 'orgs/remove-custom-property', 'Remove a custom property for an organization', 'rest/orgs/custom-properties#remove-a-custom-property-for-an-organization', [], [], ''),
 ('/orgs/{org}/properties/values', 'get', 'orgs/list-custom-properties-values-for-repos', 'List custom property values for organization repositories', 'rest/orgs/custom-properties#list-custom-property-values-for-organization-repositories', ['per_page', 'page', 'repository_query'], [], ''),
 ('/orgs/{org}/properties/values', 'patch', 'orgs/create-or-update-custom-properties-values-for-repos', 'Create or update custom property values for organization repositories', 'rest/orgs/custom-properties#create-or-update-custom-property-values-for-organization-repositories', [], [['repository_names', list], ['properties', list]], ''),
 ('/orgs/{org}/public_members', 'get', 'orgs/list-public-members', 'List public organization members', 'rest/orgs/members#list-public-organization-members', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/public_members/{username}', 'get', 'orgs/check-public-membership-for-user', 'Check public organization membership for a user', 'rest/orgs/members#check-public-organization-membership-for-a-user', [], [], ''),
 ('/orgs/{org}/public_members/{username}', 'put', 'orgs/set-public-membership-for-authenticated-user', 'Set public organization membership for the authenticated user', 'rest/orgs/members#set-public-organization-membership-for-the-authenticated-user', [], [], ''),
 ('/orgs/{org}/public_members/{username}', 'delete', 'orgs/remove-public-membership-for-authenticated-user', 'Remove public organization membership for the authenticated user', 'rest/orgs/members#remove-public-organization-membership-for-the-authenticated-user', [], [], ''),
 ('/orgs/{org}/repos', 'get', 'repos/list-for-org', 'List organization repositories', 'rest/repos/repos#list-organization-repositories', ['type', 'sort', 'direction', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/repos',
  'post',
  'repos/create-in-org',
  'Create an organization repository',
  'rest/repos/repos#create-an-organization-repository',
  [],
  [['name', str],
   ['description', str],
   ['homepage', str],
   ['private', bool, False],
   ['visibility', str],
   ['has_issues', bool, True],
   ['has_projects', bool, True],
   ['has_wiki', bool, True],
   ['has_downloads', bool, True],
   ['is_template', bool, False],
   ['team_id', int],
   ['auto_init', bool, False],
   ['gitignore_template', str],
   ['license_template', str],
   ['allow_squash_merge', bool, True],
   ['allow_merge_commit', bool, True],
   ['allow_rebase_merge', bool, True],
   ['allow_auto_merge', bool, False],
   ['delete_branch_on_merge', bool, False],
   ['use_squash_pr_title_as_default', bool, False],
   ['squash_merge_commit_title', str],
   ['squash_merge_commit_message', str],
   ['merge_commit_title', str],
   ['merge_commit_message', str],
   ['custom_properties', dict]],
  ''),
 ('/orgs/{org}/rulesets', 'get', 'repos/get-org-rulesets', 'Get all organization repository rulesets', 'rest/orgs/rules#get-all-organization-repository-rulesets', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/rulesets', 'post', 'repos/create-org-ruleset', 'Create an organization repository ruleset', 'rest/orgs/rules#create-an-organization-repository-ruleset', [], [['name', str], ['target', str], ['enforcement', str], ['bypass_actors', list], ['conditions', dict], ['rules', list]], ''),
 ('/orgs/{org}/rulesets/rule-suites', 'get', 'repos/get-org-rule-suites', 'List organization rule suites', 'rest/orgs/rule-suites#list-organization-rule-suites', ['repository_name', 'time_period', 'actor_name', 'rule_suite_result', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/rulesets/rule-suites/{rule_suite_id}', 'get', 'repos/get-org-rule-suite', 'Get an organization rule suite', 'rest/orgs/rule-suites#get-an-organization-rule-suite', [], [], ''),
 ('/orgs/{org}/rulesets/{ruleset_id}', 'get', 'repos/get-org-ruleset', 'Get an organization repository ruleset', 'rest/orgs/rules#get-an-organization-repository-ruleset', [], [], ''),
 ('/orgs/{org}/rulesets/{ruleset_id}', 'put', 'repos/update-org-ruleset', 'Update an organization repository ruleset', 'rest/orgs/rules#update-an-organization-repository-ruleset', [], [['name', str], ['target', str], ['enforcement', str], ['bypass_actors', list], ['conditions', dict], ['rules', list]], ''),
 ('/orgs/{org}/rulesets/{ruleset_id}', 'delete', 'repos/delete-org-ruleset', 'Delete an organization repository ruleset', 'rest/orgs/rules#delete-an-organization-repository-ruleset', [], [], ''),
 ('/orgs/{org}/secret-scanning/alerts', 'get', 'secret-scanning/list-alerts-for-org', 'List secret scanning alerts for an organization', 'rest/secret-scanning/secret-scanning#list-secret-scanning-alerts-for-an-organization', ['state', 'secret_type', 'resolution', 'sort', 'direction', 'page', 'per_page', 'before', 'after', 'validity'], [], ''),
 ('/orgs/{org}/security-advisories', 'get', 'security-advisories/list-org-repository-advisories', 'List repository security advisories for an organization', 'rest/security-advisories/repository-advisories#list-repository-security-advisories-for-an-organization', ['direction', 'sort', 'before', 'after', 'per_page', 'state'], [], ''),
 ('/orgs/{org}/security-managers', 'get', 'orgs/list-security-manager-teams', 'List security manager teams', 'rest/orgs/security-managers#list-security-manager-teams', [], [], ''),
 ('/orgs/{org}/security-managers/teams/{team_slug}', 'put', 'orgs/add-security-manager-team', 'Add a security manager team', 'rest/orgs/security-managers#add-a-security-manager-team', [], [], ''),
 ('/orgs/{org}/security-managers/teams/{team_slug}', 'delete', 'orgs/remove-security-manager-team', 'Remove a security manager team', 'rest/orgs/security-managers#remove-a-security-manager-team', [], [], ''),
 ('/orgs/{org}/settings/billing/actions', 'get', 'billing/get-github-actions-billing-org', 'Get GitHub Actions billing for an organization', 'rest/billing/billing#get-github-actions-billing-for-an-organization', [], [], ''),
 ('/orgs/{org}/settings/billing/packages', 'get', 'billing/get-github-packages-billing-org', 'Get GitHub Packages billing for an organization', 'rest/billing/billing#get-github-packages-billing-for-an-organization', [], [], ''),
 ('/orgs/{org}/settings/billing/shared-storage', 'get', 'billing/get-shared-storage-billing-org', 'Get shared storage billing for an organization', 'rest/billing/billing#get-shared-storage-billing-for-an-organization', [], [], ''),
 ('/orgs/{org}/teams', 'get', 'teams/list', 'List teams', 'rest/teams/teams#list-teams', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/teams', 'post', 'teams/create', 'Create a team', 'rest/teams/teams#create-a-team', [], [['name', str], ['description', str], ['maintainers', list], ['repo_names', list], ['privacy', str], ['notification_setting', str], ['permission', str, 'pull'], ['parent_team_id', int]], ''),
 ('/orgs/{org}/teams/{team_slug}', 'get', 'teams/get-by-name', 'Get a team by name', 'rest/teams/teams#get-a-team-by-name', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}', 'patch', 'teams/update-in-org', 'Update a team', 'rest/teams/teams#update-a-team', [], [['name', str], ['description', str], ['privacy', str], ['notification_setting', str], ['permission', str, 'pull'], ['parent_team_id', int]], ''),
 ('/orgs/{org}/teams/{team_slug}', 'delete', 'teams/delete-in-org', 'Delete a team', 'rest/teams/teams#delete-a-team', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions', 'get', 'teams/list-discussions-in-org', 'List discussions', 'rest/teams/discussions#list-discussions', ['direction', 'per_page', 'page', 'pinned'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions', 'post', 'teams/create-discussion-in-org', 'Create a discussion', 'rest/teams/discussions#create-a-discussion', [], [['title', str], ['body', str], ['private', bool, False]], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}', 'get', 'teams/get-discussion-in-org', 'Get a discussion', 'rest/teams/discussions#get-a-discussion', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}', 'patch', 'teams/update-discussion-in-org', 'Update a discussion', 'rest/teams/discussions#update-a-discussion', [], [['title', str], ['body', str]], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}', 'delete', 'teams/delete-discussion-in-org', 'Delete a discussion', 'rest/teams/discussions#delete-a-discussion', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments', 'get', 'teams/list-discussion-comments-in-org', 'List discussion comments', 'rest/teams/discussion-comments#list-discussion-comments', ['direction', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments', 'post', 'teams/create-discussion-comment-in-org', 'Create a discussion comment', 'rest/teams/discussion-comments#create-a-discussion-comment', [], [['body', str]], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}', 'get', 'teams/get-discussion-comment-in-org', 'Get a discussion comment', 'rest/teams/discussion-comments#get-a-discussion-comment', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}', 'patch', 'teams/update-discussion-comment-in-org', 'Update a discussion comment', 'rest/teams/discussion-comments#update-a-discussion-comment', [], [['body', str]], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}', 'delete', 'teams/delete-discussion-comment-in-org', 'Delete a discussion comment', 'rest/teams/discussion-comments#delete-a-discussion-comment', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions', 'get', 'reactions/list-for-team-discussion-comment-in-org', 'List reactions for a team discussion comment', 'rest/reactions/reactions#list-reactions-for-a-team-discussion-comment', ['content', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions', 'post', 'reactions/create-for-team-discussion-comment-in-org', 'Create reaction for a team discussion comment', 'rest/reactions/reactions#create-reaction-for-a-team-discussion-comment', [], [['content', str]], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions/{reaction_id}', 'delete', 'reactions/delete-for-team-discussion-comment', 'Delete team discussion comment reaction', 'rest/reactions/reactions#delete-team-discussion-comment-reaction', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions', 'get', 'reactions/list-for-team-discussion-in-org', 'List reactions for a team discussion', 'rest/reactions/reactions#list-reactions-for-a-team-discussion', ['content', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions', 'post', 'reactions/create-for-team-discussion-in-org', 'Create reaction for a team discussion', 'rest/reactions/reactions#create-reaction-for-a-team-discussion', [], [['content', str]], ''),
 ('/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions/{reaction_id}', 'delete', 'reactions/delete-for-team-discussion', 'Delete team discussion reaction', 'rest/reactions/reactions#delete-team-discussion-reaction', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/invitations', 'get', 'teams/list-pending-invitations-in-org', 'List pending team invitations', 'rest/teams/members#list-pending-team-invitations', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/members', 'get', 'teams/list-members-in-org', 'List team members', 'rest/teams/members#list-team-members', ['role', 'per_page', 'page'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/memberships/{username}', 'get', 'teams/get-membership-for-user-in-org', 'Get team membership for a user', 'rest/teams/members#get-team-membership-for-a-user', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/memberships/{username}', 'put', 'teams/add-or-update-membership-for-user-in-org', 'Add or update team membership for a user', 'rest/teams/members#add-or-update-team-membership-for-a-user', [], [['role', str, 'member']], ''),
 ('/orgs/{org}/teams/{team_slug}/memberships/{username}', 'delete', 'teams/remove-membership-for-user-in-org', 'Remove team membership for a user', 'rest/teams/members#remove-team-membership-for-a-user', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/projects', 'get', 'teams/list-projects-in-org', 'List team projects', 'rest/teams/teams#list-team-projects', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/projects/{project_id}', 'get', 'teams/check-permissions-for-project-in-org', 'Check team permissions for a project', 'rest/teams/teams#check-team-permissions-for-a-project', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/projects/{project_id}', 'put', 'teams/add-or-update-project-permissions-in-org', 'Add or update team project permissions', 'rest/teams/teams#add-or-update-team-project-permissions', [], [['permission', str]], ''),
 ('/orgs/{org}/teams/{team_slug}/projects/{project_id}', 'delete', 'teams/remove-project-in-org', 'Remove a project from a team', 'rest/teams/teams#remove-a-project-from-a-team', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/repos', 'get', 'teams/list-repos-in-org', 'List team repositories', 'rest/teams/teams#list-team-repositories', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}', 'get', 'teams/check-permissions-for-repo-in-org', 'Check team permissions for a repository', 'rest/teams/teams#check-team-permissions-for-a-repository', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}', 'put', 'teams/add-or-update-repo-permissions-in-org', 'Add or update team repository permissions', 'rest/teams/teams#add-or-update-team-repository-permissions', [], [['permission', str, 'push']], ''),
 ('/orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}', 'delete', 'teams/remove-repo-in-org', 'Remove a repository from a team', 'rest/teams/teams#remove-a-repository-from-a-team', [], [], ''),
 ('/orgs/{org}/teams/{team_slug}/teams', 'get', 'teams/list-child-in-org', 'List child teams', 'rest/teams/teams#list-child-teams', ['per_page', 'page'], [], ''),
 ('/orgs/{org}/{security_product}/{enablement}', 'post', 'orgs/enable-or-disable-security-product-on-all-org-repos', 'Enable or disable a security feature for an organization', 'rest/orgs/orgs#enable-or-disable-a-security-feature-for-an-organization', [], [['query_suite', str]], ''),
 ('/projects/columns/cards/{card_id}', 'get', 'projects/get-card', 'Get a project card', 'rest/projects/cards#get-a-project-card', [], [], ''),
 ('/projects/columns/cards/{card_id}', 'patch', 'projects/update-card', 'Update an existing project card', 'rest/projects/cards#update-an-existing-project-card', [], [['note', str], ['archived', bool]], ''),
 ('/projects/columns/cards/{card_id}', 'delete', 'projects/delete-card', 'Delete a project card', 'rest/projects/cards#delete-a-project-card', [], [], ''),
 ('/projects/columns/cards/{card_id}/moves', 'post', 'projects/move-card', 'Move a project card', 'rest/projects/cards#move-a-project-card', [], [['position', str], ['column_id', int]], ''),
 ('/projects/columns/{column_id}', 'get', 'projects/get-column', 'Get a project column', 'rest/projects/columns#get-a-project-column', [], [], ''),
 ('/projects/columns/{column_id}', 'patch', 'projects/update-column', 'Update an existing project column', 'rest/projects/columns#update-an-existing-project-column', [], [['name', str]], ''),
 ('/projects/columns/{column_id}', 'delete', 'projects/delete-column', 'Delete a project column', 'rest/projects/columns#delete-a-project-column', [], [], ''),
 ('/projects/columns/{column_id}/cards', 'get', 'projects/list-cards', 'List project cards', 'rest/projects/cards#list-project-cards', ['archived_state', 'per_page', 'page'], [], ''),
 ('/projects/columns/{column_id}/cards', 'post', 'projects/create-card', 'Create a project card', 'rest/projects/cards#create-a-project-card', [], [['note', str]], ''),
 ('/projects/columns/{column_id}/moves', 'post', 'projects/move-column', 'Move a project column', 'rest/projects/columns#move-a-project-column', [], [['position', str]], ''),
 ('/projects/{project_id}', 'get', 'projects/get', 'Get a project', 'rest/projects/projects#get-a-project', [], [], ''),
 ('/projects/{project_id}', 'patch', 'projects/update', 'Update a project', 'rest/projects/projects#update-a-project', [], [['name', str], ['body', str], ['state', str], ['organization_permission', str], ['private', bool]], ''),
 ('/projects/{project_id}', 'delete', 'projects/delete', 'Delete a project', 'rest/projects/projects#delete-a-project', [], [], ''),
 ('/projects/{project_id}/collaborators', 'get', 'projects/list-collaborators', 'List project collaborators', 'rest/projects/collaborators#list-project-collaborators', ['affiliation', 'per_page', 'page'], [], ''),
 ('/projects/{project_id}/collaborators/{username}', 'put', 'projects/add-collaborator', 'Add project collaborator', 'rest/projects/collaborators#add-project-collaborator', [], [['permission', str, 'write']], ''),
 ('/projects/{project_id}/collaborators/{username}', 'delete', 'projects/remove-collaborator', 'Remove user as a collaborator', 'rest/projects/collaborators#remove-user-as-a-collaborator', [], [], ''),
 ('/projects/{project_id}/collaborators/{username}/permission', 'get', 'projects/get-permission-for-user', 'Get project permission for a user', 'rest/projects/collaborators#get-project-permission-for-a-user', [], [], ''),
 ('/projects/{project_id}/columns', 'get', 'projects/list-columns', 'List project columns', 'rest/projects/columns#list-project-columns', ['per_page', 'page'], [], ''),
 ('/projects/{project_id}/columns', 'post', 'projects/create-column', 'Create a project column', 'rest/projects/columns#create-a-project-column', [], [['name', str]], ''),
 ('/rate_limit', 'get', 'rate-limit/get', 'Get rate limit status for the authenticated user', 'rest/rate-limit/rate-limit#get-rate-limit-status-for-the-authenticated-user', [], [], ''),
 ('/repos/{owner}/{repo}', 'get', 'repos/get', 'Get a repository', 'rest/repos/repos#get-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}',
  'patch',
  'repos/update',
  'Update a repository',
  'rest/repos/repos#update-a-repository',
  [],
  [['name', str],
   ['description', str],
   ['homepage', str],
   ['private', bool, False],
   ['visibility', str],
   ['security_and_analysis', dict],
   ['has_issues', bool, True],
   ['has_projects', bool, True],
   ['has_wiki', bool, True],
   ['is_template', bool, False],
   ['default_branch', str],
   ['allow_squash_merge', bool, True],
   ['allow_merge_commit', bool, True],
   ['allow_rebase_merge', bool, True],
   ['allow_auto_merge', bool, False],
   ['delete_branch_on_merge', bool, False],
   ['allow_update_branch', bool, False],
   ['use_squash_pr_title_as_default', bool, False],
   ['squash_merge_commit_title', str],
   ['squash_merge_commit_message', str],
   ['merge_commit_title', str],
   ['merge_commit_message', str],
   ['archived', bool, False],
   ['allow_forking', bool, False],
   ['web_commit_signoff_required', bool, False]],
  ''),
 ('/repos/{owner}/{repo}', 'delete', 'repos/delete', 'Delete a repository', 'rest/repos/repos#delete-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/artifacts', 'get', 'actions/list-artifacts-for-repo', 'List artifacts for a repository', 'rest/actions/artifacts#list-artifacts-for-a-repository', ['per_page', 'page', 'name'], [], ''),
 ('/repos/{owner}/{repo}/actions/artifacts/{artifact_id}', 'get', 'actions/get-artifact', 'Get an artifact', 'rest/actions/artifacts#get-an-artifact', [], [], ''),
 ('/repos/{owner}/{repo}/actions/artifacts/{artifact_id}', 'delete', 'actions/delete-artifact', 'Delete an artifact', 'rest/actions/artifacts#delete-an-artifact', [], [], ''),
 ('/repos/{owner}/{repo}/actions/artifacts/{artifact_id}/{archive_format}', 'get', 'actions/download-artifact', 'Download an artifact', 'rest/actions/artifacts#download-an-artifact', [], [], ''),
 ('/repos/{owner}/{repo}/actions/cache/usage', 'get', 'actions/get-actions-cache-usage', 'Get GitHub Actions cache usage for a repository', 'rest/actions/cache#get-github-actions-cache-usage-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/caches', 'get', 'actions/get-actions-cache-list', 'List GitHub Actions caches for a repository', 'rest/actions/cache#list-github-actions-caches-for-a-repository', ['per_page', 'page', 'ref', 'key', 'sort', 'direction'], [], ''),
 ('/repos/{owner}/{repo}/actions/caches', 'delete', 'actions/delete-actions-cache-by-key', 'Delete GitHub Actions caches for a repository (using a cache key)', 'rest/actions/cache#delete-github-actions-caches-for-a-repository-using-a-cache-key', ['key', 'ref'], [], ''),
 ('/repos/{owner}/{repo}/actions/caches/{cache_id}', 'delete', 'actions/delete-actions-cache-by-id', 'Delete a GitHub Actions cache for a repository (using a cache ID)', 'rest/actions/cache#delete-a-github-actions-cache-for-a-repository-using-a-cache-id', [], [], ''),
 ('/repos/{owner}/{repo}/actions/jobs/{job_id}', 'get', 'actions/get-job-for-workflow-run', 'Get a job for a workflow run', 'rest/actions/workflow-jobs#get-a-job-for-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/jobs/{job_id}/logs', 'get', 'actions/download-job-logs-for-workflow-run', 'Download job logs for a workflow run', 'rest/actions/workflow-jobs#download-job-logs-for-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/jobs/{job_id}/rerun', 'post', 'actions/re-run-job-for-workflow-run', 'Re-run a job from a workflow run', 'rest/actions/workflow-runs#re-run-a-job-from-a-workflow-run', [], [['enable_debug_logging', bool, False]], ''),
 ('/repos/{owner}/{repo}/actions/oidc/customization/sub', 'get', 'actions/get-custom-oidc-sub-claim-for-repo', 'Get the customization template for an OIDC subject claim for a repository', 'rest/actions/oidc#get-the-customization-template-for-an-oidc-subject-claim-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/oidc/customization/sub', 'put', 'actions/set-custom-oidc-sub-claim-for-repo', 'Set the customization template for an OIDC subject claim for a repository', 'rest/actions/oidc#set-the-customization-template-for-an-oidc-subject-claim-for-a-repository', [], [['use_default', bool], ['include_claim_keys', list]], ''),
 ('/repos/{owner}/{repo}/actions/organization-secrets', 'get', 'actions/list-repo-organization-secrets', 'List repository organization secrets', 'rest/actions/secrets#list-repository-organization-secrets', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/organization-variables', 'get', 'actions/list-repo-organization-variables', 'List repository organization variables', 'rest/actions/variables#list-repository-organization-variables', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/permissions', 'get', 'actions/get-github-actions-permissions-repository', 'Get GitHub Actions permissions for a repository', 'rest/actions/permissions#get-github-actions-permissions-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/permissions', 'put', 'actions/set-github-actions-permissions-repository', 'Set GitHub Actions permissions for a repository', 'rest/actions/permissions#set-github-actions-permissions-for-a-repository', [], [['enabled', bool], ['allowed_actions', str]], ''),
 ('/repos/{owner}/{repo}/actions/permissions/access', 'get', 'actions/get-workflow-access-to-repository', 'Get the level of access for workflows outside of the repository', 'rest/actions/permissions#get-the-level-of-access-for-workflows-outside-of-the-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/permissions/access', 'put', 'actions/set-workflow-access-to-repository', 'Set the level of access for workflows outside of the repository', 'rest/actions/permissions#set-the-level-of-access-for-workflows-outside-of-the-repository', [], [['access_level', str]], ''),
 ('/repos/{owner}/{repo}/actions/permissions/selected-actions', 'get', 'actions/get-allowed-actions-repository', 'Get allowed actions and reusable workflows for a repository', 'rest/actions/permissions#get-allowed-actions-and-reusable-workflows-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/permissions/selected-actions',
  'put',
  'actions/set-allowed-actions-repository',
  'Set allowed actions and reusable workflows for a repository',
  'rest/actions/permissions#set-allowed-actions-and-reusable-workflows-for-a-repository',
  [],
  [['github_owned_allowed', bool], ['verified_allowed', bool], ['patterns_allowed', list]],
  ''),
 ('/repos/{owner}/{repo}/actions/permissions/workflow', 'get', 'actions/get-github-actions-default-workflow-permissions-repository', 'Get default workflow permissions for a repository', 'rest/actions/permissions#get-default-workflow-permissions-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/permissions/workflow', 'put', 'actions/set-github-actions-default-workflow-permissions-repository', 'Set default workflow permissions for a repository', 'rest/actions/permissions#set-default-workflow-permissions-for-a-repository', [], [['default_workflow_permissions', str], ['can_approve_pull_request_reviews', bool]], ''),
 ('/repos/{owner}/{repo}/actions/runners', 'get', 'actions/list-self-hosted-runners-for-repo', 'List self-hosted runners for a repository', 'rest/actions/self-hosted-runners#list-self-hosted-runners-for-a-repository', ['name', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/downloads', 'get', 'actions/list-runner-applications-for-repo', 'List runner applications for a repository', 'rest/actions/self-hosted-runners#list-runner-applications-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/generate-jitconfig',
  'post',
  'actions/generate-runner-jitconfig-for-repo',
  'Create configuration for a just-in-time runner for a repository',
  'rest/actions/self-hosted-runners#create-configuration-for-a-just-in-time-runner-for-a-repository',
  [],
  [['name', str], ['runner_group_id', int], ['labels', list], ['work_folder', str, '_work']],
  ''),
 ('/repos/{owner}/{repo}/actions/runners/registration-token', 'post', 'actions/create-registration-token-for-repo', 'Create a registration token for a repository', 'rest/actions/self-hosted-runners#create-a-registration-token-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/remove-token', 'post', 'actions/create-remove-token-for-repo', 'Create a remove token for a repository', 'rest/actions/self-hosted-runners#create-a-remove-token-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/{runner_id}', 'get', 'actions/get-self-hosted-runner-for-repo', 'Get a self-hosted runner for a repository', 'rest/actions/self-hosted-runners#get-a-self-hosted-runner-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/{runner_id}', 'delete', 'actions/delete-self-hosted-runner-from-repo', 'Delete a self-hosted runner from a repository', 'rest/actions/self-hosted-runners#delete-a-self-hosted-runner-from-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/{runner_id}/labels', 'get', 'actions/list-labels-for-self-hosted-runner-for-repo', 'List labels for a self-hosted runner for a repository', 'rest/actions/self-hosted-runners#list-labels-for-a-self-hosted-runner-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/{runner_id}/labels', 'post', 'actions/add-custom-labels-to-self-hosted-runner-for-repo', 'Add custom labels to a self-hosted runner for a repository', 'rest/actions/self-hosted-runners#add-custom-labels-to-a-self-hosted-runner-for-a-repository', [], [['labels', list]], ''),
 ('/repos/{owner}/{repo}/actions/runners/{runner_id}/labels', 'put', 'actions/set-custom-labels-for-self-hosted-runner-for-repo', 'Set custom labels for a self-hosted runner for a repository', 'rest/actions/self-hosted-runners#set-custom-labels-for-a-self-hosted-runner-for-a-repository', [], [['labels', list]], ''),
 ('/repos/{owner}/{repo}/actions/runners/{runner_id}/labels', 'delete', 'actions/remove-all-custom-labels-from-self-hosted-runner-for-repo', 'Remove all custom labels from a self-hosted runner for a repository', 'rest/actions/self-hosted-runners#remove-all-custom-labels-from-a-self-hosted-runner-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runners/{runner_id}/labels/{name}', 'delete', 'actions/remove-custom-label-from-self-hosted-runner-for-repo', 'Remove a custom label from a self-hosted runner for a repository', 'rest/actions/self-hosted-runners#remove-a-custom-label-from-a-self-hosted-runner-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs', 'get', 'actions/list-workflow-runs-for-repo', 'List workflow runs for a repository', 'rest/actions/workflow-runs#list-workflow-runs-for-a-repository', ['actor', 'branch', 'event', 'status', 'per_page', 'page', 'created', 'exclude_pull_requests', 'check_suite_id', 'head_sha'], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}', 'get', 'actions/get-workflow-run', 'Get a workflow run', 'rest/actions/workflow-runs#get-a-workflow-run', ['exclude_pull_requests'], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}', 'delete', 'actions/delete-workflow-run', 'Delete a workflow run', 'rest/actions/workflow-runs#delete-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/approvals', 'get', 'actions/get-reviews-for-run', 'Get the review history for a workflow run', 'rest/actions/workflow-runs#get-the-review-history-for-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/approve', 'post', 'actions/approve-workflow-run', 'Approve a workflow run for a fork pull request', 'rest/actions/workflow-runs#approve-a-workflow-run-for-a-fork-pull-request', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/artifacts', 'get', 'actions/list-workflow-run-artifacts', 'List workflow run artifacts', 'rest/actions/artifacts#list-workflow-run-artifacts', ['per_page', 'page', 'name'], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}', 'get', 'actions/get-workflow-run-attempt', 'Get a workflow run attempt', 'rest/actions/workflow-runs#get-a-workflow-run-attempt', ['exclude_pull_requests'], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}/jobs', 'get', 'actions/list-jobs-for-workflow-run-attempt', 'List jobs for a workflow run attempt', 'rest/actions/workflow-jobs#list-jobs-for-a-workflow-run-attempt', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}/logs', 'get', 'actions/download-workflow-run-attempt-logs', 'Download workflow run attempt logs', 'rest/actions/workflow-runs#download-workflow-run-attempt-logs', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/cancel', 'post', 'actions/cancel-workflow-run', 'Cancel a workflow run', 'rest/actions/workflow-runs#cancel-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/deployment_protection_rule', 'post', 'actions/review-custom-gates-for-run', 'Review custom deployment protection rules for a workflow run', 'rest/actions/workflow-runs#review-custom-deployment-protection-rules-for-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/force-cancel', 'post', 'actions/force-cancel-workflow-run', 'Force cancel a workflow run', 'rest/actions/workflow-runs#force-cancel-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/jobs', 'get', 'actions/list-jobs-for-workflow-run', 'List jobs for a workflow run', 'rest/actions/workflow-jobs#list-jobs-for-a-workflow-run', ['filter', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/logs', 'get', 'actions/download-workflow-run-logs', 'Download workflow run logs', 'rest/actions/workflow-runs#download-workflow-run-logs', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/logs', 'delete', 'actions/delete-workflow-run-logs', 'Delete workflow run logs', 'rest/actions/workflow-runs#delete-workflow-run-logs', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments', 'get', 'actions/get-pending-deployments-for-run', 'Get pending deployments for a workflow run', 'rest/actions/workflow-runs#get-pending-deployments-for-a-workflow-run', [], [], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments', 'post', 'actions/review-pending-deployments-for-run', 'Review pending deployments for a workflow run', 'rest/actions/workflow-runs#review-pending-deployments-for-a-workflow-run', [], [['environment_ids', list], ['state', str], ['comment', str]], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/rerun', 'post', 'actions/re-run-workflow', 'Re-run a workflow', 'rest/actions/workflow-runs#re-run-a-workflow', [], [['enable_debug_logging', bool, False]], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/rerun-failed-jobs', 'post', 'actions/re-run-workflow-failed-jobs', 'Re-run failed jobs from a workflow run', 'rest/actions/workflow-runs#re-run-failed-jobs-from-a-workflow-run', [], [['enable_debug_logging', bool, False]], ''),
 ('/repos/{owner}/{repo}/actions/runs/{run_id}/timing', 'get', 'actions/get-workflow-run-usage', 'Get workflow run usage', 'rest/actions/workflow-runs#get-workflow-run-usage', [], [], ''),
 ('/repos/{owner}/{repo}/actions/secrets', 'get', 'actions/list-repo-secrets', 'List repository secrets', 'rest/actions/secrets#list-repository-secrets', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/secrets/public-key', 'get', 'actions/get-repo-public-key', 'Get a repository public key', 'rest/actions/secrets#get-a-repository-public-key', [], [], ''),
 ('/repos/{owner}/{repo}/actions/secrets/{secret_name}', 'get', 'actions/get-repo-secret', 'Get a repository secret', 'rest/actions/secrets#get-a-repository-secret', [], [], ''),
 ('/repos/{owner}/{repo}/actions/secrets/{secret_name}', 'put', 'actions/create-or-update-repo-secret', 'Create or update a repository secret', 'rest/actions/secrets#create-or-update-a-repository-secret', [], [['encrypted_value', str], ['key_id', str]], ''),
 ('/repos/{owner}/{repo}/actions/secrets/{secret_name}', 'delete', 'actions/delete-repo-secret', 'Delete a repository secret', 'rest/actions/secrets#delete-a-repository-secret', [], [], ''),
 ('/repos/{owner}/{repo}/actions/variables', 'get', 'actions/list-repo-variables', 'List repository variables', 'rest/actions/variables#list-repository-variables', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/variables', 'post', 'actions/create-repo-variable', 'Create a repository variable', 'rest/actions/variables#create-a-repository-variable', [], [['name', str], ['value', str]], ''),
 ('/repos/{owner}/{repo}/actions/variables/{name}', 'get', 'actions/get-repo-variable', 'Get a repository variable', 'rest/actions/variables#get-a-repository-variable', [], [], ''),
 ('/repos/{owner}/{repo}/actions/variables/{name}', 'patch', 'actions/update-repo-variable', 'Update a repository variable', 'rest/actions/variables#update-a-repository-variable', [], [['name', str], ['value', str]], ''),
 ('/repos/{owner}/{repo}/actions/variables/{name}', 'delete', 'actions/delete-repo-variable', 'Delete a repository variable', 'rest/actions/variables#delete-a-repository-variable', [], [], ''),
 ('/repos/{owner}/{repo}/actions/workflows', 'get', 'actions/list-repo-workflows', 'List repository workflows', 'rest/actions/workflows#list-repository-workflows', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/actions/workflows/{workflow_id}', 'get', 'actions/get-workflow', 'Get a workflow', 'rest/actions/workflows#get-a-workflow', [], [], ''),
 ('/repos/{owner}/{repo}/actions/workflows/{workflow_id}/disable', 'put', 'actions/disable-workflow', 'Disable a workflow', 'rest/actions/workflows#disable-a-workflow', [], [], ''),
 ('/repos/{owner}/{repo}/actions/workflows/{workflow_id}/dispatches', 'post', 'actions/create-workflow-dispatch', 'Create a workflow dispatch event', 'rest/actions/workflows#create-a-workflow-dispatch-event', [], [['ref', str], ['inputs', dict]], ''),
 ('/repos/{owner}/{repo}/actions/workflows/{workflow_id}/enable', 'put', 'actions/enable-workflow', 'Enable a workflow', 'rest/actions/workflows#enable-a-workflow', [], [], ''),
 ('/repos/{owner}/{repo}/actions/workflows/{workflow_id}/runs', 'get', 'actions/list-workflow-runs', 'List workflow runs for a workflow', 'rest/actions/workflow-runs#list-workflow-runs-for-a-workflow', ['actor', 'branch', 'event', 'status', 'per_page', 'page', 'created', 'exclude_pull_requests', 'check_suite_id', 'head_sha'], [], ''),
 ('/repos/{owner}/{repo}/actions/workflows/{workflow_id}/timing', 'get', 'actions/get-workflow-usage', 'Get workflow usage', 'rest/actions/workflows#get-workflow-usage', [], [], ''),
 ('/repos/{owner}/{repo}/activity', 'get', 'repos/list-activities', 'List repository activities', 'rest/repos/repos#list-repository-activities', ['direction', 'per_page', 'before', 'after', 'ref', 'actor', 'time_period', 'activity_type'], [], ''),
 ('/repos/{owner}/{repo}/assignees', 'get', 'issues/list-assignees', 'List assignees', 'rest/issues/assignees#list-assignees', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/assignees/{assignee}', 'get', 'issues/check-user-can-be-assigned', 'Check if a user can be assigned', 'rest/issues/assignees#check-if-a-user-can-be-assigned', [], [], ''),
 ('/repos/{owner}/{repo}/autolinks', 'get', 'repos/list-autolinks', 'Get all autolinks of a repository', 'rest/repos/autolinks#get-all-autolinks-of-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/autolinks', 'post', 'repos/create-autolink', 'Create an autolink reference for a repository', 'rest/repos/autolinks#create-an-autolink-reference-for-a-repository', [], [['key_prefix', str], ['url_template', str], ['is_alphanumeric', bool, True]], ''),
 ('/repos/{owner}/{repo}/autolinks/{autolink_id}', 'get', 'repos/get-autolink', 'Get an autolink reference of a repository', 'rest/repos/autolinks#get-an-autolink-reference-of-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/autolinks/{autolink_id}', 'delete', 'repos/delete-autolink', 'Delete an autolink reference from a repository', 'rest/repos/autolinks#delete-an-autolink-reference-from-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/automated-security-fixes', 'get', 'repos/check-automated-security-fixes', 'Check if automated security fixes are enabled for a repository', 'rest/repos/repos#check-if-automated-security-fixes-are-enabled-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/automated-security-fixes', 'put', 'repos/enable-automated-security-fixes', 'Enable automated security fixes', 'rest/repos/repos#enable-automated-security-fixes', [], [], ''),
 ('/repos/{owner}/{repo}/automated-security-fixes', 'delete', 'repos/disable-automated-security-fixes', 'Disable automated security fixes', 'rest/repos/repos#disable-automated-security-fixes', [], [], ''),
 ('/repos/{owner}/{repo}/branches', 'get', 'repos/list-branches', 'List branches', 'rest/branches/branches#list-branches', ['protected', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}', 'get', 'repos/get-branch', 'Get a branch', 'rest/branches/branches#get-a-branch', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection', 'get', 'repos/get-branch-protection', 'Get branch protection', 'rest/branches/branch-protection#get-branch-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection',
  'put',
  'repos/update-branch-protection',
  'Update branch protection',
  'rest/branches/branch-protection#update-branch-protection',
  [],
  [['required_status_checks', dict], ['enforce_admins', bool], ['required_pull_request_reviews', dict], ['restrictions', dict], ['required_linear_history', bool], ['allow_force_pushes', bool], ['allow_deletions', bool], ['block_creations', bool], ['required_conversation_resolution', bool], ['lock_branch', bool, False], ['allow_fork_syncing', bool, False]],
  ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection', 'delete', 'repos/delete-branch-protection', 'Delete branch protection', 'rest/branches/branch-protection#delete-branch-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins', 'get', 'repos/get-admin-branch-protection', 'Get admin branch protection', 'rest/branches/branch-protection#get-admin-branch-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins', 'post', 'repos/set-admin-branch-protection', 'Set admin branch protection', 'rest/branches/branch-protection#set-admin-branch-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins', 'delete', 'repos/delete-admin-branch-protection', 'Delete admin branch protection', 'rest/branches/branch-protection#delete-admin-branch-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews', 'get', 'repos/get-pull-request-review-protection', 'Get pull request review protection', 'rest/branches/branch-protection#get-pull-request-review-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews',
  'patch',
  'repos/update-pull-request-review-protection',
  'Update pull request review protection',
  'rest/branches/branch-protection#update-pull-request-review-protection',
  [],
  [['dismissal_restrictions', dict], ['dismiss_stale_reviews', bool], ['require_code_owner_reviews', bool], ['required_approving_review_count', int], ['require_last_push_approval', bool, False], ['bypass_pull_request_allowances', dict]],
  ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews', 'delete', 'repos/delete-pull-request-review-protection', 'Delete pull request review protection', 'rest/branches/branch-protection#delete-pull-request-review-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_signatures', 'get', 'repos/get-commit-signature-protection', 'Get commit signature protection', 'rest/branches/branch-protection#get-commit-signature-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_signatures', 'post', 'repos/create-commit-signature-protection', 'Create commit signature protection', 'rest/branches/branch-protection#create-commit-signature-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_signatures', 'delete', 'repos/delete-commit-signature-protection', 'Delete commit signature protection', 'rest/branches/branch-protection#delete-commit-signature-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks', 'get', 'repos/get-status-checks-protection', 'Get status checks protection', 'rest/branches/branch-protection#get-status-checks-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks', 'patch', 'repos/update-status-check-protection', 'Update status check protection', 'rest/branches/branch-protection#update-status-check-protection', [], [['strict', bool], ['contexts', list], ['checks', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks', 'delete', 'repos/remove-status-check-protection', 'Remove status check protection', 'rest/branches/branch-protection#remove-status-check-protection', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts', 'get', 'repos/get-all-status-check-contexts', 'Get all status check contexts', 'rest/branches/branch-protection#get-all-status-check-contexts', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts', 'post', 'repos/add-status-check-contexts', 'Add status check contexts', 'rest/branches/branch-protection#add-status-check-contexts', [], [['contexts', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts', 'put', 'repos/set-status-check-contexts', 'Set status check contexts', 'rest/branches/branch-protection#set-status-check-contexts', [], [['contexts', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts', 'delete', 'repos/remove-status-check-contexts', 'Remove status check contexts', 'rest/branches/branch-protection#remove-status-check-contexts', [], [['contexts', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions', 'get', 'repos/get-access-restrictions', 'Get access restrictions', 'rest/branches/branch-protection#get-access-restrictions', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions', 'delete', 'repos/delete-access-restrictions', 'Delete access restrictions', 'rest/branches/branch-protection#delete-access-restrictions', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps', 'get', 'repos/get-apps-with-access-to-protected-branch', 'Get apps with access to the protected branch', 'rest/branches/branch-protection#get-apps-with-access-to-the-protected-branch', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps', 'post', 'repos/add-app-access-restrictions', 'Add app access restrictions', 'rest/branches/branch-protection#add-app-access-restrictions', [], [['apps', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps', 'put', 'repos/set-app-access-restrictions', 'Set app access restrictions', 'rest/branches/branch-protection#set-app-access-restrictions', [], [['apps', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps', 'delete', 'repos/remove-app-access-restrictions', 'Remove app access restrictions', 'rest/branches/branch-protection#remove-app-access-restrictions', [], [['apps', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams', 'get', 'repos/get-teams-with-access-to-protected-branch', 'Get teams with access to the protected branch', 'rest/branches/branch-protection#get-teams-with-access-to-the-protected-branch', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams', 'post', 'repos/add-team-access-restrictions', 'Add team access restrictions', 'rest/branches/branch-protection#add-team-access-restrictions', [], [['teams', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams', 'put', 'repos/set-team-access-restrictions', 'Set team access restrictions', 'rest/branches/branch-protection#set-team-access-restrictions', [], [['teams', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams', 'delete', 'repos/remove-team-access-restrictions', 'Remove team access restrictions', 'rest/branches/branch-protection#remove-team-access-restrictions', [], [['teams', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users', 'get', 'repos/get-users-with-access-to-protected-branch', 'Get users with access to the protected branch', 'rest/branches/branch-protection#get-users-with-access-to-the-protected-branch', [], [], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users', 'post', 'repos/add-user-access-restrictions', 'Add user access restrictions', 'rest/branches/branch-protection#add-user-access-restrictions', [], [['users', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users', 'put', 'repos/set-user-access-restrictions', 'Set user access restrictions', 'rest/branches/branch-protection#set-user-access-restrictions', [], [['users', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users', 'delete', 'repos/remove-user-access-restrictions', 'Remove user access restrictions', 'rest/branches/branch-protection#remove-user-access-restrictions', [], [['users', list]], ''),
 ('/repos/{owner}/{repo}/branches/{branch}/rename', 'post', 'repos/rename-branch', 'Rename a branch', 'rest/branches/branches#rename-a-branch', [], [['new_name', str]], ''),
 ('/repos/{owner}/{repo}/check-runs', 'post', 'checks/create', 'Create a check run', 'rest/checks/runs#create-a-check-run', [], [['name', str], ['head_sha', str], ['details_url', str], ['external_id', str], ['status', str, 'queued'], ['started_at', str], ['conclusion', str], ['completed_at', str], ['output', dict], ['actions', list]], ''),
 ('/repos/{owner}/{repo}/check-runs/{check_run_id}', 'get', 'checks/get', 'Get a check run', 'rest/checks/runs#get-a-check-run', [], [], ''),
 ('/repos/{owner}/{repo}/check-runs/{check_run_id}', 'patch', 'checks/update', 'Update a check run', 'rest/checks/runs#update-a-check-run', [], [['name', str], ['details_url', str], ['external_id', str], ['started_at', str], ['status', str], ['conclusion', str], ['completed_at', str], ['output', dict], ['actions', list]], ''),
 ('/repos/{owner}/{repo}/check-runs/{check_run_id}/annotations', 'get', 'checks/list-annotations', 'List check run annotations', 'rest/checks/runs#list-check-run-annotations', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/check-runs/{check_run_id}/rerequest', 'post', 'checks/rerequest-run', 'Rerequest a check run', 'rest/checks/runs#rerequest-a-check-run', [], [], ''),
 ('/repos/{owner}/{repo}/check-suites', 'post', 'checks/create-suite', 'Create a check suite', 'rest/checks/suites#create-a-check-suite', [], [['head_sha', str]], ''),
 ('/repos/{owner}/{repo}/check-suites/preferences', 'patch', 'checks/set-suites-preferences', 'Update repository preferences for check suites', 'rest/checks/suites#update-repository-preferences-for-check-suites', [], [['auto_trigger_checks', list]], ''),
 ('/repos/{owner}/{repo}/check-suites/{check_suite_id}', 'get', 'checks/get-suite', 'Get a check suite', 'rest/checks/suites#get-a-check-suite', [], [], ''),
 ('/repos/{owner}/{repo}/check-suites/{check_suite_id}/check-runs', 'get', 'checks/list-for-suite', 'List check runs in a check suite', 'rest/checks/runs#list-check-runs-in-a-check-suite', ['check_name', 'status', 'filter', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/check-suites/{check_suite_id}/rerequest', 'post', 'checks/rerequest-suite', 'Rerequest a check suite', 'rest/checks/suites#rerequest-a-check-suite', [], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/alerts', 'get', 'code-scanning/list-alerts-for-repo', 'List code scanning alerts for a repository', 'rest/code-scanning/code-scanning#list-code-scanning-alerts-for-a-repository', ['tool_name', 'tool_guid', 'page', 'per_page', 'ref', 'direction', 'sort', 'state', 'severity'], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/alerts/{alert_number}', 'get', 'code-scanning/get-alert', 'Get a code scanning alert', 'rest/code-scanning/code-scanning#get-a-code-scanning-alert', [], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/alerts/{alert_number}', 'patch', 'code-scanning/update-alert', 'Update a code scanning alert', 'rest/code-scanning/code-scanning#update-a-code-scanning-alert', [], [['state', str], ['dismissed_reason', str], ['dismissed_comment', str]], ''),
 ('/repos/{owner}/{repo}/code-scanning/alerts/{alert_number}/instances', 'get', 'code-scanning/list-alert-instances', 'List instances of a code scanning alert', 'rest/code-scanning/code-scanning#list-instances-of-a-code-scanning-alert', ['page', 'per_page', 'ref'], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/analyses', 'get', 'code-scanning/list-recent-analyses', 'List code scanning analyses for a repository', 'rest/code-scanning/code-scanning#list-code-scanning-analyses-for-a-repository', ['tool_name', 'tool_guid', 'page', 'per_page', 'ref', 'sarif_id', 'direction', 'sort'], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/analyses/{analysis_id}', 'get', 'code-scanning/get-analysis', 'Get a code scanning analysis for a repository', 'rest/code-scanning/code-scanning#get-a-code-scanning-analysis-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/analyses/{analysis_id}', 'delete', 'code-scanning/delete-analysis', 'Delete a code scanning analysis from a repository', 'rest/code-scanning/code-scanning#delete-a-code-scanning-analysis-from-a-repository', ['confirm_delete'], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/codeql/databases', 'get', 'code-scanning/list-codeql-databases', 'List CodeQL databases for a repository', 'rest/code-scanning/code-scanning#list-codeql-databases-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/codeql/databases/{language}', 'get', 'code-scanning/get-codeql-database', 'Get a CodeQL database for a repository', 'rest/code-scanning/code-scanning#get-a-codeql-database-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/default-setup', 'get', 'code-scanning/get-default-setup', 'Get a code scanning default setup configuration', 'rest/code-scanning/code-scanning#get-a-code-scanning-default-setup-configuration', [], [], ''),
 ('/repos/{owner}/{repo}/code-scanning/default-setup', 'patch', 'code-scanning/update-default-setup', 'Update a code scanning default setup configuration', 'rest/code-scanning/code-scanning#update-a-code-scanning-default-setup-configuration', [], [['state', str], ['query_suite', str], ['languages', list]], ''),
 ('/repos/{owner}/{repo}/code-scanning/sarifs', 'post', 'code-scanning/upload-sarif', 'Upload an analysis as SARIF data', 'rest/code-scanning/code-scanning#upload-an-analysis-as-sarif-data', [], [['commit_sha', str], ['ref', str], ['sarif', str], ['checkout_uri', str], ['started_at', str], ['tool_name', str], ['validate', bool]], ''),
 ('/repos/{owner}/{repo}/code-scanning/sarifs/{sarif_id}', 'get', 'code-scanning/get-sarif', 'Get information about a SARIF upload', 'rest/code-scanning/code-scanning#get-information-about-a-sarif-upload', [], [], ''),
 ('/repos/{owner}/{repo}/codeowners/errors', 'get', 'repos/codeowners-errors', 'List CODEOWNERS errors', 'rest/repos/repos#list-codeowners-errors', ['ref'], [], ''),
 ('/repos/{owner}/{repo}/codespaces', 'get', 'codespaces/list-in-repository-for-authenticated-user', 'List codespaces in a repository for the authenticated user', 'rest/codespaces/codespaces#list-codespaces-in-a-repository-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/codespaces',
  'post',
  'codespaces/create-with-repo-for-authenticated-user',
  'Create a codespace in a repository',
  'rest/codespaces/codespaces#create-a-codespace-in-a-repository',
  [],
  [['ref', str], ['location', str], ['geo', str], ['client_ip', str], ['machine', str], ['devcontainer_path', str], ['multi_repo_permissions_opt_out', bool], ['working_directory', str], ['idle_timeout_minutes', int], ['display_name', str], ['retention_period_minutes', int]],
  ''),
 ('/repos/{owner}/{repo}/codespaces/devcontainers', 'get', 'codespaces/list-devcontainers-in-repository-for-authenticated-user', 'List devcontainer configurations in a repository for the authenticated user', 'rest/codespaces/codespaces#list-devcontainer-configurations-in-a-repository-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/codespaces/machines', 'get', 'codespaces/repo-machines-for-authenticated-user', 'List available machine types for a repository', 'rest/codespaces/machines#list-available-machine-types-for-a-repository', ['location', 'client_ip', 'ref'], [], ''),
 ('/repos/{owner}/{repo}/codespaces/new', 'get', 'codespaces/pre-flight-with-repo-for-authenticated-user', 'Get default attributes for a codespace', 'rest/codespaces/codespaces#get-default-attributes-for-a-codespace', ['ref', 'client_ip'], [], ''),
 ('/repos/{owner}/{repo}/codespaces/permissions_check',
  'get',
  'codespaces/check-permissions-for-devcontainer',
  'Check if permissions defined by a devcontainer have been accepted by the authenticated user',
  'rest/codespaces/codespaces#check-if-permissions-defined-by-a-devcontainer-have-been-accepted-by-the-authenticated-user',
  ['ref', 'devcontainer_path'],
  [],
  ''),
 ('/repos/{owner}/{repo}/codespaces/secrets', 'get', 'codespaces/list-repo-secrets', 'List repository secrets', 'rest/codespaces/repository-secrets#list-repository-secrets', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/codespaces/secrets/public-key', 'get', 'codespaces/get-repo-public-key', 'Get a repository public key', 'rest/codespaces/repository-secrets#get-a-repository-public-key', [], [], ''),
 ('/repos/{owner}/{repo}/codespaces/secrets/{secret_name}', 'get', 'codespaces/get-repo-secret', 'Get a repository secret', 'rest/codespaces/repository-secrets#get-a-repository-secret', [], [], ''),
 ('/repos/{owner}/{repo}/codespaces/secrets/{secret_name}', 'put', 'codespaces/create-or-update-repo-secret', 'Create or update a repository secret', 'rest/codespaces/repository-secrets#create-or-update-a-repository-secret', [], [['encrypted_value', str], ['key_id', str]], ''),
 ('/repos/{owner}/{repo}/codespaces/secrets/{secret_name}', 'delete', 'codespaces/delete-repo-secret', 'Delete a repository secret', 'rest/codespaces/repository-secrets#delete-a-repository-secret', [], [], ''),
 ('/repos/{owner}/{repo}/collaborators', 'get', 'repos/list-collaborators', 'List repository collaborators', 'rest/collaborators/collaborators#list-repository-collaborators', ['affiliation', 'permission', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/collaborators/{username}', 'get', 'repos/check-collaborator', 'Check if a user is a repository collaborator', 'rest/collaborators/collaborators#check-if-a-user-is-a-repository-collaborator', [], [], ''),
 ('/repos/{owner}/{repo}/collaborators/{username}', 'put', 'repos/add-collaborator', 'Add a repository collaborator', 'rest/collaborators/collaborators#add-a-repository-collaborator', [], [['permission', str, 'push']], ''),
 ('/repos/{owner}/{repo}/collaborators/{username}', 'delete', 'repos/remove-collaborator', 'Remove a repository collaborator', 'rest/collaborators/collaborators#remove-a-repository-collaborator', [], [], ''),
 ('/repos/{owner}/{repo}/collaborators/{username}/permission', 'get', 'repos/get-collaborator-permission-level', 'Get repository permissions for a user', 'rest/collaborators/collaborators#get-repository-permissions-for-a-user', [], [], ''),
 ('/repos/{owner}/{repo}/comments', 'get', 'repos/list-commit-comments-for-repo', 'List commit comments for a repository', 'rest/commits/comments#list-commit-comments-for-a-repository', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/comments/{comment_id}', 'get', 'repos/get-commit-comment', 'Get a commit comment', 'rest/commits/comments#get-a-commit-comment', [], [], ''),
 ('/repos/{owner}/{repo}/comments/{comment_id}', 'patch', 'repos/update-commit-comment', 'Update a commit comment', 'rest/commits/comments#update-a-commit-comment', [], [['body', str]], ''),
 ('/repos/{owner}/{repo}/comments/{comment_id}', 'delete', 'repos/delete-commit-comment', 'Delete a commit comment', 'rest/commits/comments#delete-a-commit-comment', [], [], ''),
 ('/repos/{owner}/{repo}/comments/{comment_id}/reactions', 'get', 'reactions/list-for-commit-comment', 'List reactions for a commit comment', 'rest/reactions/reactions#list-reactions-for-a-commit-comment', ['content', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/comments/{comment_id}/reactions', 'post', 'reactions/create-for-commit-comment', 'Create reaction for a commit comment', 'rest/reactions/reactions#create-reaction-for-a-commit-comment', [], [['content', str]], ''),
 ('/repos/{owner}/{repo}/comments/{comment_id}/reactions/{reaction_id}', 'delete', 'reactions/delete-for-commit-comment', 'Delete a commit comment reaction', 'rest/reactions/reactions#delete-a-commit-comment-reaction', [], [], ''),
 ('/repos/{owner}/{repo}/commits', 'get', 'repos/list-commits', 'List commits', 'rest/commits/commits#list-commits', ['sha', 'path', 'author', 'committer', 'since', 'until', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/commits/{commit_sha}/branches-where-head', 'get', 'repos/list-branches-for-head-commit', 'List branches for HEAD commit', 'rest/commits/commits#list-branches-for-head-commit', [], [], ''),
 ('/repos/{owner}/{repo}/commits/{commit_sha}/comments', 'get', 'repos/list-comments-for-commit', 'List commit comments', 'rest/commits/comments#list-commit-comments', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/commits/{commit_sha}/comments', 'post', 'repos/create-commit-comment', 'Create a commit comment', 'rest/commits/comments#create-a-commit-comment', [], [['body', str], ['path', str], ['position', int], ['line', int]], ''),
 ('/repos/{owner}/{repo}/commits/{commit_sha}/pulls', 'get', 'repos/list-pull-requests-associated-with-commit', 'List pull requests associated with a commit', 'rest/commits/commits#list-pull-requests-associated-with-a-commit', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/commits/{ref}', 'get', 'repos/get-commit', 'Get a commit', 'rest/commits/commits#get-a-commit', ['page', 'per_page'], [], ''),
 ('/repos/{owner}/{repo}/commits/{ref}/check-runs', 'get', 'checks/list-for-ref', 'List check runs for a Git reference', 'rest/checks/runs#list-check-runs-for-a-git-reference', ['check_name', 'status', 'filter', 'per_page', 'page', 'app_id'], [], ''),
 ('/repos/{owner}/{repo}/commits/{ref}/check-suites', 'get', 'checks/list-suites-for-ref', 'List check suites for a Git reference', 'rest/checks/suites#list-check-suites-for-a-git-reference', ['app_id', 'check_name', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/commits/{ref}/status', 'get', 'repos/get-combined-status-for-ref', 'Get the combined status for a specific reference', 'rest/commits/statuses#get-the-combined-status-for-a-specific-reference', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/commits/{ref}/statuses', 'get', 'repos/list-commit-statuses-for-ref', 'List commit statuses for a reference', 'rest/commits/statuses#list-commit-statuses-for-a-reference', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/community/profile', 'get', 'repos/get-community-profile-metrics', 'Get community profile metrics', 'rest/metrics/community#get-community-profile-metrics', [], [], ''),
 ('/repos/{owner}/{repo}/compare/{basehead}', 'get', 'repos/compare-commits', 'Compare two commits', 'rest/commits/commits#compare-two-commits', ['page', 'per_page'], [], ''),
 ('/repos/{owner}/{repo}/contents/{path}', 'get', 'repos/get-content', 'Get repository content', 'rest/repos/contents#get-repository-content', ['ref'], [], ''),
 ('/repos/{owner}/{repo}/contents/{path}', 'put', 'repos/create-or-update-file-contents', 'Create or update file contents', 'rest/repos/contents#create-or-update-file-contents', [], [['message', str], ['content', str], ['sha', str], ['branch', str], ['committer', dict], ['author', dict]], ''),
 ('/repos/{owner}/{repo}/contents/{path}', 'delete', 'repos/delete-file', 'Delete a file', 'rest/repos/contents#delete-a-file', [], [['message', str], ['sha', str], ['branch', str], ['committer', dict], ['author', dict]], ''),
 ('/repos/{owner}/{repo}/contributors', 'get', 'repos/list-contributors', 'List repository contributors', 'rest/repos/repos#list-repository-contributors', ['anon', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/dependabot/alerts', 'get', 'dependabot/list-alerts-for-repo', 'List Dependabot alerts for a repository', 'rest/dependabot/alerts#list-dependabot-alerts-for-a-repository', ['state', 'severity', 'ecosystem', 'package', 'manifest', 'scope', 'sort', 'direction', 'page', 'per_page', 'before', 'after', 'first', 'last'], [], ''),
 ('/repos/{owner}/{repo}/dependabot/alerts/{alert_number}', 'get', 'dependabot/get-alert', 'Get a Dependabot alert', 'rest/dependabot/alerts#get-a-dependabot-alert', [], [], ''),
 ('/repos/{owner}/{repo}/dependabot/alerts/{alert_number}', 'patch', 'dependabot/update-alert', 'Update a Dependabot alert', 'rest/dependabot/alerts#update-a-dependabot-alert', [], [['state', str], ['dismissed_reason', str], ['dismissed_comment', str]], ''),
 ('/repos/{owner}/{repo}/dependabot/secrets', 'get', 'dependabot/list-repo-secrets', 'List repository secrets', 'rest/dependabot/secrets#list-repository-secrets', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/dependabot/secrets/public-key', 'get', 'dependabot/get-repo-public-key', 'Get a repository public key', 'rest/dependabot/secrets#get-a-repository-public-key', [], [], ''),
 ('/repos/{owner}/{repo}/dependabot/secrets/{secret_name}', 'get', 'dependabot/get-repo-secret', 'Get a repository secret', 'rest/dependabot/secrets#get-a-repository-secret', [], [], ''),
 ('/repos/{owner}/{repo}/dependabot/secrets/{secret_name}', 'put', 'dependabot/create-or-update-repo-secret', 'Create or update a repository secret', 'rest/dependabot/secrets#create-or-update-a-repository-secret', [], [['encrypted_value', str], ['key_id', str]], ''),
 ('/repos/{owner}/{repo}/dependabot/secrets/{secret_name}', 'delete', 'dependabot/delete-repo-secret', 'Delete a repository secret', 'rest/dependabot/secrets#delete-a-repository-secret', [], [], ''),
 ('/repos/{owner}/{repo}/dependency-graph/compare/{basehead}', 'get', 'dependency-graph/diff-range', 'Get a diff of the dependencies between commits', 'rest/dependency-graph/dependency-review#get-a-diff-of-the-dependencies-between-commits', ['name'], [], ''),
 ('/repos/{owner}/{repo}/dependency-graph/sbom', 'get', 'dependency-graph/export-sbom', 'Export a software bill of materials (SBOM) for a repository.', 'rest/dependency-graph/sboms#export-a-software-bill-of-materials-sbom-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/dependency-graph/snapshots',
  'post',
  'dependency-graph/create-repository-snapshot',
  'Create a snapshot of dependencies for a repository',
  'rest/dependency-graph/dependency-submission#create-a-snapshot-of-dependencies-for-a-repository',
  [],
  [['version', int], ['job', dict], ['sha', str], ['ref', str], ['detector', dict], ['metadata', dict], ['manifests', dict], ['scanned', str]],
  ''),
 ('/repos/{owner}/{repo}/deployments', 'get', 'repos/list-deployments', 'List deployments', 'rest/deployments/deployments#list-deployments', ['sha', 'ref', 'task', 'environment', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/deployments',
  'post',
  'repos/create-deployment',
  'Create a deployment',
  'rest/deployments/deployments#create-a-deployment',
  [],
  [['ref', str], ['task', str, 'deploy'], ['auto_merge', bool, True], ['required_contexts', list], ['payload', object], ['environment', str, 'production'], ['description', str, ''], ['transient_environment', bool, False], ['production_environment', bool]],
  ''),
 ('/repos/{owner}/{repo}/deployments/{deployment_id}', 'get', 'repos/get-deployment', 'Get a deployment', 'rest/deployments/deployments#get-a-deployment', [], [], ''),
 ('/repos/{owner}/{repo}/deployments/{deployment_id}', 'delete', 'repos/delete-deployment', 'Delete a deployment', 'rest/deployments/deployments#delete-a-deployment', [], [], ''),
 ('/repos/{owner}/{repo}/deployments/{deployment_id}/statuses', 'get', 'repos/list-deployment-statuses', 'List deployment statuses', 'rest/deployments/statuses#list-deployment-statuses', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/deployments/{deployment_id}/statuses',
  'post',
  'repos/create-deployment-status',
  'Create a deployment status',
  'rest/deployments/statuses#create-a-deployment-status',
  [],
  [['state', str], ['target_url', str, ''], ['log_url', str, ''], ['description', str, ''], ['environment', str], ['environment_url', str, ''], ['auto_inactive', bool]],
  ''),
 ('/repos/{owner}/{repo}/deployments/{deployment_id}/statuses/{status_id}', 'get', 'repos/get-deployment-status', 'Get a deployment status', 'rest/deployments/statuses#get-a-deployment-status', [], [], ''),
 ('/repos/{owner}/{repo}/dispatches', 'post', 'repos/create-dispatch-event', 'Create a repository dispatch event', 'rest/repos/repos#create-a-repository-dispatch-event', [], [['event_type', str], ['client_payload', dict]], ''),
 ('/repos/{owner}/{repo}/environments', 'get', 'repos/get-all-environments', 'List environments', 'rest/deployments/environments#list-environments', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}', 'get', 'repos/get-environment', 'Get an environment', 'rest/deployments/environments#get-an-environment', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}', 'put', 'repos/create-or-update-environment', 'Create or update an environment', 'rest/deployments/environments#create-or-update-an-environment', [], [['wait_timer', int], ['prevent_self_review', bool], ['reviewers', list], ['deployment_branch_policy', dict]], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}', 'delete', 'repos/delete-an-environment', 'Delete an environment', 'rest/deployments/environments#delete-an-environment', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment-branch-policies', 'get', 'repos/list-deployment-branch-policies', 'List deployment branch policies', 'rest/deployments/branch-policies#list-deployment-branch-policies', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment-branch-policies', 'post', 'repos/create-deployment-branch-policy', 'Create a deployment branch policy', 'rest/deployments/branch-policies#create-a-deployment-branch-policy', [], [['name', str], ['type', str]], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment-branch-policies/{branch_policy_id}', 'get', 'repos/get-deployment-branch-policy', 'Get a deployment branch policy', 'rest/deployments/branch-policies#get-a-deployment-branch-policy', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment-branch-policies/{branch_policy_id}', 'put', 'repos/update-deployment-branch-policy', 'Update a deployment branch policy', 'rest/deployments/branch-policies#update-a-deployment-branch-policy', [], [['name', str]], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment-branch-policies/{branch_policy_id}', 'delete', 'repos/delete-deployment-branch-policy', 'Delete a deployment branch policy', 'rest/deployments/branch-policies#delete-a-deployment-branch-policy', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules', 'get', 'repos/get-all-deployment-protection-rules', 'Get all deployment protection rules for an environment', 'rest/deployments/protection-rules#get-all-deployment-protection-rules-for-an-environment', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules', 'post', 'repos/create-deployment-protection-rule', 'Create a custom deployment protection rule on an environment', 'rest/deployments/protection-rules#create-a-custom-deployment-protection-rule-on-an-environment', [], [['integration_id', int]], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules/apps', 'get', 'repos/list-custom-deployment-rule-integrations', 'List custom deployment rule integrations available for an environment', 'rest/deployments/protection-rules#list-custom-deployment-rule-integrations-available-for-an-environment', ['page', 'per_page'], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules/{protection_rule_id}', 'get', 'repos/get-custom-deployment-protection-rule', 'Get a custom deployment protection rule', 'rest/deployments/protection-rules#get-a-custom-deployment-protection-rule', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules/{protection_rule_id}', 'delete', 'repos/disable-deployment-protection-rule', 'Disable a custom protection rule for an environment', 'rest/deployments/protection-rules#disable-a-custom-protection-rule-for-an-environment', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/secrets', 'get', 'actions/list-environment-secrets', 'List environment secrets', 'rest/actions/secrets#list-environment-secrets', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/secrets/public-key', 'get', 'actions/get-environment-public-key', 'Get an environment public key', 'rest/actions/secrets#get-an-environment-public-key', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/secrets/{secret_name}', 'get', 'actions/get-environment-secret', 'Get an environment secret', 'rest/actions/secrets#get-an-environment-secret', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/secrets/{secret_name}', 'put', 'actions/create-or-update-environment-secret', 'Create or update an environment secret', 'rest/actions/secrets#create-or-update-an-environment-secret', [], [['encrypted_value', str], ['key_id', str]], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/secrets/{secret_name}', 'delete', 'actions/delete-environment-secret', 'Delete an environment secret', 'rest/actions/secrets#delete-an-environment-secret', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/variables', 'get', 'actions/list-environment-variables', 'List environment variables', 'rest/actions/variables#list-environment-variables', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/variables', 'post', 'actions/create-environment-variable', 'Create an environment variable', 'rest/actions/variables#create-an-environment-variable', [], [['name', str], ['value', str]], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/variables/{name}', 'get', 'actions/get-environment-variable', 'Get an environment variable', 'rest/actions/variables#get-an-environment-variable', [], [], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/variables/{name}', 'patch', 'actions/update-environment-variable', 'Update an environment variable', 'rest/actions/variables#update-an-environment-variable', [], [['name', str], ['value', str]], ''),
 ('/repos/{owner}/{repo}/environments/{environment_name}/variables/{name}', 'delete', 'actions/delete-environment-variable', 'Delete an environment variable', 'rest/actions/variables#delete-an-environment-variable', [], [], ''),
 ('/repos/{owner}/{repo}/events', 'get', 'activity/list-repo-events', 'List repository events', 'rest/activity/events#list-repository-events', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/forks', 'get', 'repos/list-forks', 'List forks', 'rest/repos/forks#list-forks', ['sort', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/forks', 'post', 'repos/create-fork', 'Create a fork', 'rest/repos/forks#create-a-fork', [], [['organization', str], ['name', str], ['default_branch_only', bool]], ''),
 ('/repos/{owner}/{repo}/git/blobs', 'post', 'git/create-blob', 'Create a blob', 'rest/git/blobs#create-a-blob', [], [['content', str], ['encoding', str, 'utf-8']], ''),
 ('/repos/{owner}/{repo}/git/blobs/{file_sha}', 'get', 'git/get-blob', 'Get a blob', 'rest/git/blobs#get-a-blob', [], [], ''),
 ('/repos/{owner}/{repo}/git/commits', 'post', 'git/create-commit', 'Create a commit', 'rest/git/commits#create-a-commit', [], [['message', str], ['tree', str], ['parents', list], ['author', dict], ['committer', dict], ['signature', str]], ''),
 ('/repos/{owner}/{repo}/git/commits/{commit_sha}', 'get', 'git/get-commit', 'Get a commit object', 'rest/git/commits#get-a-commit-object', [], [], ''),
 ('/repos/{owner}/{repo}/git/matching-refs/{ref}', 'get', 'git/list-matching-refs', 'List matching references', 'rest/git/refs#list-matching-references', [], [], ''),
 ('/repos/{owner}/{repo}/git/ref/{ref}', 'get', 'git/get-ref', 'Get a reference', 'rest/git/refs#get-a-reference', [], [], ''),
 ('/repos/{owner}/{repo}/git/refs', 'post', 'git/create-ref', 'Create a reference', 'rest/git/refs#create-a-reference', [], [['ref', str], ['sha', str]], ''),
 ('/repos/{owner}/{repo}/git/refs/{ref}', 'patch', 'git/update-ref', 'Update a reference', 'rest/git/refs#update-a-reference', [], [['sha', str], ['force', bool, False]], ''),
 ('/repos/{owner}/{repo}/git/refs/{ref}', 'delete', 'git/delete-ref', 'Delete a reference', 'rest/git/refs#delete-a-reference', [], [], ''),
 ('/repos/{owner}/{repo}/git/tags', 'post', 'git/create-tag', 'Create a tag object', 'rest/git/tags#create-a-tag-object', [], [['tag', str], ['message', str], ['object', str], ['type', str], ['tagger', dict]], ''),
 ('/repos/{owner}/{repo}/git/tags/{tag_sha}', 'get', 'git/get-tag', 'Get a tag', 'rest/git/tags#get-a-tag', [], [], ''),
 ('/repos/{owner}/{repo}/git/trees', 'post', 'git/create-tree', 'Create a tree', 'rest/git/trees#create-a-tree', [], [['tree', list], ['base_tree', str]], ''),
 ('/repos/{owner}/{repo}/git/trees/{tree_sha}', 'get', 'git/get-tree', 'Get a tree', 'rest/git/trees#get-a-tree', ['recursive'], [], ''),
 ('/repos/{owner}/{repo}/hooks', 'get', 'repos/list-webhooks', 'List repository webhooks', 'rest/repos/webhooks#list-repository-webhooks', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/hooks', 'post', 'repos/create-webhook', 'Create a repository webhook', 'rest/repos/webhooks#create-a-repository-webhook', [], [['name', str], ['config', dict], ['events', list, ['push']], ['active', bool, True]], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}', 'get', 'repos/get-webhook', 'Get a repository webhook', 'rest/repos/webhooks#get-a-repository-webhook', [], [], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}', 'patch', 'repos/update-webhook', 'Update a repository webhook', 'rest/repos/webhooks#update-a-repository-webhook', [], [['config', dict], ['events', list, ['push']], ['add_events', list], ['remove_events', list], ['active', bool, True]], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}', 'delete', 'repos/delete-webhook', 'Delete a repository webhook', 'rest/repos/webhooks#delete-a-repository-webhook', [], [], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}/config', 'get', 'repos/get-webhook-config-for-repo', 'Get a webhook configuration for a repository', 'rest/repos/webhooks#get-a-webhook-configuration-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}/config', 'patch', 'repos/update-webhook-config-for-repo', 'Update a webhook configuration for a repository', 'rest/repos/webhooks#update-a-webhook-configuration-for-a-repository', [], [['url', str], ['content_type', str], ['secret', str], ['insecure_ssl', object]], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}/deliveries', 'get', 'repos/list-webhook-deliveries', 'List deliveries for a repository webhook', 'rest/repos/webhooks#list-deliveries-for-a-repository-webhook', ['per_page', 'cursor', 'redelivery'], [], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}', 'get', 'repos/get-webhook-delivery', 'Get a delivery for a repository webhook', 'rest/repos/webhooks#get-a-delivery-for-a-repository-webhook', [], [], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}/attempts', 'post', 'repos/redeliver-webhook-delivery', 'Redeliver a delivery for a repository webhook', 'rest/repos/webhooks#redeliver-a-delivery-for-a-repository-webhook', [], [], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}/pings', 'post', 'repos/ping-webhook', 'Ping a repository webhook', 'rest/repos/webhooks#ping-a-repository-webhook', [], [], ''),
 ('/repos/{owner}/{repo}/hooks/{hook_id}/tests', 'post', 'repos/test-push-webhook', 'Test the push repository webhook', 'rest/repos/webhooks#test-the-push-repository-webhook', [], [], ''),
 ('/repos/{owner}/{repo}/import', 'get', 'migrations/get-import-status', 'Get an import status', 'rest/migrations/source-imports#get-an-import-status', [], [], ''),
 ('/repos/{owner}/{repo}/import', 'put', 'migrations/start-import', 'Start an import', 'rest/migrations/source-imports#start-an-import', [], [['vcs_url', str], ['vcs', str], ['vcs_username', str], ['vcs_password', str], ['tfvc_project', str]], ''),
 ('/repos/{owner}/{repo}/import', 'patch', 'migrations/update-import', 'Update an import', 'rest/migrations/source-imports#update-an-import', [], [['vcs_username', str], ['vcs_password', str], ['vcs', str], ['tfvc_project', str]], ''),
 ('/repos/{owner}/{repo}/import', 'delete', 'migrations/cancel-import', 'Cancel an import', 'rest/migrations/source-imports#cancel-an-import', [], [], ''),
 ('/repos/{owner}/{repo}/import/authors', 'get', 'migrations/get-commit-authors', 'Get commit authors', 'rest/migrations/source-imports#get-commit-authors', ['since'], [], ''),
 ('/repos/{owner}/{repo}/import/authors/{author_id}', 'patch', 'migrations/map-commit-author', 'Map a commit author', 'rest/migrations/source-imports#map-a-commit-author', [], [['email', str], ['name', str]], ''),
 ('/repos/{owner}/{repo}/import/large_files', 'get', 'migrations/get-large-files', 'Get large files', 'rest/migrations/source-imports#get-large-files', [], [], ''),
 ('/repos/{owner}/{repo}/import/lfs', 'patch', 'migrations/set-lfs-preference', 'Update Git LFS preference', 'rest/migrations/source-imports#update-git-lfs-preference', [], [['use_lfs', str]], ''),
 ('/repos/{owner}/{repo}/installation', 'get', 'apps/get-repo-installation', 'Get a repository installation for the authenticated app', 'rest/apps/apps#get-a-repository-installation-for-the-authenticated-app', [], [], ''),
 ('/repos/{owner}/{repo}/interaction-limits', 'get', 'interactions/get-restrictions-for-repo', 'Get interaction restrictions for a repository', 'rest/interactions/repos#get-interaction-restrictions-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/interaction-limits', 'put', 'interactions/set-restrictions-for-repo', 'Set interaction restrictions for a repository', 'rest/interactions/repos#set-interaction-restrictions-for-a-repository', [], [['limit', str], ['expiry', str]], ''),
 ('/repos/{owner}/{repo}/interaction-limits', 'delete', 'interactions/remove-restrictions-for-repo', 'Remove interaction restrictions for a repository', 'rest/interactions/repos#remove-interaction-restrictions-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/invitations', 'get', 'repos/list-invitations', 'List repository invitations', 'rest/collaborators/invitations#list-repository-invitations', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/invitations/{invitation_id}', 'patch', 'repos/update-invitation', 'Update a repository invitation', 'rest/collaborators/invitations#update-a-repository-invitation', [], [['permissions', str]], ''),
 ('/repos/{owner}/{repo}/invitations/{invitation_id}', 'delete', 'repos/delete-invitation', 'Delete a repository invitation', 'rest/collaborators/invitations#delete-a-repository-invitation', [], [], ''),
 ('/repos/{owner}/{repo}/issues', 'get', 'issues/list-for-repo', 'List repository issues', 'rest/issues/issues#list-repository-issues', ['milestone', 'state', 'assignee', 'creator', 'mentioned', 'labels', 'sort', 'direction', 'since', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues', 'post', 'issues/create', 'Create an issue', 'rest/issues/issues#create-an-issue', [], [['title', object], ['body', str], ['assignee', str], ['milestone', object], ['labels', list], ['assignees', list]], ''),
 ('/repos/{owner}/{repo}/issues/comments', 'get', 'issues/list-comments-for-repo', 'List issue comments for a repository', 'rest/issues/comments#list-issue-comments-for-a-repository', ['sort', 'direction', 'since', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues/comments/{comment_id}', 'get', 'issues/get-comment', 'Get an issue comment', 'rest/issues/comments#get-an-issue-comment', [], [], ''),
 ('/repos/{owner}/{repo}/issues/comments/{comment_id}', 'patch', 'issues/update-comment', 'Update an issue comment', 'rest/issues/comments#update-an-issue-comment', [], [['body', str]], ''),
 ('/repos/{owner}/{repo}/issues/comments/{comment_id}', 'delete', 'issues/delete-comment', 'Delete an issue comment', 'rest/issues/comments#delete-an-issue-comment', [], [], ''),
 ('/repos/{owner}/{repo}/issues/comments/{comment_id}/reactions', 'get', 'reactions/list-for-issue-comment', 'List reactions for an issue comment', 'rest/reactions/reactions#list-reactions-for-an-issue-comment', ['content', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues/comments/{comment_id}/reactions', 'post', 'reactions/create-for-issue-comment', 'Create reaction for an issue comment', 'rest/reactions/reactions#create-reaction-for-an-issue-comment', [], [['content', str]], ''),
 ('/repos/{owner}/{repo}/issues/comments/{comment_id}/reactions/{reaction_id}', 'delete', 'reactions/delete-for-issue-comment', 'Delete an issue comment reaction', 'rest/reactions/reactions#delete-an-issue-comment-reaction', [], [], ''),
 ('/repos/{owner}/{repo}/issues/events', 'get', 'issues/list-events-for-repo', 'List issue events for a repository', 'rest/issues/events#list-issue-events-for-a-repository', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues/events/{event_id}', 'get', 'issues/get-event', 'Get an issue event', 'rest/issues/events#get-an-issue-event', [], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}', 'get', 'issues/get', 'Get an issue', 'rest/issues/issues#get-an-issue', [], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}', 'patch', 'issues/update', 'Update an issue', 'rest/issues/issues#update-an-issue', [], [['title', object], ['body', str], ['assignee', str], ['state', str], ['state_reason', str], ['milestone', object], ['labels', list], ['assignees', list]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/assignees', 'post', 'issues/add-assignees', 'Add assignees to an issue', 'rest/issues/assignees#add-assignees-to-an-issue', [], [['assignees', list]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/assignees', 'delete', 'issues/remove-assignees', 'Remove assignees from an issue', 'rest/issues/assignees#remove-assignees-from-an-issue', [], [['assignees', list]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/assignees/{assignee}', 'get', 'issues/check-user-can-be-assigned-to-issue', 'Check if a user can be assigned to a issue', 'rest/issues/assignees#check-if-a-user-can-be-assigned-to-a-issue', [], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/comments', 'get', 'issues/list-comments', 'List issue comments', 'rest/issues/comments#list-issue-comments', ['since', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/comments', 'post', 'issues/create-comment', 'Create an issue comment', 'rest/issues/comments#create-an-issue-comment', [], [['body', str]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/events', 'get', 'issues/list-events', 'List issue events', 'rest/issues/events#list-issue-events', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/labels', 'get', 'issues/list-labels-on-issue', 'List labels for an issue', 'rest/issues/labels#list-labels-for-an-issue', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/labels', 'post', 'issues/add-labels', 'Add labels to an issue', 'rest/issues/labels#add-labels-to-an-issue', [], [['labels', list]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/labels', 'put', 'issues/set-labels', 'Set labels for an issue', 'rest/issues/labels#set-labels-for-an-issue', [], [['labels', list]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/labels', 'delete', 'issues/remove-all-labels', 'Remove all labels from an issue', 'rest/issues/labels#remove-all-labels-from-an-issue', [], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/labels/{name}', 'delete', 'issues/remove-label', 'Remove a label from an issue', 'rest/issues/labels#remove-a-label-from-an-issue', [], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/lock', 'put', 'issues/lock', 'Lock an issue', 'rest/issues/issues#lock-an-issue', [], [['lock_reason', str]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/lock', 'delete', 'issues/unlock', 'Unlock an issue', 'rest/issues/issues#unlock-an-issue', [], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/reactions', 'get', 'reactions/list-for-issue', 'List reactions for an issue', 'rest/reactions/reactions#list-reactions-for-an-issue', ['content', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/reactions', 'post', 'reactions/create-for-issue', 'Create reaction for an issue', 'rest/reactions/reactions#create-reaction-for-an-issue', [], [['content', str]], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/reactions/{reaction_id}', 'delete', 'reactions/delete-for-issue', 'Delete an issue reaction', 'rest/reactions/reactions#delete-an-issue-reaction', [], [], ''),
 ('/repos/{owner}/{repo}/issues/{issue_number}/timeline', 'get', 'issues/list-events-for-timeline', 'List timeline events for an issue', 'rest/issues/timeline#list-timeline-events-for-an-issue', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/keys', 'get', 'repos/list-deploy-keys', 'List deploy keys', 'rest/deploy-keys/deploy-keys#list-deploy-keys', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/keys', 'post', 'repos/create-deploy-key', 'Create a deploy key', 'rest/deploy-keys/deploy-keys#create-a-deploy-key', [], [['title', str], ['key', str], ['read_only', bool]], ''),
 ('/repos/{owner}/{repo}/keys/{key_id}', 'get', 'repos/get-deploy-key', 'Get a deploy key', 'rest/deploy-keys/deploy-keys#get-a-deploy-key', [], [], ''),
 ('/repos/{owner}/{repo}/keys/{key_id}', 'delete', 'repos/delete-deploy-key', 'Delete a deploy key', 'rest/deploy-keys/deploy-keys#delete-a-deploy-key', [], [], ''),
 ('/repos/{owner}/{repo}/labels', 'get', 'issues/list-labels-for-repo', 'List labels for a repository', 'rest/issues/labels#list-labels-for-a-repository', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/labels', 'post', 'issues/create-label', 'Create a label', 'rest/issues/labels#create-a-label', [], [['name', str], ['color', str], ['description', str]], ''),
 ('/repos/{owner}/{repo}/labels/{name}', 'get', 'issues/get-label', 'Get a label', 'rest/issues/labels#get-a-label', [], [], ''),
 ('/repos/{owner}/{repo}/labels/{name}', 'patch', 'issues/update-label', 'Update a label', 'rest/issues/labels#update-a-label', [], [['new_name', str], ['color', str], ['description', str]], ''),
 ('/repos/{owner}/{repo}/labels/{name}', 'delete', 'issues/delete-label', 'Delete a label', 'rest/issues/labels#delete-a-label', [], [], ''),
 ('/repos/{owner}/{repo}/languages', 'get', 'repos/list-languages', 'List repository languages', 'rest/repos/repos#list-repository-languages', [], [], ''),
 ('/repos/{owner}/{repo}/license', 'get', 'licenses/get-for-repo', 'Get the license for a repository', 'rest/licenses/licenses#get-the-license-for-a-repository', ['ref'], [], ''),
 ('/repos/{owner}/{repo}/merge-upstream', 'post', 'repos/merge-upstream', 'Sync a fork branch with the upstream repository', 'rest/branches/branches#sync-a-fork-branch-with-the-upstream-repository', [], [['branch', str]], ''),
 ('/repos/{owner}/{repo}/merges', 'post', 'repos/merge', 'Merge a branch', 'rest/branches/branches#merge-a-branch', [], [['base', str], ['head', str], ['commit_message', str]], ''),
 ('/repos/{owner}/{repo}/milestones', 'get', 'issues/list-milestones', 'List milestones', 'rest/issues/milestones#list-milestones', ['state', 'sort', 'direction', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/milestones', 'post', 'issues/create-milestone', 'Create a milestone', 'rest/issues/milestones#create-a-milestone', [], [['title', str], ['state', str, 'open'], ['description', str], ['due_on', str]], ''),
 ('/repos/{owner}/{repo}/milestones/{milestone_number}', 'get', 'issues/get-milestone', 'Get a milestone', 'rest/issues/milestones#get-a-milestone', [], [], ''),
 ('/repos/{owner}/{repo}/milestones/{milestone_number}', 'patch', 'issues/update-milestone', 'Update a milestone', 'rest/issues/milestones#update-a-milestone', [], [['title', str], ['state', str, 'open'], ['description', str], ['due_on', str]], ''),
 ('/repos/{owner}/{repo}/milestones/{milestone_number}', 'delete', 'issues/delete-milestone', 'Delete a milestone', 'rest/issues/milestones#delete-a-milestone', [], [], ''),
 ('/repos/{owner}/{repo}/milestones/{milestone_number}/labels', 'get', 'issues/list-labels-for-milestone', 'List labels for issues in a milestone', 'rest/issues/labels#list-labels-for-issues-in-a-milestone', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/notifications', 'get', 'activity/list-repo-notifications-for-authenticated-user', 'List repository notifications for the authenticated user', 'rest/activity/notifications#list-repository-notifications-for-the-authenticated-user', ['all', 'participating', 'since', 'before', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/notifications', 'put', 'activity/mark-repo-notifications-as-read', 'Mark repository notifications as read', 'rest/activity/notifications#mark-repository-notifications-as-read', [], [['last_read_at', str]], ''),
 ('/repos/{owner}/{repo}/pages', 'get', 'repos/get-pages', 'Get a GitHub Pages site', 'rest/pages/pages#get-a-apiname-pages-site', [], [], ''),
 ('/repos/{owner}/{repo}/pages', 'post', 'repos/create-pages-site', 'Create a GitHub Pages site', 'rest/pages/pages#create-a-apiname-pages-site', [], [['build_type', str], ['source', dict]], ''),
 ('/repos/{owner}/{repo}/pages', 'put', 'repos/update-information-about-pages-site', 'Update information about a GitHub Pages site', 'rest/pages/pages#update-information-about-a-apiname-pages-site', [], [['cname', str], ['https_enforced', bool], ['build_type', str], ['source', object]], ''),
 ('/repos/{owner}/{repo}/pages', 'delete', 'repos/delete-pages-site', 'Delete a GitHub Pages site', 'rest/pages/pages#delete-a-apiname-pages-site', [], [], ''),
 ('/repos/{owner}/{repo}/pages/builds', 'get', 'repos/list-pages-builds', 'List GitHub Pages builds', 'rest/pages/pages#list-apiname-pages-builds', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pages/builds', 'post', 'repos/request-pages-build', 'Request a GitHub Pages build', 'rest/pages/pages#request-a-apiname-pages-build', [], [], ''),
 ('/repos/{owner}/{repo}/pages/builds/latest', 'get', 'repos/get-latest-pages-build', 'Get latest Pages build', 'rest/pages/pages#get-latest-pages-build', [], [], ''),
 ('/repos/{owner}/{repo}/pages/builds/{build_id}', 'get', 'repos/get-pages-build', 'Get GitHub Pages build', 'rest/pages/pages#get-apiname-pages-build', [], [], ''),
 ('/repos/{owner}/{repo}/pages/deployments', 'post', 'repos/create-pages-deployment', 'Create a GitHub Pages deployment', 'rest/pages/pages#create-a-github-pages-deployment', [], [['artifact_id', int], ['artifact_url', str], ['environment', str, 'github-pages'], ['pages_build_version', str, 'GITHUB_SHA'], ['oidc_token', str]], ''),
 ('/repos/{owner}/{repo}/pages/deployments/{pages_deployment_id}', 'get', 'repos/get-pages-deployment', 'Get the status of a GitHub Pages deployment', 'rest/pages/pages#get-the-status-of-a-github-pages-deployment', [], [], ''),
 ('/repos/{owner}/{repo}/pages/deployments/{pages_deployment_id}/cancel', 'post', 'repos/cancel-pages-deployment', 'Cancel a GitHub Pages deployment', 'rest/pages/pages#cancel-a-github-pages-deployment', [], [], ''),
 ('/repos/{owner}/{repo}/pages/health', 'get', 'repos/get-pages-health-check', 'Get a DNS health check for GitHub Pages', 'rest/pages/pages#get-a-dns-health-check-for-github-pages', [], [], ''),
 ('/repos/{owner}/{repo}/private-vulnerability-reporting', 'get', 'repos/check-private-vulnerability-reporting', 'Check if private vulnerability reporting is enabled for a repository', 'rest/repos/repos#check-if-private-vulnerability-reporting-is-enabled-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/private-vulnerability-reporting', 'put', 'repos/enable-private-vulnerability-reporting', 'Enable private vulnerability reporting for a repository', 'rest/repos/repos#enable-private-vulnerability-reporting-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/private-vulnerability-reporting', 'delete', 'repos/disable-private-vulnerability-reporting', 'Disable private vulnerability reporting for a repository', 'rest/repos/repos#disable-private-vulnerability-reporting-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/projects', 'get', 'projects/list-for-repo', 'List repository projects', 'rest/projects/projects#list-repository-projects', ['state', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/projects', 'post', 'projects/create-for-repo', 'Create a repository project', 'rest/projects/projects#create-a-repository-project', [], [['name', str], ['body', str]], ''),
 ('/repos/{owner}/{repo}/properties/values', 'get', 'repos/get-custom-properties-values', 'Get all custom property values for a repository', 'rest/repos/custom-properties#get-all-custom-property-values-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/properties/values', 'patch', 'repos/create-or-update-custom-properties-values', 'Create or update custom property values for a repository', 'rest/repos/custom-properties#create-or-update-custom-property-values-for-a-repository', [], [['properties', list]], ''),
 ('/repos/{owner}/{repo}/pulls', 'get', 'pulls/list', 'List pull requests', 'rest/pulls/pulls#list-pull-requests', ['state', 'head', 'base', 'sort', 'direction', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls', 'post', 'pulls/create', 'Create a pull request', 'rest/pulls/pulls#create-a-pull-request', [], [['title', str], ['head', str], ['head_repo', str], ['base', str], ['body', str], ['maintainer_can_modify', bool], ['draft', bool], ['issue', int]], ''),
 ('/repos/{owner}/{repo}/pulls/comments', 'get', 'pulls/list-review-comments-for-repo', 'List review comments in a repository', 'rest/pulls/comments#list-review-comments-in-a-repository', ['sort', 'direction', 'since', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls/comments/{comment_id}', 'get', 'pulls/get-review-comment', 'Get a review comment for a pull request', 'rest/pulls/comments#get-a-review-comment-for-a-pull-request', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/comments/{comment_id}', 'patch', 'pulls/update-review-comment', 'Update a review comment for a pull request', 'rest/pulls/comments#update-a-review-comment-for-a-pull-request', [], [['body', str]], ''),
 ('/repos/{owner}/{repo}/pulls/comments/{comment_id}', 'delete', 'pulls/delete-review-comment', 'Delete a review comment for a pull request', 'rest/pulls/comments#delete-a-review-comment-for-a-pull-request', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions', 'get', 'reactions/list-for-pull-request-review-comment', 'List reactions for a pull request review comment', 'rest/reactions/reactions#list-reactions-for-a-pull-request-review-comment', ['content', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions', 'post', 'reactions/create-for-pull-request-review-comment', 'Create reaction for a pull request review comment', 'rest/reactions/reactions#create-reaction-for-a-pull-request-review-comment', [], [['content', str]], ''),
 ('/repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions/{reaction_id}', 'delete', 'reactions/delete-for-pull-request-comment', 'Delete a pull request comment reaction', 'rest/reactions/reactions#delete-a-pull-request-comment-reaction', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}', 'get', 'pulls/get', 'Get a pull request', 'rest/pulls/pulls#get-a-pull-request', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}', 'patch', 'pulls/update', 'Update a pull request', 'rest/pulls/pulls#update-a-pull-request', [], [['title', str], ['body', str], ['state', str], ['base', str], ['maintainer_can_modify', bool]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/codespaces',
  'post',
  'codespaces/create-with-pr-for-authenticated-user',
  'Create a codespace from a pull request',
  'rest/codespaces/codespaces#create-a-codespace-from-a-pull-request',
  [],
  [['location', str], ['geo', str], ['client_ip', str], ['machine', str], ['devcontainer_path', str], ['multi_repo_permissions_opt_out', bool], ['working_directory', str], ['idle_timeout_minutes', int], ['display_name', str], ['retention_period_minutes', int]],
  ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/comments', 'get', 'pulls/list-review-comments', 'List review comments on a pull request', 'rest/pulls/comments#list-review-comments-on-a-pull-request', ['sort', 'direction', 'since', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/comments',
  'post',
  'pulls/create-review-comment',
  'Create a review comment for a pull request',
  'rest/pulls/comments#create-a-review-comment-for-a-pull-request',
  [],
  [['body', str], ['commit_id', str], ['path', str], ['position', int], ['side', str], ['line', int], ['start_line', int], ['start_side', str], ['in_reply_to', int], ['subject_type', str]],
  ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/comments/{comment_id}/replies', 'post', 'pulls/create-reply-for-review-comment', 'Create a reply for a review comment', 'rest/pulls/comments#create-a-reply-for-a-review-comment', [], [['body', str]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/commits', 'get', 'pulls/list-commits', 'List commits on a pull request', 'rest/pulls/pulls#list-commits-on-a-pull-request', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/files', 'get', 'pulls/list-files', 'List pull requests files', 'rest/pulls/pulls#list-pull-requests-files', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/merge', 'get', 'pulls/check-if-merged', 'Check if a pull request has been merged', 'rest/pulls/pulls#check-if-a-pull-request-has-been-merged', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/merge', 'put', 'pulls/merge', 'Merge a pull request', 'rest/pulls/pulls#merge-a-pull-request', [], [['commit_title', str], ['commit_message', str], ['sha', str], ['merge_method', str]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers', 'get', 'pulls/list-requested-reviewers', 'Get all requested reviewers for a pull request', 'rest/pulls/review-requests#get-all-requested-reviewers-for-a-pull-request', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers', 'post', 'pulls/request-reviewers', 'Request reviewers for a pull request', 'rest/pulls/review-requests#request-reviewers-for-a-pull-request', [], [['reviewers', list], ['team_reviewers', list]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers', 'delete', 'pulls/remove-requested-reviewers', 'Remove requested reviewers from a pull request', 'rest/pulls/review-requests#remove-requested-reviewers-from-a-pull-request', [], [['reviewers', list], ['team_reviewers', list]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews', 'get', 'pulls/list-reviews', 'List reviews for a pull request', 'rest/pulls/reviews#list-reviews-for-a-pull-request', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews', 'post', 'pulls/create-review', 'Create a review for a pull request', 'rest/pulls/reviews#create-a-review-for-a-pull-request', [], [['commit_id', str], ['body', str], ['event', str], ['comments', list]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}', 'get', 'pulls/get-review', 'Get a review for a pull request', 'rest/pulls/reviews#get-a-review-for-a-pull-request', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}', 'put', 'pulls/update-review', 'Update a review for a pull request', 'rest/pulls/reviews#update-a-review-for-a-pull-request', [], [['body', str]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}', 'delete', 'pulls/delete-pending-review', 'Delete a pending review for a pull request', 'rest/pulls/reviews#delete-a-pending-review-for-a-pull-request', [], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/comments', 'get', 'pulls/list-comments-for-review', 'List comments for a pull request review', 'rest/pulls/reviews#list-comments-for-a-pull-request-review', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/dismissals', 'put', 'pulls/dismiss-review', 'Dismiss a review for a pull request', 'rest/pulls/reviews#dismiss-a-review-for-a-pull-request', [], [['message', str], ['event', str]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/events', 'post', 'pulls/submit-review', 'Submit a review for a pull request', 'rest/pulls/reviews#submit-a-review-for-a-pull-request', [], [['body', str], ['event', str]], ''),
 ('/repos/{owner}/{repo}/pulls/{pull_number}/update-branch', 'put', 'pulls/update-branch', 'Update a pull request branch', 'rest/pulls/pulls#update-a-pull-request-branch', [], [['expected_head_sha', str]], ''),
 ('/repos/{owner}/{repo}/readme', 'get', 'repos/get-readme', 'Get a repository README', 'rest/repos/contents#get-a-repository-readme', ['ref'], [], ''),
 ('/repos/{owner}/{repo}/readme/{dir}', 'get', 'repos/get-readme-in-directory', 'Get a repository README for a directory', 'rest/repos/contents#get-a-repository-readme-for-a-directory', ['ref'], [], ''),
 ('/repos/{owner}/{repo}/releases', 'get', 'repos/list-releases', 'List releases', 'rest/releases/releases#list-releases', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/releases',
  'post',
  'repos/create-release',
  'Create a release',
  'rest/releases/releases#create-a-release',
  [],
  [['tag_name', str], ['target_commitish', str], ['name', str], ['body', str], ['draft', bool, False], ['prerelease', bool, False], ['discussion_category_name', str], ['generate_release_notes', bool, False], ['make_latest', str, True]],
  ''),
 ('/repos/{owner}/{repo}/releases/assets/{asset_id}', 'get', 'repos/get-release-asset', 'Get a release asset', 'rest/releases/assets#get-a-release-asset', [], [], ''),
 ('/repos/{owner}/{repo}/releases/assets/{asset_id}', 'patch', 'repos/update-release-asset', 'Update a release asset', 'rest/releases/assets#update-a-release-asset', [], [['name', str], ['label', str], ['state', str]], ''),
 ('/repos/{owner}/{repo}/releases/assets/{asset_id}', 'delete', 'repos/delete-release-asset', 'Delete a release asset', 'rest/releases/assets#delete-a-release-asset', [], [], ''),
 ('/repos/{owner}/{repo}/releases/generate-notes', 'post', 'repos/generate-release-notes', 'Generate release notes content for a release', 'rest/releases/releases#generate-release-notes-content-for-a-release', [], [['tag_name', str], ['target_commitish', str], ['previous_tag_name', str], ['configuration_file_path', str]], ''),
 ('/repos/{owner}/{repo}/releases/latest', 'get', 'repos/get-latest-release', 'Get the latest release', 'rest/releases/releases#get-the-latest-release', [], [], ''),
 ('/repos/{owner}/{repo}/releases/tags/{tag}', 'get', 'repos/get-release-by-tag', 'Get a release by tag name', 'rest/releases/releases#get-a-release-by-tag-name', [], [], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}', 'get', 'repos/get-release', 'Get a release', 'rest/releases/releases#get-a-release', [], [], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}', 'patch', 'repos/update-release', 'Update a release', 'rest/releases/releases#update-a-release', [], [['tag_name', str], ['target_commitish', str], ['name', str], ['body', str], ['draft', bool], ['prerelease', bool], ['make_latest', str, True], ['discussion_category_name', str]], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}', 'delete', 'repos/delete-release', 'Delete a release', 'rest/releases/releases#delete-a-release', [], [], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}/assets', 'get', 'repos/list-release-assets', 'List release assets', 'rest/releases/assets#list-release-assets', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}/assets', 'post', 'repos/upload-release-asset', 'Upload a release asset', 'rest/releases/assets#upload-a-release-asset', ['name', 'label'], [], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}/reactions', 'get', 'reactions/list-for-release', 'List reactions for a release', 'rest/reactions/reactions#list-reactions-for-a-release', ['content', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}/reactions', 'post', 'reactions/create-for-release', 'Create reaction for a release', 'rest/reactions/reactions#create-reaction-for-a-release', [], [['content', str]], ''),
 ('/repos/{owner}/{repo}/releases/{release_id}/reactions/{reaction_id}', 'delete', 'reactions/delete-for-release', 'Delete a release reaction', 'rest/reactions/reactions#delete-a-release-reaction', [], [], ''),
 ('/repos/{owner}/{repo}/rules/branches/{branch}', 'get', 'repos/get-branch-rules', 'Get rules for a branch', 'rest/repos/rules#get-rules-for-a-branch', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/rulesets', 'get', 'repos/get-repo-rulesets', 'Get all repository rulesets', 'rest/repos/rules#get-all-repository-rulesets', ['per_page', 'page', 'includes_parents'], [], ''),
 ('/repos/{owner}/{repo}/rulesets', 'post', 'repos/create-repo-ruleset', 'Create a repository ruleset', 'rest/repos/rules#create-a-repository-ruleset', [], [['name', str], ['target', str], ['enforcement', str], ['bypass_actors', list], ['conditions', dict], ['rules', list]], ''),
 ('/repos/{owner}/{repo}/rulesets/rule-suites', 'get', 'repos/get-repo-rule-suites', 'List repository rule suites', 'rest/repos/rule-suites#list-repository-rule-suites', ['ref', 'time_period', 'actor_name', 'rule_suite_result', 'per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/rulesets/rule-suites/{rule_suite_id}', 'get', 'repos/get-repo-rule-suite', 'Get a repository rule suite', 'rest/repos/rule-suites#get-a-repository-rule-suite', [], [], ''),
 ('/repos/{owner}/{repo}/rulesets/{ruleset_id}', 'get', 'repos/get-repo-ruleset', 'Get a repository ruleset', 'rest/repos/rules#get-a-repository-ruleset', ['includes_parents'], [], ''),
 ('/repos/{owner}/{repo}/rulesets/{ruleset_id}', 'put', 'repos/update-repo-ruleset', 'Update a repository ruleset', 'rest/repos/rules#update-a-repository-ruleset', [], [['name', str], ['target', str], ['enforcement', str], ['bypass_actors', list], ['conditions', dict], ['rules', list]], ''),
 ('/repos/{owner}/{repo}/rulesets/{ruleset_id}', 'delete', 'repos/delete-repo-ruleset', 'Delete a repository ruleset', 'rest/repos/rules#delete-a-repository-ruleset', [], [], ''),
 ('/repos/{owner}/{repo}/secret-scanning/alerts', 'get', 'secret-scanning/list-alerts-for-repo', 'List secret scanning alerts for a repository', 'rest/secret-scanning/secret-scanning#list-secret-scanning-alerts-for-a-repository', ['state', 'secret_type', 'resolution', 'sort', 'direction', 'page', 'per_page', 'before', 'after', 'validity'], [], ''),
 ('/repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}', 'get', 'secret-scanning/get-alert', 'Get a secret scanning alert', 'rest/secret-scanning/secret-scanning#get-a-secret-scanning-alert', [], [], ''),
 ('/repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}', 'patch', 'secret-scanning/update-alert', 'Update a secret scanning alert', 'rest/secret-scanning/secret-scanning#update-a-secret-scanning-alert', [], [['state', str], ['resolution', str], ['resolution_comment', str]], ''),
 ('/repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}/locations', 'get', 'secret-scanning/list-locations-for-alert', 'List locations for a secret scanning alert', 'rest/secret-scanning/secret-scanning#list-locations-for-a-secret-scanning-alert', ['page', 'per_page'], [], ''),
 ('/repos/{owner}/{repo}/security-advisories', 'get', 'security-advisories/list-repository-advisories', 'List repository security advisories', 'rest/security-advisories/repository-advisories#list-repository-security-advisories', ['direction', 'sort', 'before', 'after', 'per_page', 'state'], [], ''),
 ('/repos/{owner}/{repo}/security-advisories',
  'post',
  'security-advisories/create-repository-advisory',
  'Create a repository security advisory',
  'rest/security-advisories/repository-advisories#create-a-repository-security-advisory',
  [],
  [['summary', str], ['description', str], ['cve_id', str], ['vulnerabilities', list], ['cwe_ids', list], ['credits', list], ['severity', str], ['cvss_vector_string', str], ['start_private_fork', bool, False]],
  ''),
 ('/repos/{owner}/{repo}/security-advisories/reports',
  'post',
  'security-advisories/create-private-vulnerability-report',
  'Privately report a security vulnerability',
  'rest/security-advisories/repository-advisories#privately-report-a-security-vulnerability',
  [],
  [['summary', str], ['description', str], ['vulnerabilities', list], ['cwe_ids', list], ['severity', str], ['cvss_vector_string', str], ['start_private_fork', bool, False]],
  ''),
 ('/repos/{owner}/{repo}/security-advisories/{ghsa_id}', 'get', 'security-advisories/get-repository-advisory', 'Get a repository security advisory', 'rest/security-advisories/repository-advisories#get-a-repository-security-advisory', [], [], ''),
 ('/repos/{owner}/{repo}/security-advisories/{ghsa_id}',
  'patch',
  'security-advisories/update-repository-advisory',
  'Update a repository security advisory',
  'rest/security-advisories/repository-advisories#update-a-repository-security-advisory',
  [],
  [['summary', str], ['description', str], ['cve_id', str], ['vulnerabilities', list], ['cwe_ids', list], ['credits', list], ['severity', str], ['cvss_vector_string', str], ['state', str], ['collaborating_users', list], ['collaborating_teams', list]],
  ''),
 ('/repos/{owner}/{repo}/security-advisories/{ghsa_id}/cve', 'post', 'security-advisories/create-repository-advisory-cve-request', 'Request a CVE for a repository security advisory', 'rest/security-advisories/repository-advisories#request-a-cve-for-a-repository-security-advisory', [], [], ''),
 ('/repos/{owner}/{repo}/security-advisories/{ghsa_id}/forks', 'post', 'security-advisories/create-fork', 'Create a temporary private fork', 'rest/security-advisories/repository-advisories#create-a-temporary-private-fork', [], [], ''),
 ('/repos/{owner}/{repo}/stargazers', 'get', 'activity/list-stargazers-for-repo', 'List stargazers', 'rest/activity/starring#list-stargazers', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/stats/code_frequency', 'get', 'repos/get-code-frequency-stats', 'Get the weekly commit activity', 'rest/metrics/statistics#get-the-weekly-commit-activity', [], [], ''),
 ('/repos/{owner}/{repo}/stats/commit_activity', 'get', 'repos/get-commit-activity-stats', 'Get the last year of commit activity', 'rest/metrics/statistics#get-the-last-year-of-commit-activity', [], [], ''),
 ('/repos/{owner}/{repo}/stats/contributors', 'get', 'repos/get-contributors-stats', 'Get all contributor commit activity', 'rest/metrics/statistics#get-all-contributor-commit-activity', [], [], ''),
 ('/repos/{owner}/{repo}/stats/participation', 'get', 'repos/get-participation-stats', 'Get the weekly commit count', 'rest/metrics/statistics#get-the-weekly-commit-count', [], [], ''),
 ('/repos/{owner}/{repo}/stats/punch_card', 'get', 'repos/get-punch-card-stats', 'Get the hourly commit count for each day', 'rest/metrics/statistics#get-the-hourly-commit-count-for-each-day', [], [], ''),
 ('/repos/{owner}/{repo}/statuses/{sha}', 'post', 'repos/create-commit-status', 'Create a commit status', 'rest/commits/statuses#create-a-commit-status', [], [['state', str], ['target_url', str], ['description', str], ['context', str, 'default']], ''),
 ('/repos/{owner}/{repo}/subscribers', 'get', 'activity/list-watchers-for-repo', 'List watchers', 'rest/activity/watching#list-watchers', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/subscription', 'get', 'activity/get-repo-subscription', 'Get a repository subscription', 'rest/activity/watching#get-a-repository-subscription', [], [], ''),
 ('/repos/{owner}/{repo}/subscription', 'put', 'activity/set-repo-subscription', 'Set a repository subscription', 'rest/activity/watching#set-a-repository-subscription', [], [['subscribed', bool], ['ignored', bool]], ''),
 ('/repos/{owner}/{repo}/subscription', 'delete', 'activity/delete-repo-subscription', 'Delete a repository subscription', 'rest/activity/watching#delete-a-repository-subscription', [], [], ''),
 ('/repos/{owner}/{repo}/tags', 'get', 'repos/list-tags', 'List repository tags', 'rest/repos/repos#list-repository-tags', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/tags/protection', 'get', 'repos/list-tag-protection', 'List tag protection states for a repository', 'rest/repos/tags#list-tag-protection-states-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/tags/protection', 'post', 'repos/create-tag-protection', 'Create a tag protection state for a repository', 'rest/repos/tags#create-a-tag-protection-state-for-a-repository', [], [['pattern', str]], ''),
 ('/repos/{owner}/{repo}/tags/protection/{tag_protection_id}', 'delete', 'repos/delete-tag-protection', 'Delete a tag protection state for a repository', 'rest/repos/tags#delete-a-tag-protection-state-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/tarball/{ref}', 'get', 'repos/download-tarball-archive', 'Download a repository archive (tar)', 'rest/repos/contents#download-a-repository-archive-tar', [], [], ''),
 ('/repos/{owner}/{repo}/teams', 'get', 'repos/list-teams', 'List repository teams', 'rest/repos/repos#list-repository-teams', ['per_page', 'page'], [], ''),
 ('/repos/{owner}/{repo}/topics', 'get', 'repos/get-all-topics', 'Get all repository topics', 'rest/repos/repos#get-all-repository-topics', ['page', 'per_page'], [], ''),
 ('/repos/{owner}/{repo}/topics', 'put', 'repos/replace-all-topics', 'Replace all repository topics', 'rest/repos/repos#replace-all-repository-topics', [], [['names', list]], ''),
 ('/repos/{owner}/{repo}/traffic/clones', 'get', 'repos/get-clones', 'Get repository clones', 'rest/metrics/traffic#get-repository-clones', ['per'], [], ''),
 ('/repos/{owner}/{repo}/traffic/popular/paths', 'get', 'repos/get-top-paths', 'Get top referral paths', 'rest/metrics/traffic#get-top-referral-paths', [], [], ''),
 ('/repos/{owner}/{repo}/traffic/popular/referrers', 'get', 'repos/get-top-referrers', 'Get top referral sources', 'rest/metrics/traffic#get-top-referral-sources', [], [], ''),
 ('/repos/{owner}/{repo}/traffic/views', 'get', 'repos/get-views', 'Get page views', 'rest/metrics/traffic#get-page-views', ['per'], [], ''),
 ('/repos/{owner}/{repo}/transfer', 'post', 'repos/transfer', 'Transfer a repository', 'rest/repos/repos#transfer-a-repository', [], [['new_owner', str], ['new_name', str], ['team_ids', list]], ''),
 ('/repos/{owner}/{repo}/vulnerability-alerts', 'get', 'repos/check-vulnerability-alerts', 'Check if vulnerability alerts are enabled for a repository', 'rest/repos/repos#check-if-vulnerability-alerts-are-enabled-for-a-repository', [], [], ''),
 ('/repos/{owner}/{repo}/vulnerability-alerts', 'put', 'repos/enable-vulnerability-alerts', 'Enable vulnerability alerts', 'rest/repos/repos#enable-vulnerability-alerts', [], [], ''),
 ('/repos/{owner}/{repo}/vulnerability-alerts', 'delete', 'repos/disable-vulnerability-alerts', 'Disable vulnerability alerts', 'rest/repos/repos#disable-vulnerability-alerts', [], [], ''),
 ('/repos/{owner}/{repo}/zipball/{ref}', 'get', 'repos/download-zipball-archive', 'Download a repository archive (zip)', 'rest/repos/contents#download-a-repository-archive-zip', [], [], ''),
 ('/repos/{template_owner}/{template_repo}/generate', 'post', 'repos/create-using-template', 'Create a repository using a template', 'rest/repos/repos#create-a-repository-using-a-template', [], [['owner', str], ['name', str], ['description', str], ['include_all_branches', bool, False], ['private', bool, False]], ''),
 ('/repositories', 'get', 'repos/list-public', 'List public repositories', 'rest/repos/repos#list-public-repositories', ['since'], [], ''),
 ('/search/code', 'get', 'search/code', 'Search code', 'rest/search/search#search-code', ['q', 'sort', 'order', 'per_page', 'page'], [], ''),
 ('/search/commits', 'get', 'search/commits', 'Search commits', 'rest/search/search#search-commits', ['q', 'sort', 'order', 'per_page', 'page'], [], ''),
 ('/search/issues', 'get', 'search/issues-and-pull-requests', 'Search issues and pull requests', 'rest/search/search#search-issues-and-pull-requests', ['q', 'sort', 'order', 'per_page', 'page'], [], ''),
 ('/search/labels', 'get', 'search/labels', 'Search labels', 'rest/search/search#search-labels', ['repository_id', 'q', 'sort', 'order', 'per_page', 'page'], [], ''),
 ('/search/repositories', 'get', 'search/repos', 'Search repositories', 'rest/search/search#search-repositories', ['q', 'sort', 'order', 'per_page', 'page'], [], ''),
 ('/search/topics', 'get', 'search/topics', 'Search topics', 'rest/search/search#search-topics', ['q', 'per_page', 'page'], [], ''),
 ('/search/users', 'get', 'search/users', 'Search users', 'rest/search/search#search-users', ['q', 'sort', 'order', 'per_page', 'page'], [], ''),
 ('/teams/{team_id}', 'get', 'teams/get-legacy', 'Get a team (Legacy)', 'rest/teams/teams#get-a-team-legacy', [], [], ''),
 ('/teams/{team_id}', 'patch', 'teams/update-legacy', 'Update a team (Legacy)', 'rest/teams/teams#update-a-team-legacy', [], [['name', str], ['description', str], ['privacy', str], ['notification_setting', str], ['permission', str, 'pull'], ['parent_team_id', int]], ''),
 ('/teams/{team_id}', 'delete', 'teams/delete-legacy', 'Delete a team (Legacy)', 'rest/teams/teams#delete-a-team-legacy', [], [], ''),
 ('/teams/{team_id}/discussions', 'get', 'teams/list-discussions-legacy', 'List discussions (Legacy)', 'rest/teams/discussions#list-discussions-legacy', ['direction', 'per_page', 'page'], [], ''),
 ('/teams/{team_id}/discussions', 'post', 'teams/create-discussion-legacy', 'Create a discussion (Legacy)', 'rest/teams/discussions#create-a-discussion-legacy', [], [['title', str], ['body', str], ['private', bool, False]], ''),
 ('/teams/{team_id}/discussions/{discussion_number}', 'get', 'teams/get-discussion-legacy', 'Get a discussion (Legacy)', 'rest/teams/discussions#get-a-discussion-legacy', [], [], ''),
 ('/teams/{team_id}/discussions/{discussion_number}', 'patch', 'teams/update-discussion-legacy', 'Update a discussion (Legacy)', 'rest/teams/discussions#update-a-discussion-legacy', [], [['title', str], ['body', str]], ''),
 ('/teams/{team_id}/discussions/{discussion_number}', 'delete', 'teams/delete-discussion-legacy', 'Delete a discussion (Legacy)', 'rest/teams/discussions#delete-a-discussion-legacy', [], [], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/comments', 'get', 'teams/list-discussion-comments-legacy', 'List discussion comments (Legacy)', 'rest/teams/discussion-comments#list-discussion-comments-legacy', ['direction', 'per_page', 'page'], [], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/comments', 'post', 'teams/create-discussion-comment-legacy', 'Create a discussion comment (Legacy)', 'rest/teams/discussion-comments#create-a-discussion-comment-legacy', [], [['body', str]], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}', 'get', 'teams/get-discussion-comment-legacy', 'Get a discussion comment (Legacy)', 'rest/teams/discussion-comments#get-a-discussion-comment-legacy', [], [], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}', 'patch', 'teams/update-discussion-comment-legacy', 'Update a discussion comment (Legacy)', 'rest/teams/discussion-comments#update-a-discussion-comment-legacy', [], [['body', str]], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}', 'delete', 'teams/delete-discussion-comment-legacy', 'Delete a discussion comment (Legacy)', 'rest/teams/discussion-comments#delete-a-discussion-comment-legacy', [], [], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}/reactions', 'get', 'reactions/list-for-team-discussion-comment-legacy', 'List reactions for a team discussion comment (Legacy)', 'rest/reactions/reactions#list-reactions-for-a-team-discussion-comment-legacy', ['content', 'per_page', 'page'], [], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}/reactions', 'post', 'reactions/create-for-team-discussion-comment-legacy', 'Create reaction for a team discussion comment (Legacy)', 'rest/reactions/reactions#create-reaction-for-a-team-discussion-comment-legacy', [], [['content', str]], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/reactions', 'get', 'reactions/list-for-team-discussion-legacy', 'List reactions for a team discussion (Legacy)', 'rest/reactions/reactions#list-reactions-for-a-team-discussion-legacy', ['content', 'per_page', 'page'], [], ''),
 ('/teams/{team_id}/discussions/{discussion_number}/reactions', 'post', 'reactions/create-for-team-discussion-legacy', 'Create reaction for a team discussion (Legacy)', 'rest/reactions/reactions#create-reaction-for-a-team-discussion-legacy', [], [['content', str]], ''),
 ('/teams/{team_id}/invitations', 'get', 'teams/list-pending-invitations-legacy', 'List pending team invitations (Legacy)', 'rest/teams/members#list-pending-team-invitations-legacy', ['per_page', 'page'], [], ''),
 ('/teams/{team_id}/members', 'get', 'teams/list-members-legacy', 'List team members (Legacy)', 'rest/teams/members#list-team-members-legacy', ['role', 'per_page', 'page'], [], ''),
 ('/teams/{team_id}/members/{username}', 'get', 'teams/get-member-legacy', 'Get team member (Legacy)', 'rest/teams/members#get-team-member-legacy', [], [], ''),
 ('/teams/{team_id}/members/{username}', 'put', 'teams/add-member-legacy', 'Add team member (Legacy)', 'rest/teams/members#add-team-member-legacy', [], [], ''),
 ('/teams/{team_id}/members/{username}', 'delete', 'teams/remove-member-legacy', 'Remove team member (Legacy)', 'rest/teams/members#remove-team-member-legacy', [], [], ''),
 ('/teams/{team_id}/memberships/{username}', 'get', 'teams/get-membership-for-user-legacy', 'Get team membership for a user (Legacy)', 'rest/teams/members#get-team-membership-for-a-user-legacy', [], [], ''),
 ('/teams/{team_id}/memberships/{username}', 'put', 'teams/add-or-update-membership-for-user-legacy', 'Add or update team membership for a user (Legacy)', 'rest/teams/members#add-or-update-team-membership-for-a-user-legacy', [], [['role', str, 'member']], ''),
 ('/teams/{team_id}/memberships/{username}', 'delete', 'teams/remove-membership-for-user-legacy', 'Remove team membership for a user (Legacy)', 'rest/teams/members#remove-team-membership-for-a-user-legacy', [], [], ''),
 ('/teams/{team_id}/projects', 'get', 'teams/list-projects-legacy', 'List team projects (Legacy)', 'rest/teams/teams#list-team-projects-legacy', ['per_page', 'page'], [], ''),
 ('/teams/{team_id}/projects/{project_id}', 'get', 'teams/check-permissions-for-project-legacy', 'Check team permissions for a project (Legacy)', 'rest/teams/teams#check-team-permissions-for-a-project-legacy', [], [], ''),
 ('/teams/{team_id}/projects/{project_id}', 'put', 'teams/add-or-update-project-permissions-legacy', 'Add or update team project permissions (Legacy)', 'rest/teams/teams#add-or-update-team-project-permissions-legacy', [], [['permission', str]], ''),
 ('/teams/{team_id}/projects/{project_id}', 'delete', 'teams/remove-project-legacy', 'Remove a project from a team (Legacy)', 'rest/teams/teams#remove-a-project-from-a-team-legacy', [], [], ''),
 ('/teams/{team_id}/repos', 'get', 'teams/list-repos-legacy', 'List team repositories (Legacy)', 'rest/teams/teams#list-team-repositories-legacy', ['per_page', 'page'], [], ''),
 ('/teams/{team_id}/repos/{owner}/{repo}', 'get', 'teams/check-permissions-for-repo-legacy', 'Check team permissions for a repository (Legacy)', 'rest/teams/teams#check-team-permissions-for-a-repository-legacy', [], [], ''),
 ('/teams/{team_id}/repos/{owner}/{repo}', 'put', 'teams/add-or-update-repo-permissions-legacy', 'Add or update team repository permissions (Legacy)', 'rest/teams/teams#add-or-update-team-repository-permissions-legacy', [], [['permission', str]], ''),
 ('/teams/{team_id}/repos/{owner}/{repo}', 'delete', 'teams/remove-repo-legacy', 'Remove a repository from a team (Legacy)', 'rest/teams/teams#remove-a-repository-from-a-team-legacy', [], [], ''),
 ('/teams/{team_id}/teams', 'get', 'teams/list-child-legacy', 'List child teams (Legacy)', 'rest/teams/teams#list-child-teams-legacy', ['per_page', 'page'], [], ''),
 ('/user', 'get', 'users/get-authenticated', 'Get the authenticated user', 'rest/users/users#get-the-authenticated-user', [], [], ''),
 ('/user', 'patch', 'users/update-authenticated', 'Update the authenticated user', 'rest/users/users#update-the-authenticated-user', [], [['name', str], ['email', str], ['blog', str], ['twitter_username', str], ['company', str], ['location', str], ['hireable', bool], ['bio', str]], ''),
 ('/user/blocks', 'get', 'users/list-blocked-by-authenticated-user', 'List users blocked by the authenticated user', 'rest/users/blocking#list-users-blocked-by-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/blocks/{username}', 'get', 'users/check-blocked', 'Check if a user is blocked by the authenticated user', 'rest/users/blocking#check-if-a-user-is-blocked-by-the-authenticated-user', [], [], ''),
 ('/user/blocks/{username}', 'put', 'users/block', 'Block a user', 'rest/users/blocking#block-a-user', [], [], ''),
 ('/user/blocks/{username}', 'delete', 'users/unblock', 'Unblock a user', 'rest/users/blocking#unblock-a-user', [], [], ''),
 ('/user/codespaces', 'get', 'codespaces/list-for-authenticated-user', 'List codespaces for the authenticated user', 'rest/codespaces/codespaces#list-codespaces-for-the-authenticated-user', ['per_page', 'page', 'repository_id'], [], ''),
 ('/user/codespaces',
  'post',
  'codespaces/create-for-authenticated-user',
  'Create a codespace for the authenticated user',
  'rest/codespaces/codespaces#create-a-codespace-for-the-authenticated-user',
  [],
  [['repository_id', int], ['ref', str], ['location', str], ['geo', str], ['client_ip', str], ['machine', str], ['devcontainer_path', str], ['multi_repo_permissions_opt_out', bool], ['working_directory', str], ['idle_timeout_minutes', int], ['display_name', str], ['retention_period_minutes', int]],
  ''),
 ('/user/codespaces/secrets', 'get', 'codespaces/list-secrets-for-authenticated-user', 'List secrets for the authenticated user', 'rest/codespaces/secrets#list-secrets-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/codespaces/secrets/public-key', 'get', 'codespaces/get-public-key-for-authenticated-user', 'Get public key for the authenticated user', 'rest/codespaces/secrets#get-public-key-for-the-authenticated-user', [], [], ''),
 ('/user/codespaces/secrets/{secret_name}', 'get', 'codespaces/get-secret-for-authenticated-user', 'Get a secret for the authenticated user', 'rest/codespaces/secrets#get-a-secret-for-the-authenticated-user', [], [], ''),
 ('/user/codespaces/secrets/{secret_name}', 'put', 'codespaces/create-or-update-secret-for-authenticated-user', 'Create or update a secret for the authenticated user', 'rest/codespaces/secrets#create-or-update-a-secret-for-the-authenticated-user', [], [['encrypted_value', str], ['key_id', str], ['selected_repository_ids', list]], ''),
 ('/user/codespaces/secrets/{secret_name}', 'delete', 'codespaces/delete-secret-for-authenticated-user', 'Delete a secret for the authenticated user', 'rest/codespaces/secrets#delete-a-secret-for-the-authenticated-user', [], [], ''),
 ('/user/codespaces/secrets/{secret_name}/repositories', 'get', 'codespaces/list-repositories-for-secret-for-authenticated-user', 'List selected repositories for a user secret', 'rest/codespaces/secrets#list-selected-repositories-for-a-user-secret', [], [], ''),
 ('/user/codespaces/secrets/{secret_name}/repositories', 'put', 'codespaces/set-repositories-for-secret-for-authenticated-user', 'Set selected repositories for a user secret', 'rest/codespaces/secrets#set-selected-repositories-for-a-user-secret', [], [['selected_repository_ids', list]], ''),
 ('/user/codespaces/secrets/{secret_name}/repositories/{repository_id}', 'put', 'codespaces/add-repository-for-secret-for-authenticated-user', 'Add a selected repository to a user secret', 'rest/codespaces/secrets#add-a-selected-repository-to-a-user-secret', [], [], ''),
 ('/user/codespaces/secrets/{secret_name}/repositories/{repository_id}', 'delete', 'codespaces/remove-repository-for-secret-for-authenticated-user', 'Remove a selected repository from a user secret', 'rest/codespaces/secrets#remove-a-selected-repository-from-a-user-secret', [], [], ''),
 ('/user/codespaces/{codespace_name}', 'get', 'codespaces/get-for-authenticated-user', 'Get a codespace for the authenticated user', 'rest/codespaces/codespaces#get-a-codespace-for-the-authenticated-user', [], [], ''),
 ('/user/codespaces/{codespace_name}', 'patch', 'codespaces/update-for-authenticated-user', 'Update a codespace for the authenticated user', 'rest/codespaces/codespaces#update-a-codespace-for-the-authenticated-user', [], [['machine', str], ['display_name', str], ['recent_folders', list]], ''),
 ('/user/codespaces/{codespace_name}', 'delete', 'codespaces/delete-for-authenticated-user', 'Delete a codespace for the authenticated user', 'rest/codespaces/codespaces#delete-a-codespace-for-the-authenticated-user', [], [], ''),
 ('/user/codespaces/{codespace_name}/exports', 'post', 'codespaces/export-for-authenticated-user', 'Export a codespace for the authenticated user', 'rest/codespaces/codespaces#export-a-codespace-for-the-authenticated-user', [], [], ''),
 ('/user/codespaces/{codespace_name}/exports/{export_id}', 'get', 'codespaces/get-export-details-for-authenticated-user', 'Get details about a codespace export', 'rest/codespaces/codespaces#get-details-about-a-codespace-export', [], [], ''),
 ('/user/codespaces/{codespace_name}/machines', 'get', 'codespaces/codespace-machines-for-authenticated-user', 'List machine types for a codespace', 'rest/codespaces/machines#list-machine-types-for-a-codespace', [], [], ''),
 ('/user/codespaces/{codespace_name}/publish', 'post', 'codespaces/publish-for-authenticated-user', 'Create a repository from an unpublished codespace', 'rest/codespaces/codespaces#create-a-repository-from-an-unpublished-codespace', [], [['name', str], ['private', bool, False]], ''),
 ('/user/codespaces/{codespace_name}/start', 'post', 'codespaces/start-for-authenticated-user', 'Start a codespace for the authenticated user', 'rest/codespaces/codespaces#start-a-codespace-for-the-authenticated-user', [], [], ''),
 ('/user/codespaces/{codespace_name}/stop', 'post', 'codespaces/stop-for-authenticated-user', 'Stop a codespace for the authenticated user', 'rest/codespaces/codespaces#stop-a-codespace-for-the-authenticated-user', [], [], ''),
 ('/user/docker/conflicts', 'get', 'packages/list-docker-migration-conflicting-packages-for-authenticated-user', 'Get list of conflicting packages during Docker migration for authenticated-user', 'rest/packages/packages#get-list-of-conflicting-packages-during-docker-migration-for-authenticated-user', [], [], ''),
 ('/user/email/visibility', 'patch', 'users/set-primary-email-visibility-for-authenticated-user', 'Set primary email visibility for the authenticated user', 'rest/users/emails#set-primary-email-visibility-for-the-authenticated-user', [], [['visibility', str]], ''),
 ('/user/emails', 'get', 'users/list-emails-for-authenticated-user', 'List email addresses for the authenticated user', 'rest/users/emails#list-email-addresses-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/emails', 'post', 'users/add-email-for-authenticated-user', 'Add an email address for the authenticated user', 'rest/users/emails#add-an-email-address-for-the-authenticated-user', [], [['emails', list]], ''),
 ('/user/emails', 'delete', 'users/delete-email-for-authenticated-user', 'Delete an email address for the authenticated user', 'rest/users/emails#delete-an-email-address-for-the-authenticated-user', [], [['emails', list]], ''),
 ('/user/followers', 'get', 'users/list-followers-for-authenticated-user', 'List followers of the authenticated user', 'rest/users/followers#list-followers-of-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/following', 'get', 'users/list-followed-by-authenticated-user', 'List the people the authenticated user follows', 'rest/users/followers#list-the-people-the-authenticated-user-follows', ['per_page', 'page'], [], ''),
 ('/user/following/{username}', 'get', 'users/check-person-is-followed-by-authenticated', 'Check if a person is followed by the authenticated user', 'rest/users/followers#check-if-a-person-is-followed-by-the-authenticated-user', [], [], ''),
 ('/user/following/{username}', 'put', 'users/follow', 'Follow a user', 'rest/users/followers#follow-a-user', [], [], ''),
 ('/user/following/{username}', 'delete', 'users/unfollow', 'Unfollow a user', 'rest/users/followers#unfollow-a-user', [], [], ''),
 ('/user/gpg_keys', 'get', 'users/list-gpg-keys-for-authenticated-user', 'List GPG keys for the authenticated user', 'rest/users/gpg-keys#list-gpg-keys-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/gpg_keys', 'post', 'users/create-gpg-key-for-authenticated-user', 'Create a GPG key for the authenticated user', 'rest/users/gpg-keys#create-a-gpg-key-for-the-authenticated-user', [], [['name', str], ['armored_public_key', str]], ''),
 ('/user/gpg_keys/{gpg_key_id}', 'get', 'users/get-gpg-key-for-authenticated-user', 'Get a GPG key for the authenticated user', 'rest/users/gpg-keys#get-a-gpg-key-for-the-authenticated-user', [], [], ''),
 ('/user/gpg_keys/{gpg_key_id}', 'delete', 'users/delete-gpg-key-for-authenticated-user', 'Delete a GPG key for the authenticated user', 'rest/users/gpg-keys#delete-a-gpg-key-for-the-authenticated-user', [], [], ''),
 ('/user/installations', 'get', 'apps/list-installations-for-authenticated-user', 'List app installations accessible to the user access token', 'rest/apps/installations#list-app-installations-accessible-to-the-user-access-token', ['per_page', 'page'], [], ''),
 ('/user/installations/{installation_id}/repositories', 'get', 'apps/list-installation-repos-for-authenticated-user', 'List repositories accessible to the user access token', 'rest/apps/installations#list-repositories-accessible-to-the-user-access-token', ['per_page', 'page'], [], ''),
 ('/user/installations/{installation_id}/repositories/{repository_id}', 'put', 'apps/add-repo-to-installation-for-authenticated-user', 'Add a repository to an app installation', 'rest/apps/installations#add-a-repository-to-an-app-installation', [], [], ''),
 ('/user/installations/{installation_id}/repositories/{repository_id}', 'delete', 'apps/remove-repo-from-installation-for-authenticated-user', 'Remove a repository from an app installation', 'rest/apps/installations#remove-a-repository-from-an-app-installation', [], [], ''),
 ('/user/interaction-limits', 'get', 'interactions/get-restrictions-for-authenticated-user', 'Get interaction restrictions for your public repositories', 'rest/interactions/user#get-interaction-restrictions-for-your-public-repositories', [], [], ''),
 ('/user/interaction-limits', 'put', 'interactions/set-restrictions-for-authenticated-user', 'Set interaction restrictions for your public repositories', 'rest/interactions/user#set-interaction-restrictions-for-your-public-repositories', [], [['limit', str], ['expiry', str]], ''),
 ('/user/interaction-limits', 'delete', 'interactions/remove-restrictions-for-authenticated-user', 'Remove interaction restrictions from your public repositories', 'rest/interactions/user#remove-interaction-restrictions-from-your-public-repositories', [], [], ''),
 ('/user/issues', 'get', 'issues/list-for-authenticated-user', 'List user account issues assigned to the authenticated user', 'rest/issues/issues#list-user-account-issues-assigned-to-the-authenticated-user', ['filter', 'state', 'labels', 'sort', 'direction', 'since', 'per_page', 'page'], [], ''),
 ('/user/keys', 'get', 'users/list-public-ssh-keys-for-authenticated-user', 'List public SSH keys for the authenticated user', 'rest/users/keys#list-public-ssh-keys-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/keys', 'post', 'users/create-public-ssh-key-for-authenticated-user', 'Create a public SSH key for the authenticated user', 'rest/users/keys#create-a-public-ssh-key-for-the-authenticated-user', [], [['title', str], ['key', str]], ''),
 ('/user/keys/{key_id}', 'get', 'users/get-public-ssh-key-for-authenticated-user', 'Get a public SSH key for the authenticated user', 'rest/users/keys#get-a-public-ssh-key-for-the-authenticated-user', [], [], ''),
 ('/user/keys/{key_id}', 'delete', 'users/delete-public-ssh-key-for-authenticated-user', 'Delete a public SSH key for the authenticated user', 'rest/users/keys#delete-a-public-ssh-key-for-the-authenticated-user', [], [], ''),
 ('/user/marketplace_purchases', 'get', 'apps/list-subscriptions-for-authenticated-user', 'List subscriptions for the authenticated user', 'rest/apps/marketplace#list-subscriptions-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/marketplace_purchases/stubbed', 'get', 'apps/list-subscriptions-for-authenticated-user-stubbed', 'List subscriptions for the authenticated user (stubbed)', 'rest/apps/marketplace#list-subscriptions-for-the-authenticated-user-stubbed', ['per_page', 'page'], [], ''),
 ('/user/memberships/orgs', 'get', 'orgs/list-memberships-for-authenticated-user', 'List organization memberships for the authenticated user', 'rest/orgs/members#list-organization-memberships-for-the-authenticated-user', ['state', 'per_page', 'page'], [], ''),
 ('/user/memberships/orgs/{org}', 'get', 'orgs/get-membership-for-authenticated-user', 'Get an organization membership for the authenticated user', 'rest/orgs/members#get-an-organization-membership-for-the-authenticated-user', [], [], ''),
 ('/user/memberships/orgs/{org}', 'patch', 'orgs/update-membership-for-authenticated-user', 'Update an organization membership for the authenticated user', 'rest/orgs/members#update-an-organization-membership-for-the-authenticated-user', [], [['state', str]], ''),
 ('/user/migrations', 'get', 'migrations/list-for-authenticated-user', 'List user migrations', 'rest/migrations/users#list-user-migrations', ['per_page', 'page'], [], ''),
 ('/user/migrations',
  'post',
  'migrations/start-for-authenticated-user',
  'Start a user migration',
  'rest/migrations/users#start-a-user-migration',
  [],
  [['lock_repositories', bool], ['exclude_metadata', bool], ['exclude_git_data', bool], ['exclude_attachments', bool], ['exclude_releases', bool], ['exclude_owner_projects', bool], ['org_metadata_only', bool, False], ['exclude', list], ['repositories', list]],
  ''),
 ('/user/migrations/{migration_id}', 'get', 'migrations/get-status-for-authenticated-user', 'Get a user migration status', 'rest/migrations/users#get-a-user-migration-status', ['exclude'], [], ''),
 ('/user/migrations/{migration_id}/archive', 'get', 'migrations/get-archive-for-authenticated-user', 'Download a user migration archive', 'rest/migrations/users#download-a-user-migration-archive', [], [], ''),
 ('/user/migrations/{migration_id}/archive', 'delete', 'migrations/delete-archive-for-authenticated-user', 'Delete a user migration archive', 'rest/migrations/users#delete-a-user-migration-archive', [], [], ''),
 ('/user/migrations/{migration_id}/repos/{repo_name}/lock', 'delete', 'migrations/unlock-repo-for-authenticated-user', 'Unlock a user repository', 'rest/migrations/users#unlock-a-user-repository', [], [], ''),
 ('/user/migrations/{migration_id}/repositories', 'get', 'migrations/list-repos-for-authenticated-user', 'List repositories for a user migration', 'rest/migrations/users#list-repositories-for-a-user-migration', ['per_page', 'page'], [], ''),
 ('/user/orgs', 'get', 'orgs/list-for-authenticated-user', 'List organizations for the authenticated user', 'rest/orgs/orgs#list-organizations-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/packages', 'get', 'packages/list-packages-for-authenticated-user', "List packages for the authenticated user's namespace", 'rest/packages/packages#list-packages-for-the-authenticated-users-namespace', ['package_type', 'visibility', 'page', 'per_page'], [], ''),
 ('/user/packages/{package_type}/{package_name}', 'get', 'packages/get-package-for-authenticated-user', 'Get a package for the authenticated user', 'rest/packages/packages#get-a-package-for-the-authenticated-user', [], [], ''),
 ('/user/packages/{package_type}/{package_name}', 'delete', 'packages/delete-package-for-authenticated-user', 'Delete a package for the authenticated user', 'rest/packages/packages#delete-a-package-for-the-authenticated-user', [], [], ''),
 ('/user/packages/{package_type}/{package_name}/restore', 'post', 'packages/restore-package-for-authenticated-user', 'Restore a package for the authenticated user', 'rest/packages/packages#restore-a-package-for-the-authenticated-user', ['token'], [], ''),
 ('/user/packages/{package_type}/{package_name}/versions', 'get', 'packages/get-all-package-versions-for-package-owned-by-authenticated-user', 'List package versions for a package owned by the authenticated user', 'rest/packages/packages#list-package-versions-for-a-package-owned-by-the-authenticated-user', ['page', 'per_page', 'state'], [], ''),
 ('/user/packages/{package_type}/{package_name}/versions/{package_version_id}', 'get', 'packages/get-package-version-for-authenticated-user', 'Get a package version for the authenticated user', 'rest/packages/packages#get-a-package-version-for-the-authenticated-user', [], [], ''),
 ('/user/packages/{package_type}/{package_name}/versions/{package_version_id}', 'delete', 'packages/delete-package-version-for-authenticated-user', 'Delete a package version for the authenticated user', 'rest/packages/packages#delete-a-package-version-for-the-authenticated-user', [], [], ''),
 ('/user/packages/{package_type}/{package_name}/versions/{package_version_id}/restore', 'post', 'packages/restore-package-version-for-authenticated-user', 'Restore a package version for the authenticated user', 'rest/packages/packages#restore-a-package-version-for-the-authenticated-user', [], [], ''),
 ('/user/projects', 'post', 'projects/create-for-authenticated-user', 'Create a user project', 'rest/projects/projects#create-a-user-project', [], [['name', str], ['body', str]], ''),
 ('/user/public_emails', 'get', 'users/list-public-emails-for-authenticated-user', 'List public email addresses for the authenticated user', 'rest/users/emails#list-public-email-addresses-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/repos', 'get', 'repos/list-for-authenticated-user', 'List repositories for the authenticated user', 'rest/repos/repos#list-repositories-for-the-authenticated-user', ['visibility', 'affiliation', 'type', 'sort', 'direction', 'per_page', 'page', 'since', 'before'], [], ''),
 ('/user/repos',
  'post',
  'repos/create-for-authenticated-user',
  'Create a repository for the authenticated user',
  'rest/repos/repos#create-a-repository-for-the-authenticated-user',
  [],
  [['name', str],
   ['description', str],
   ['homepage', str],
   ['private', bool, False],
   ['has_issues', bool, True],
   ['has_projects', bool, True],
   ['has_wiki', bool, True],
   ['has_discussions', bool, False],
   ['team_id', int],
   ['auto_init', bool, False],
   ['gitignore_template', str],
   ['license_template', str],
   ['allow_squash_merge', bool, True],
   ['allow_merge_commit', bool, True],
   ['allow_rebase_merge', bool, True],
   ['allow_auto_merge', bool, False],
   ['delete_branch_on_merge', bool, False],
   ['squash_merge_commit_title', str],
   ['squash_merge_commit_message', str],
   ['merge_commit_title', str],
   ['merge_commit_message', str],
   ['has_downloads', bool, True],
   ['is_template', bool, False]],
  ''),
 ('/user/repository_invitations', 'get', 'repos/list-invitations-for-authenticated-user', 'List repository invitations for the authenticated user', 'rest/collaborators/invitations#list-repository-invitations-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/repository_invitations/{invitation_id}', 'patch', 'repos/accept-invitation-for-authenticated-user', 'Accept a repository invitation', 'rest/collaborators/invitations#accept-a-repository-invitation', [], [], ''),
 ('/user/repository_invitations/{invitation_id}', 'delete', 'repos/decline-invitation-for-authenticated-user', 'Decline a repository invitation', 'rest/collaborators/invitations#decline-a-repository-invitation', [], [], ''),
 ('/user/social_accounts', 'get', 'users/list-social-accounts-for-authenticated-user', 'List social accounts for the authenticated user', 'rest/users/social-accounts#list-social-accounts-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/social_accounts', 'post', 'users/add-social-account-for-authenticated-user', 'Add social accounts for the authenticated user', 'rest/users/social-accounts#add-social-accounts-for-the-authenticated-user', [], [['account_urls', list]], ''),
 ('/user/social_accounts', 'delete', 'users/delete-social-account-for-authenticated-user', 'Delete social accounts for the authenticated user', 'rest/users/social-accounts#delete-social-accounts-for-the-authenticated-user', [], [['account_urls', list]], ''),
 ('/user/ssh_signing_keys', 'get', 'users/list-ssh-signing-keys-for-authenticated-user', 'List SSH signing keys for the authenticated user', 'rest/users/ssh-signing-keys#list-ssh-signing-keys-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/ssh_signing_keys', 'post', 'users/create-ssh-signing-key-for-authenticated-user', 'Create a SSH signing key for the authenticated user', 'rest/users/ssh-signing-keys#create-a-ssh-signing-key-for-the-authenticated-user', [], [['title', str], ['key', str]], ''),
 ('/user/ssh_signing_keys/{ssh_signing_key_id}', 'get', 'users/get-ssh-signing-key-for-authenticated-user', 'Get an SSH signing key for the authenticated user', 'rest/users/ssh-signing-keys#get-an-ssh-signing-key-for-the-authenticated-user', [], [], ''),
 ('/user/ssh_signing_keys/{ssh_signing_key_id}', 'delete', 'users/delete-ssh-signing-key-for-authenticated-user', 'Delete an SSH signing key for the authenticated user', 'rest/users/ssh-signing-keys#delete-an-ssh-signing-key-for-the-authenticated-user', [], [], ''),
 ('/user/starred', 'get', 'activity/list-repos-starred-by-authenticated-user', 'List repositories starred by the authenticated user', 'rest/activity/starring#list-repositories-starred-by-the-authenticated-user', ['sort', 'direction', 'per_page', 'page'], [], ''),
 ('/user/starred/{owner}/{repo}', 'get', 'activity/check-repo-is-starred-by-authenticated-user', 'Check if a repository is starred by the authenticated user', 'rest/activity/starring#check-if-a-repository-is-starred-by-the-authenticated-user', [], [], ''),
 ('/user/starred/{owner}/{repo}', 'put', 'activity/star-repo-for-authenticated-user', 'Star a repository for the authenticated user', 'rest/activity/starring#star-a-repository-for-the-authenticated-user', [], [], ''),
 ('/user/starred/{owner}/{repo}', 'delete', 'activity/unstar-repo-for-authenticated-user', 'Unstar a repository for the authenticated user', 'rest/activity/starring#unstar-a-repository-for-the-authenticated-user', [], [], ''),
 ('/user/subscriptions', 'get', 'activity/list-watched-repos-for-authenticated-user', 'List repositories watched by the authenticated user', 'rest/activity/watching#list-repositories-watched-by-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/user/teams', 'get', 'teams/list-for-authenticated-user', 'List teams for the authenticated user', 'rest/teams/teams#list-teams-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/users', 'get', 'users/list', 'List users', 'rest/users/users#list-users', ['since', 'per_page'], [], ''),
 ('/users/{username}', 'get', 'users/get-by-username', 'Get a user', 'rest/users/users#get-a-user', [], [], ''),
 ('/users/{username}/docker/conflicts', 'get', 'packages/list-docker-migration-conflicting-packages-for-user', 'Get list of conflicting packages during Docker migration for user', 'rest/packages/packages#get-list-of-conflicting-packages-during-docker-migration-for-user', [], [], ''),
 ('/users/{username}/events', 'get', 'activity/list-events-for-authenticated-user', 'List events for the authenticated user', 'rest/activity/events#list-events-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/events/orgs/{org}', 'get', 'activity/list-org-events-for-authenticated-user', 'List organization events for the authenticated user', 'rest/activity/events#list-organization-events-for-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/events/public', 'get', 'activity/list-public-events-for-user', 'List public events for a user', 'rest/activity/events#list-public-events-for-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/followers', 'get', 'users/list-followers-for-user', 'List followers of a user', 'rest/users/followers#list-followers-of-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/following', 'get', 'users/list-following-for-user', 'List the people a user follows', 'rest/users/followers#list-the-people-a-user-follows', ['per_page', 'page'], [], ''),
 ('/users/{username}/following/{target_user}', 'get', 'users/check-following-for-user', 'Check if a user follows another user', 'rest/users/followers#check-if-a-user-follows-another-user', [], [], ''),
 ('/users/{username}/gists', 'get', 'gists/list-for-user', 'List gists for a user', 'rest/gists/gists#list-gists-for-a-user', ['since', 'per_page', 'page'], [], ''),
 ('/users/{username}/gpg_keys', 'get', 'users/list-gpg-keys-for-user', 'List GPG keys for a user', 'rest/users/gpg-keys#list-gpg-keys-for-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/hovercard', 'get', 'users/get-context-for-user', 'Get contextual information for a user', 'rest/users/users#get-contextual-information-for-a-user', ['subject_type', 'subject_id'], [], ''),
 ('/users/{username}/installation', 'get', 'apps/get-user-installation', 'Get a user installation for the authenticated app', 'rest/apps/apps#get-a-user-installation-for-the-authenticated-app', [], [], ''),
 ('/users/{username}/keys', 'get', 'users/list-public-keys-for-user', 'List public keys for a user', 'rest/users/keys#list-public-keys-for-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/orgs', 'get', 'orgs/list-for-user', 'List organizations for a user', 'rest/orgs/orgs#list-organizations-for-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/packages', 'get', 'packages/list-packages-for-user', 'List packages for a user', 'rest/packages/packages#list-packages-for-a-user', ['package_type', 'visibility', 'page', 'per_page'], [], ''),
 ('/users/{username}/packages/{package_type}/{package_name}', 'get', 'packages/get-package-for-user', 'Get a package for a user', 'rest/packages/packages#get-a-package-for-a-user', [], [], ''),
 ('/users/{username}/packages/{package_type}/{package_name}', 'delete', 'packages/delete-package-for-user', 'Delete a package for a user', 'rest/packages/packages#delete-a-package-for-a-user', [], [], ''),
 ('/users/{username}/packages/{package_type}/{package_name}/restore', 'post', 'packages/restore-package-for-user', 'Restore a package for a user', 'rest/packages/packages#restore-a-package-for-a-user', ['token'], [], ''),
 ('/users/{username}/packages/{package_type}/{package_name}/versions', 'get', 'packages/get-all-package-versions-for-package-owned-by-user', 'List package versions for a package owned by a user', 'rest/packages/packages#list-package-versions-for-a-package-owned-by-a-user', [], [], ''),
 ('/users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}', 'get', 'packages/get-package-version-for-user', 'Get a package version for a user', 'rest/packages/packages#get-a-package-version-for-a-user', [], [], ''),
 ('/users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}', 'delete', 'packages/delete-package-version-for-user', 'Delete package version for a user', 'rest/packages/packages#delete-package-version-for-a-user', [], [], ''),
 ('/users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}/restore', 'post', 'packages/restore-package-version-for-user', 'Restore package version for a user', 'rest/packages/packages#restore-package-version-for-a-user', [], [], ''),
 ('/users/{username}/projects', 'get', 'projects/list-for-user', 'List user projects', 'rest/projects/projects#list-user-projects', ['state', 'per_page', 'page'], [], ''),
 ('/users/{username}/received_events', 'get', 'activity/list-received-events-for-user', 'List events received by the authenticated user', 'rest/activity/events#list-events-received-by-the-authenticated-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/received_events/public', 'get', 'activity/list-received-public-events-for-user', 'List public events received by a user', 'rest/activity/events#list-public-events-received-by-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/repos', 'get', 'repos/list-for-user', 'List repositories for a user', 'rest/repos/repos#list-repositories-for-a-user', ['type', 'sort', 'direction', 'per_page', 'page'], [], ''),
 ('/users/{username}/settings/billing/actions', 'get', 'billing/get-github-actions-billing-user', 'Get GitHub Actions billing for a user', 'rest/billing/billing#get-github-actions-billing-for-a-user', [], [], ''),
 ('/users/{username}/settings/billing/packages', 'get', 'billing/get-github-packages-billing-user', 'Get GitHub Packages billing for a user', 'rest/billing/billing#get-github-packages-billing-for-a-user', [], [], ''),
 ('/users/{username}/settings/billing/shared-storage', 'get', 'billing/get-shared-storage-billing-user', 'Get shared storage billing for a user', 'rest/billing/billing#get-shared-storage-billing-for-a-user', [], [], ''),
 ('/users/{username}/social_accounts', 'get', 'users/list-social-accounts-for-user', 'List social accounts for a user', 'rest/users/social-accounts#list-social-accounts-for-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/ssh_signing_keys', 'get', 'users/list-ssh-signing-keys-for-user', 'List SSH signing keys for a user', 'rest/users/ssh-signing-keys#list-ssh-signing-keys-for-a-user', ['per_page', 'page'], [], ''),
 ('/users/{username}/starred', 'get', 'activity/list-repos-starred-by-user', 'List repositories starred by a user', 'rest/activity/starring#list-repositories-starred-by-a-user', ['sort', 'direction', 'per_page', 'page'], [], ''),
 ('/users/{username}/subscriptions', 'get', 'activity/list-repos-watched-by-user', 'List repositories watched by a user', 'rest/activity/watching#list-repositories-watched-by-a-user', ['per_page', 'page'], [], ''),
 ('/versions', 'get', 'meta/get-all-versions', 'Get all API versions', 'rest/meta/meta#get-all-api-versions', [], [], ''),
 ('/zen', 'get', 'meta/get-zen', 'Get the Zen of GitHub', 'rest/meta/meta#get-the-zen-of-github', [], [], '')]